(*********************************************************************
 *
 *  :Program.		HilfsModul fr Mastermind
 *  :Author.		Hans Schafft
 *  :Address.		Landfriedstrae 1A - Hinterhaus
 *  :Address.		6900 Heidelberg
 *  :Phone.		06221 - 22416
 *  :Version.		1.0
 *  :Date.		1989
 *  :Copyright.		PD
 *  :Language.		Modula-II
 *  :Translator.	M2Amiga
 *
 *********************************************************************)

IMPLEMENTATION MODULE BildMalen;

FROM SYSTEM		IMPORT	ADR;
FROM Arts		IMPORT	TermProcedure,Assert,CurrentLevel;
FROM Intuition		IMPORT	WindowPtr,DrawImage;
FROM RechtsImg		IMPORT	RechtsImage;
FROM LinksImg		IMPORT	LinksImage;
FROM ObenImg		IMPORT	ObenImage;
FROM UntenImg		IMPORT	UntenImage;
FROM PlusMinusImg	IMPORT	PlusMinusImage;
FROM DiskFont		IMPORT	OpenDiskFont;
FROM Str		IMPORT	Copy,Length;
FROM Graphics		IMPORT	TextAttr,SetAPen,RectFill,FontFlagSet,
				TextFontPtr,FontStyleSet,RastPortPtr,
				Text,TextLength,Move,RemFont,SetDrMd,
				jam1,jam2,SetBPen,
				AddFont,SetFont,FontFlags,CloseFont;


CONST	rahmenFarbe = 13;
	innenFarbe  = 2;
	aussenBreite = 110;
	aussenHoehe = 36;
        LinkeUndRechteRandBreite = 7;
        ObereUndUntereRandBreite = 5;
        KnopfXPos  = 525;

VAR	YEcke	: ARRAY [1..9] OF INTEGER;
	tfPtr	: TextFontPtr;
        knopfText : ARRAY [1..9],[1..6] OF CHAR;
        level	: INTEGER;

(***************************************************************)
PROCEDURE Bezeichnen(rpPtr : RastPortPtr);
VAR textAttribute : TextAttr;
    x,pix : INTEGER;
    o,k : CHAR;
BEGIN
  o := "O";
  k := "K";
  WITH textAttribute DO
    name  := ADR("poster.font");
    ySize := 16;
    style := FontStyleSet{};
    flags := FontFlagSet{diskFont};
  END;
  tfPtr := OpenDiskFont(ADR(textAttribute));
  Assert(tfPtr # NIL,ADR("Konnte Zeichensatz nicht finden !"));
  SetFont(rpPtr,tfPtr);
  SetAPen(rpPtr,1);
  SetBPen(rpPtr,2);
  SetDrMd(rpPtr,jam2);
  FOR x := 1 TO 9 DO
    pix := TextLength(rpPtr, ADR(knopfText[x]), Length(knopfText[x]));
    Move(rpPtr, KnopfXPos+7 + (96 - pix)/2, YEcke[x] + 25);
    Text(rpPtr, ADR(knopfText[x]), Length(knopfText[x]));
  END;
  SetBPen(rpPtr,4);
  FOR x := 1 TO 6 DO
    Move(rpPtr,418,x*70);
    Text(rpPtr,ADR(o),1);
    Move(rpPtr,418,x*70+25);
    Text(rpPtr,ADR(k),1);
  END;
  SetBPen(rpPtr,0);
END Bezeichnen;


(***************************************************************)
PROCEDURE Malen(wiPtr : WindowPtr);
VAR rpPtr : RastPortPtr;
    x : CARDINAL;
BEGIN
  rpPtr := wiPtr^.rPort;
  FOR x := 1 TO 9 DO
    SetAPen(rpPtr,rahmenFarbe);
    RectFill(rpPtr,KnopfXPos,YEcke[x],
    		KnopfXPos+aussenBreite,YEcke[x]+aussenHoehe);
  END;
  RectFill(rpPtr,405,10,444,500);		(* OK *)
  FOR x := 1 TO 9 DO
    SetAPen(rpPtr,innenFarbe);
    RectFill(rpPtr,KnopfXPos+LinkeUndRechteRandBreite,
    		YEcke[x]+ObereUndUntereRandBreite,
    		KnopfXPos+aussenBreite-LinkeUndRechteRandBreite,
    		YEcke[x]+aussenHoehe-ObereUndUntereRandBreite);
    DrawImage(rpPtr,ADR(LinksImage),KnopfXPos,YEcke[x]-1);
    DrawImage(rpPtr,ADR(RechtsImage),KnopfXPos+100,YEcke[x]-1);
  END;

  DrawImage(rpPtr,ADR(PlusMinusImage),525,60);	(* Plus - Minus *)
  DrawImage(rpPtr,ADR(PlusMinusImage),525,160);

  DrawImage(rpPtr,ADR(ObenImage),405,10);	(* OK *)
  DrawImage(rpPtr,ADR(UntenImage),405,495);
  SetAPen(rpPtr,4);
  RectFill(rpPtr,411,17,438,495);

  Bezeichnen(rpPtr);
END Malen;

(***************************************************************)
PROCEDURE zu;
BEGIN
  IF level >= CurrentLevel() THEN
    IF tfPtr # NIL THEN
      RemFont(tfPtr);
      CloseFont(tfPtr);
    END;
  END;
END zu;

(***************************************************************)
(***************************************************************)
BEGIN
  level := CurrentLevel();
  TermProcedure(zu);

  YEcke[1]:=10;
  YEcke[2]:=110;
  YEcke[3]:=220;
  YEcke[4]:=260;
  YEcke[5]:=300;
  YEcke[6]:=340;
  YEcke[7]:=380;
  YEcke[8]:=420;
  YEcke[9]:=465;
  Copy(knopfText[1],"KISTEN");
  Copy(knopfText[2],"FARBEN");
  Copy(knopfText[3],"SPIEL");
  Copy(knopfText[4],"HILFE");
  Copy(knopfText[5],"INFO");
  Copy(knopfText[6],"BESTEN");
  Copy(knopfText[7],"NEU");
  Copy(knopfText[8],"DRUCK");
  Copy(knopfText[9],"ENDE");
END BildMalen.
