(*********************************************************************
 *
 *  :Program.		AbfrageRequester fr Mastermind
 *  :Author.		Hans Schafft
 *  :Address.		Landfriedstrae 1A - Hinterhaus
 *  :Address.		6900 Heidelberg
 *  :Phone.		06221 - 22416
 *  :Version.		1.0
 *  :Date.		1989
 *  :Copyright.		PD
 *  :Language.		Modula-II
 *  :Translator.	M2Amiga
 *
 *********************************************************************)

IMPLEMENTATION MODULE MODUS;

FROM SYSTEM	IMPORT  ADR, ADDRESS, LONGSET;
FROM Intuition	IMPORT	GadgetPtr, WindowPtr,IntuiText,RemoveGadget,
			IntuiMessagePtr, IDCMPFlags, IDCMPFlagSet,
			boolGadget, reqGadget, ActivationFlags,Request,
		        ActivationFlagSet, Border, Gadget, GadgetFlagSet,
                        Requester, RequesterFlagSet, InitRequester;
FROM Exec       IMPORT  MemReqs, MemReqSet, WaitPort, ReplyMsg, GetMsg;
FROM Graphics	IMPORT	jam2, jam1;


CONST
 RequBreite = 320; 	RequHoehe = 120;
 GadBreite  = 115; 	GadHoehe  =  10;

VAR
 EndeRequest   : Requester;
 EndeGad1Text  : IntuiText;
 EndeGad1      : Gadget;
 EndeGad1Border: Border;
 EndeGad1Ecken : ARRAY [1..10] OF INTEGER;
 EndeGad2Text  : IntuiText;
 EndeGad2      : Gadget;
 EndeGad2Border: Border;
 EndeGad2Ecken : ARRAY [1..10] OF INTEGER;
 EndeReqBorder : Border;
 EndeReqEcken  : ARRAY [1..10] OF INTEGER;
 EndeReqText   : ARRAY [0..7] OF IntuiText;


(******************************************************************)
PROCEDURE Modus(wiPtr : WindowPtr) : BOOLEAN;
VAR
  gadPtr	: GadgetPtr;
  gadNr,z	: INTEGER;
  hilfen,y	: INTEGER;
  versuche,x	: INTEGER;
  msgPtr	: IntuiMessagePtr;
  class 	: IDCMPFlagSet;
  code		: CARDINAL;
  ende,mode	: BOOLEAN;

BEGIN
  IF Request(ADR(EndeRequest),wiPtr) THEN
    ende := FALSE;mode := TRUE;
    REPEAT
      WaitPort(wiPtr^.userPort);
      LOOP
        msgPtr := GetMsg(wiPtr^.userPort);
        IF msgPtr=NIL THEN EXIT END;

        class := msgPtr^.class;
        code  := msgPtr^.code;
        gadPtr := msgPtr^.iAddress;
        gadNr := gadPtr^.gadgetID;

        ReplyMsg(msgPtr);

        IF (class = IDCMPFlagSet{gadgetUp}) THEN
          CASE gadNr OF
          | 1 : mode := TRUE;  ende := TRUE;
          | 2 : mode := FALSE; ende := TRUE;
          ELSE
          END;
        END;
        IF ende THEN EXIT END;
      END; (* LOOP *)
    UNTIL ende;
  END;
  RETURN mode;
END Modus;


(******************************************************************)
PROCEDURE RichteEinGadgetJa;
BEGIN
   (* Koordinaten fr den Rand der Gadget Box *)
  EndeGad1Ecken[1] := 0;              EndeGad1Ecken[2] := 0;
  EndeGad1Ecken[3] := GadBreite+1;    EndeGad1Ecken[4] := 0;
  EndeGad1Ecken[5] := GadBreite+1;    EndeGad1Ecken[6] := GadHoehe+1;
  EndeGad1Ecken[7] := 0;              EndeGad1Ecken[8] := GadHoehe+1;
  EndeGad1Ecken[9] := 0;              EndeGad1Ecken[10] := 0;

  WITH EndeGad1Border DO
    leftEdge := -1; 			topEdge 	:= -1;
    frontPen := 4; 			backPen 	:= 0;
    drawMode := jam1; 	     		count   	:= 5;
    xy       := ADR(EndeGad1Ecken); 	nextBorder 	:= NIL;
  END;

  WITH EndeGad1Text DO
   leftEdge  := 3; topEdge := 1;
   frontPen  := 3; backPen := 2;
   drawMode  := jam2;
   iText     := ADR("EINZEL - MODUS");
   iTextFont := NIL; nextText := NIL;
  END;

  WITH EndeGad1 DO
   leftEdge  	:=  190;
   topEdge  	:=  RequHoehe - (GadHoehe + 13);
   width  	:=  GadBreite;
   height 	:=  GadHoehe;
   flags  	:=  GadgetFlagSet{};
   activation 	:=  ActivationFlagSet{endGadget, relVerify};
   gadgetType 	:=  boolGadget + reqGadget;
   gadgetRender :=  ADR(EndeGad1Border);
   gadgetText 	:=  ADR(EndeGad1Text);
   mutualExclude:=  LONGSET{};
   nextGadget 	:=  NIL;
   selectRender :=  NIL;
   specialInfo 	:=  NIL;
   userData     :=  NIL;
   gadgetID	:=  1;
  END;
 END RichteEinGadgetJa;


(******************************************************************)
PROCEDURE RichteEinGadgetNein;
BEGIN
   (* Koordinaten fr den Rand der Gadget Box *)
  EndeGad2Ecken[1] := 0;              EndeGad2Ecken[2] := 0;
  EndeGad2Ecken[3] := GadBreite+4;    EndeGad2Ecken[4] := 0;
  EndeGad2Ecken[5] := GadBreite+4;    EndeGad2Ecken[6] := GadHoehe+1;
  EndeGad2Ecken[7] := 0;              EndeGad2Ecken[8] := GadHoehe+1;
  EndeGad2Ecken[9] := 0;              EndeGad2Ecken[10] := 0;

  WITH EndeGad2Border DO
    leftEdge := -1;   			topEdge := -1;
    frontPen := 4;			backPen :=  0;
    drawMode := jam2; 			count   :=  5;
    xy 	     := ADR(EndeGad2Ecken);
    nextBorder  :=  NIL;(*ADR(EndeGad1Border);*)
  END;

  WITH EndeGad2Text DO
    leftEdge  := 5; topEdge := 1;
    frontPen  := 3; backPen := 2;
    drawMode  := jam2;
    iText     := ADR("MEHRFACH-MODUS");
    iTextFont := NIL; nextText := NIL;
  END;

  WITH EndeGad2 DO
    leftEdge  	:=  10;
    topEdge  	:=  RequHoehe - (GadHoehe + 13);
    width  	:=  GadBreite;
    height	:=  GadHoehe;
    flags  	:=  GadgetFlagSet{};
   activation 	:=  ActivationFlagSet{endGadget, relVerify};
   gadgetType 	:=  boolGadget + reqGadget;
   gadgetRender :=  ADR(EndeGad2Border);
   gadgetText 	:=  ADR(EndeGad2Text);
   mutualExclude:=  LONGSET{};
   nextGadget 	:=  ADR(EndeGad1);
   selectRender :=  NIL;
   specialInfo 	:=  NIL;
   userData 	:=  NIL;
   gadgetID 	:=  2
  END;
 END RichteEinGadgetNein;


(******************************************************************)
PROCEDURE RichteEinRequester;
BEGIN
  EndeReqEcken[1] := 0;              EndeReqEcken[2] := 0;
  EndeReqEcken[3] := RequBreite-3;   EndeReqEcken[4] := 0;
  EndeReqEcken[5] := RequBreite-3;   EndeReqEcken[6] := RequHoehe-3;
  EndeReqEcken[7] := 0;              EndeReqEcken[8] := RequHoehe-3;
  EndeReqEcken[9] := 0;              EndeReqEcken[10] := 0;

  WITH EndeReqBorder DO
    leftEdge := 1;  topEdge := 1;
    frontPen := 3;  backPen := 0;
    drawMode := jam2; count := 5;
    xy       := ADR(EndeReqEcken); nextBorder := NIL;
  END;

  InitRequester(ADR(EndeRequest));

  WITH EndeRequest DO
   leftEdge 	:= 30; 		topEdge := 210;
   width 	:= RequBreite; 		height  := RequHoehe;
   reqGadget 	:= ADR(EndeGad2);
   reqText 	:= ADR(EndeReqText);
   reqBorder 	:= ADR(EndeReqBorder);
   backFill 	:= 2;
  END;

 END RichteEinRequester;


(******************************************************************)
PROCEDURE RichteEinRequesterText;

 PROCEDURE InitIText(VAR itext: IntuiText; L, T: CARDINAL; Next, text: ADDRESS);
  BEGIN
   WITH itext DO
    leftEdge  := L;    topEdge  := T;
    frontPen  := 3;    backPen  := 2;
    drawMode  := jam2; iText    := text;
    iTextFont := NIL;  nextText := Next
   END
  END InitIText;

BEGIN
  InitIText(EndeReqText[0], 5, 10, ADR(EndeReqText[1]),
        ADR("Sie knnen zwischen zwei verschiedenen"));
  InitIText(EndeReqText[1], 5, 20, ADR(EndeReqText[2]),
        ADR("Modi whlen: "));
  InitIText(EndeReqText[2], 5, 30, ADR(EndeReqText[3]),
        ADR("Im Einzel-Modus kommt jede Farbe hch-"));
  InitIText(EndeReqText[3], 5, 40, ADR(EndeReqText[4]),
        ADR("stens einmal vor - natrlich nur, wenn"));
  InitIText(EndeReqText[4], 5, 50, ADR(EndeReqText[5]),
        ADR("die Anzahl der Stellen die Anzahl der"));
  InitIText(EndeReqText[5], 5, 60, ADR(EndeReqText[6]),
        ADR("Farben nicht berschreitet."));
  InitIText(EndeReqText[6], 5, 70, ADR(EndeReqText[7]),
        ADR("Im Mehrfach-Modus kann jede Farbe ein"));
  InitIText(EndeReqText[7], 5, 80, NIL,
        ADR("bis StellenAnzahl mal vorkommen."));
END RichteEinRequesterText;


(******************************************************************)
(******************************************************************)
BEGIN
 RichteEinGadgetJa; RichteEinGadgetNein;
 RichteEinRequesterText; RichteEinRequester;
END MODUS.
