(*********************************************************************
 *
 *  :Program.	HilfsModul fr SCHIFFCHENVERSENKEN
 *  :Author.	Hans Schafft
 *  :Address.	Landfriedstrae 1A - Hinterhaus
 *  :Address.	6900 Heidelberg
 *  :Phone.	06221 - 22416
 *  :Version.	1.0
 *  :Date.	1990
 *  :Copyright.	PD
 *  :Language.	Modula-II
 *  :Translator.M2Amiga
 *  :Contents.
 *
 *********************************************************************)
IMPLEMENTATION MODULE BildMalen;

FROM SYSTEM		IMPORT	ADR;
FROM Arts		IMPORT	Assert,CurrentLevel,TermProcedure;
FROM Intuition		IMPORT	WindowPtr,DrawImage;
FROM DiskFont		IMPORT	OpenDiskFont;
FROM Str		IMPORT	Copy,Length;
FROM Graphics		IMPORT	TextAttr,SetAPen,RectFill,FontFlagSet,
				TextFontPtr,FontStyleSet,RastPortPtr,
				Text,TextLength,Move,RemFont,SetDrMd,
				jam1,jam2,SetBPen,Draw,SetRast,
				AddFont,SetFont,FontFlags,CloseFont;


CONST	rahmenFarbe = 13;
	innenFarbe  = 2;
	aussenBreite = 300;
	aussenHoehe = 36;
        LinkeUndRechteRandBreite = 7;
        ObereUndUntereRandBreite = 5;
        KnopfXPos  = 340;
	AbstandVonOben = 70;

VAR	YEcke	: ARRAY [1..9] OF INTEGER;
        knopfText : ARRAY [1..9],[1..20] OF CHAR;
        Info : ARRAY [1..16],[1..30] OF CHAR;
        tfPtr : TextFontPtr;
        level : INTEGER;


(***************************************************************)
PROCEDURE FontOeffnen;
VAR textAttribute : TextAttr;
BEGIN
  WITH textAttribute DO
    name  := ADR("poster.font");
    ySize := 16;
    style := FontStyleSet{};
    flags := FontFlagSet{diskFont};
  END;
  tfPtr := OpenDiskFont(ADR(textAttribute));
  Assert(tfPtr # NIL,ADR("Konnte POSTER.font nicht finden !"));
END FontOeffnen;

(***************************************************************)
PROCEDURE Bezeichnen(rpPtr : RastPortPtr);
VAR textAttribute : TextAttr;
    x,pix : INTEGER;
BEGIN
  SetFont(rpPtr,tfPtr);
  SetAPen(rpPtr,1);
  SetBPen(rpPtr,2);
  SetDrMd(rpPtr,jam2);
  FOR x := 1 TO 9 DO
    pix := TextLength(rpPtr, ADR(knopfText[x]), Length(knopfText[x]));
    Move(rpPtr, KnopfXPos+7 + (295 - pix)/2, YEcke[x] + 25);
    Text(rpPtr, ADR(knopfText[x]), Length(knopfText[x]));
  END;
  SetBPen(rpPtr,0);
  FOR x := 1 TO 16 DO
    IF x < 16 THEN
      SetAPen(rpPtr,x);
    ELSE
      SetAPen(rpPtr,5);
    END;
    Move(rpPtr, 0 , x*30);
    Text(rpPtr, ADR(Info[x]), Length(Info[x]));
  END;
  CloseFont(tfPtr);
END Bezeichnen;


(***************************************************************)
PROCEDURE Malen(wiPtr : WindowPtr);
VAR rpPtr : RastPortPtr;
    x : CARDINAL;
BEGIN
  rpPtr := wiPtr^.rPort;
  FOR x := 1 TO 9 DO
    SetAPen(rpPtr,rahmenFarbe);
    RectFill(rpPtr,KnopfXPos,YEcke[x],
    		KnopfXPos+aussenBreite,YEcke[x]+aussenHoehe);
  END;
  FOR x := 1 TO 9 DO
    SetAPen(rpPtr,innenFarbe);
    RectFill(rpPtr,KnopfXPos+LinkeUndRechteRandBreite,
    		YEcke[x]+ObereUndUntereRandBreite,
    		KnopfXPos+aussenBreite-LinkeUndRechteRandBreite,
    		YEcke[x]+aussenHoehe-ObereUndUntereRandBreite);
  END;

  SetAPen(rpPtr,4);
  Bezeichnen(rpPtr);
END Malen;

(***************************************************************)
PROCEDURE FeldKommentar(rpPtr : RastPortPtr; farbe : INTEGER;
			text : ARRAY OF CHAR);
BEGIN
  Assert(TextLength(rpPtr,ADR(text),Length(text)) < 640,ADR("Text zu lang !!!"));
  SetBPen(rpPtr,0);
  SetDrMd(rpPtr,jam2);
  SetAPen(rpPtr,0);
  RectFill(rpPtr,0,0,640,AbstandVonOben-1);
  SetAPen(rpPtr,farbe);
  Move(rpPtr,10,AbstandVonOben DIV 2);
  Text(rpPtr, ADR(text), Length(text));
END FeldKommentar;

(***************************************************************)
PROCEDURE SpielFelder(wiPtr : WindowPtr; breite : INTEGER);
VAR quadBreite,x,pix : INTEGER;
BEGIN
  quadBreite := 310 DIV breite;
  SetRast(wiPtr^.rPort,0);
  FOR x := 0 TO breite DO
    SetAPen(wiPtr^.rPort,8);
    Move(wiPtr^.rPort,0,AbstandVonOben+quadBreite*x);
    Draw(wiPtr^.rPort,quadBreite*(breite),AbstandVonOben+quadBreite*x);
    Move(wiPtr^.rPort,quadBreite*x,AbstandVonOben);
    Draw(wiPtr^.rPort,quadBreite*x,AbstandVonOben+quadBreite*(breite));
    SetAPen(wiPtr^.rPort,9);
    Move(wiPtr^.rPort,320,AbstandVonOben+quadBreite*x);
    Draw(wiPtr^.rPort,320+quadBreite*(breite),AbstandVonOben+quadBreite*x);
    Move(wiPtr^.rPort,320+quadBreite*x,AbstandVonOben);
    Draw(wiPtr^.rPort,320+quadBreite*x,AbstandVonOben+quadBreite*(breite));
  END;
END SpielFelder;

(***************************************************************)
PROCEDURE zu;
BEGIN
  IF level >= CurrentLevel() THEN
    IF tfPtr # NIL THEN
      CloseFont(tfPtr);
      RemFont(tfPtr);
    END;
  END;
END zu;

(***************************************************************)
(***************************************************************)
BEGIN
  TermProcedure(zu);
  level := CurrentLevel();
  FontOeffnen;
  YEcke[1]:=0;
  YEcke[2]:=50;
  YEcke[3]:=100;
  YEcke[4]:=170;
  YEcke[5]:=220;
  YEcke[6]:=270;
  YEcke[7]:=340;
  YEcke[8]:=390;
  YEcke[9]:=470;
  Copy(knopfText[1]," SPIEL - REGELN");
  Copy(knopfText[2]," BESTEN - LISTE");
  Copy(knopfText[3],"  SPIEL BEENDEN");
  Copy(knopfText[4],"KLEINES SPIELFELD");
  Copy(knopfText[5],"MITTLERES SPIELFELD");
  Copy(knopfText[6],"GROSSES SPIELFELD");
  Copy(knopfText[7],"AUTO - EINRICHTUNG");
  Copy(knopfText[8],"HAND - EINRICHTUNG");
  Copy(knopfText[9],"O K");
  Copy(Info[1],"Schiffchen Versenken");
  Copy(Info[2],"von Hans Schafft ");
  Copy(Info[3],"erstellt 1989 - 1990.");
  Copy(Info[4],"Anregungen, Geld");
  Copy(Info[5],"und, so unvermeidbar,");
  Copy(Info[6],"auch Kritik nehme ich");
  Copy(Info[7],"- hmmm - dankbar an !");
  Copy(Info[8],"Bitte waehlen Sie");
  Copy(Info[9],"die SpielFeldGroesse");
  Copy(Info[10],"sowie die Art des Auf-");
  Copy(Info[11],"baus. Nur nach Anwahl");
  Copy(Info[12],"beider Kriterien sowie");
  Copy(Info[13],"des abschliessenden OK");
  Copy(Info[14],"geht's los ! Wollen Sie");
  Copy(Info[15],"mehr wissen, so klicken");
  Copy(Info[16],"Sie bitte 'SpielRegeln'.");
END BildMalen.
