(*********************************************************************
 *
 *  :Program.	HauptProgramm SCHIFFCHENVERSENKEN
 *  :Author.	Hans Schafft
 *  :Address.	Landfriedstrae 1A - Hinterhaus
 *  :Address.	6900 Heidelberg
 *  :Phone.	06221 - 22416
 *  :Version.	1.3
 *  :Date.	9.7.1990
 *  :Copyright.	PD
 *  :Language.	Modula-II
 *  :Translator.M2Amiga
 *  :Contents.
 *
 *********************************************************************)
MODULE SchiffchenVersenken;
(*$R-*)(*$V-*)(*$S-*)(*$F-*)
FROM Dos		IMPORT	Delay;
FROM Arts		IMPORT	Assert,AllLevelTermProc,Terminate;
FROM Graphics		IMPORT  CloseFont,SetAPen,RectFill,SetRast,RemFont;
FROM Conversions	IMPORT	ValToStr;
FROM Exec	        IMPORT  WaitPort, ReplyMsg, GetMsg;
FROM Str		IMPORT	Copy,Concat;
FROM RandomNumber	IMPORT	RND, PutSeed;
FROM SYSTEM		IMPORT	BITSET,ADR,ADDRESS;
FROM SCREEN		IMPORT	ScreenAuf,FensterAuf;
FROM Intuition		IMPORT	WindowPtr,CloseScreen,GadgetPtr,ScreenPtr,
				CurrentTime,CloseWindow,
				IntuiMessagePtr, RemoveGList;
FROM BildMalen		IMPORT	Malen,SpielFelder,FeldKommentar;
FROM BESTENLISTE	IMPORT	BestenListe;
FROM Klang		IMPORT	WasserTon,GetroffenTon,VersenktTon,CompSiegTon,
				MenschSiegTon,MenschTipTon,CompTipTon,
				SchonmalTon;
FROM WASSER		 IMPORT	WasserHerum,WasserHerumWeg,
				EinfaerbenUndWasserHerum,
				EinKaestchenMarkieren,AlleKaestchenMarkieren;
FROM Abbruch		IMPORT	ZeigeAbbruch;
FROM SpielRegeln	IMPORT	ZeigeSpielRegeln;
FROM Gadget		IMPORT	FestGadgetAufbau,SpielArtFlagSet,SpielArtFlags,
				GadgetIDHolen,Konstellation,MausTaste,
				KaestchenGadgetAufbau, fertig;


CONST	AbstandVonOben = 70;
	nochNichts = 0;
	wasser = 6;
	UBoot = 1;
	Torpedo = 2;
	Kreuzer = 3;
	Schlachtschiff = 4;
	schonGetippt = 10;
	links = 0;
	rechts = 1;

VAR	wiPtr			: WindowPtr;
	scPtr			: ScreenPtr;
	prefs			: SpielArtFlagSet;
	Feld			: ARRAY [0..1],[0..13],[0..13] OF INTEGER;
	CTmax,MTmax		: ARRAY [1..4] OF INTEGER;
	KaroZahl,gadBreite,xx	: INTEGER;
	maxID,vky,vkx,verfolgen	: INTEGER;
        restWasser,restBoote,yy	: INTEGER;
        xAlt,yAlt		: INTEGER;
	s,m			: LONGINT;
	MSieg,CSieg		: BOOLEAN;
	err,waagrecht		: BOOLEAN;


(***************************************************************)
PROCEDURE FeldLeeren(seite : INTEGER);
VAR a,b : INTEGER;
BEGIN
  FOR a := 0 TO 13 DO
    FOR b := 0 TO 13 DO
      Feld[seite,a,b] := nochNichts;
    END;
  END;
END FeldLeeren;

(***************************************************************)
PROCEDURE Nebeneinander(seite,boot,zahl : INTEGER): BOOLEAN;
VAR x,y : INTEGER;
    ok : BOOLEAN;
BEGIN
  ok := TRUE;
  FOR x := 1 TO zahl - 1 DO
    IF (vkx + x) > KaroZahl THEN     (* Bereich prfen  *)
      ok := FALSE;
    ELSIF Feld[seite,vkx+x,vky] # boot THEN
      ok := FALSE;
    ELSE
    END;
  END;
  IF ok THEN
    FOR x := 0 TO zahl - 1 DO	(* ntig, damit nicht alle EinzelBoote  *)
      Feld[rechts,vkx+x,vky] := boot + 16; (* ebenfalls gemalt werden!  *)
    END;
    RETURN TRUE;

  ELSE
    ok := TRUE;
    FOR x := 1 TO zahl - 1 DO
      IF (vkx - x) < 1 THEN
        ok := FALSE;
      ELSIF Feld[seite,vkx-x,vky] # boot THEN
        ok := FALSE;
      ELSE
      END;
    END;
    IF ok THEN
      FOR x := 0 TO zahl - 1 DO (* ntig, damit nicht alle EinzelBoote  *)
        Feld[rechts,vkx-x,vky] := boot + 16; (* ebenfalls gemalt werden!  *)
      END;
      RETURN TRUE;
    ELSE

      ok := TRUE;
      FOR x := 1 TO zahl - 1 DO
        IF (vky + x) > KaroZahl THEN
          ok := FALSE;
        ELSIF Feld[seite,vkx,vky+x] # boot THEN
          ok := FALSE;
        ELSE
        END;
      END;
      IF ok THEN
        FOR x := 0 TO zahl - 1 DO (* ntig, damit nicht alle EinzelBoote  *)
          Feld[rechts,vkx,vky+x] := boot + 16; (* ebenfalls gemalt werden!  *)
        END;
        RETURN TRUE;
      ELSE

        ok := TRUE;
        FOR x := 1 TO zahl - 1 DO
          IF (vky - x) < 1 THEN
            ok := FALSE;
          ELSIF Feld[seite,vkx,vky-x] # boot THEN
            ok := FALSE;
          ELSE
          END;
        END;
        IF ok THEN
          FOR x := 0 TO zahl - 1 DO(* ntig, damit nicht alle EinzelBoote  *)
            Feld[rechts,vkx,vky-x] := boot + 16; (* ebenfalls gemalt werden!  *)
          END;
          RETURN TRUE;
        ELSE
          RETURN FALSE;
        END;
      END;
    END;
  END;
END Nebeneinander;

(***************************************************************)
PROCEDURE VersenktKontrolle(wert,boot,seite : INTEGER) : BOOLEAN;
BEGIN
  IF wert = 0 THEN
    RETURN TRUE;
  ELSIF boot = UBoot THEN
    RETURN TRUE;
  ELSIF seite = links THEN
    CASE boot OF
    | 2 : CASE wert OF
          | 2 : RETURN TRUE;
          | 4 : RETURN TRUE;
          ELSE
            RETURN FALSE;
          END;
    | 3 : CASE wert OF
          | 3 : RETURN TRUE;
          ELSE
            RETURN FALSE;
          END;
    | 4 : CASE wert OF
          | 3 : RETURN FALSE;
          | 2 : RETURN FALSE;
          | 1 : RETURN FALSE;
          ELSE
            RETURN TRUE;
          END;
    ELSE
      RETURN TRUE;
    END;

  ELSE (* seite = rechts *)
    RETURN Nebeneinander(seite,boot+schonGetippt,boot);
  END;
END VersenktKontrolle;

(***************************************************************)
PROCEDURE Aufbauen(seite,boot,x,y : INTEGER) : BOOLEAN;
VAR richtung,k,rx,ry : INTEGER;
    genugPlatz : BOOLEAN;
BEGIN
  richtung := RND(4);		(* Richtung ermitteln *)
  REPEAT
    CASE richtung OF
    | 0 : rx := 0;  ry := 1;
    | 1 : rx := 0;  ry := -1;
    | 2 : rx := 1;  ry := 0;
    | 3 : rx := -1; ry := 0;
    ELSE
      rx := 1; ry := 0;
    END;
    genugPlatz := TRUE;
    FOR k := 1 TO boot DO
      IF ((x+rx*k) > KaroZahl) OR ((y+ry*k) > KaroZahl) OR
         ((x+rx*k) < 1) OR ((y+ry*k) < 1) THEN
        genugPlatz := FALSE;
      ELSIF Feld[seite,x+(rx*k),y+(ry*k)] # nochNichts THEN
        genugPlatz := FALSE;
      ELSE
      END;
    END;
    INC(richtung);
  UNTIL genugPlatz OR (richtung > 3);

  IF genugPlatz THEN
    FOR k := 1 TO boot DO
      Feld[seite,x+(rx*k),y+(ry*k)] := boot;
    END;
    WasserHerum(ADR(Feld),seite,KaroZahl,boot,wasser);
    IF seite = links THEN
      AlleKaestchenMarkieren(wiPtr,ADR(Feld),seite,KaroZahl);
    END;

    RETURN TRUE;

  ELSE
    RETURN FALSE;
  END;
END Aufbauen;

(***************************************************************)
PROCEDURE AutomatischerAufbau(seite : INTEGER);
VAR boot,x,y,versuche : INTEGER;
    max : ARRAY [1..4] OF INTEGER;
BEGIN
  FeldLeeren(seite);
  boot := Schlachtschiff;
  max[1] := 4; max[2] := 3; max[3] := 2; max[4] := 1;
  REPEAT
    versuche := 0;
    REPEAT
      x := RND(KaroZahl)+1;
      y := RND(KaroZahl)+1;
      INC(versuche);
    UNTIL Aufbauen(seite,boot,x,y) OR (versuche = maxID);

    DEC(max[boot]);
    IF max[boot] = 0 THEN
      DEC(boot);
    END;

    IF versuche = maxID THEN
      FeldLeeren(seite);
      boot := 4;
      IF seite = links THEN
        AlleKaestchenMarkieren(wiPtr,ADR(Feld),links,KaroZahl);
      END;
      max[1] := 4; max[2] := 3; max[3] := 2; max[4] := 1;
    END;
  UNTIL boot = 0;

  FOR x := 1 TO KaroZahl DO
    FOR y := 1 TO KaroZahl DO
      IF Feld[seite,x,y]  = nochNichts THEN
        Feld[seite,x,y] := wasser;
      END;
    END;
  END;

  IF seite = links THEN
    AlleKaestchenMarkieren(wiPtr,ADR(Feld),seite,KaroZahl);
  END;

END AutomatischerAufbau;

(***************************************************************)
PROCEDURE MitDerMausAufbauen(seite : INTEGER);
VAR laenge,karo,Boot,id,x,y : INTEGER;
    texte : ARRAY [1..4],[1..33] OF CHAR;
    max : ARRAY [1..4] OF INTEGER;
BEGIN
  FeldLeeren(seite);
  FOR x := 1 TO 4 DO
    max[x] := (5 - x) * x;
  END;

  Copy(texte[4],"Plazieren Sie das Schlachtschiff !");
  Copy(texte[3],"Plazieren Sie die zwei Kreuzer !");
  Copy(texte[2],"Plazieren Sie die drei Torpedos !");
  Copy(texte[1],"Plazieren Sie Ihre vier U-Boote !");

  Boot := Schlachtschiff;
  FeldKommentar(wiPtr^.rPort,Boot,texte[Boot]);
  vkx := 0; vky := 0; laenge := 0;

  REPEAT

    REPEAT
      id := GadgetIDHolen(maxID);
      IF id = fertig THEN
        IF ZeigeAbbruch(wiPtr) THEN
          Terminate(0);
        END;
      END;
    UNTIL id # fertig;

    x := (id DIV KaroZahl) + 1;
    y := (id MOD KaroZahl) + 1;

    karo := Feld[seite,x,y];

    CASE karo OF
    | nochNichts :

      vkx := x; vky := y;
      IF (laenge > 0) AND NOT Nebeneinander(seite,Boot,laenge+1) THEN
         (* bergehe dieses Klicken *)
      ELSE
        INC(laenge);
        Feld[seite,x,y] := Boot;
        EinKaestchenMarkieren(wiPtr,ADR(Feld),seite,KaroZahl,Boot,x,y);
        DEC(max[Boot]);
        IF VersenktKontrolle(max[Boot],Boot,seite) THEN
          WasserHerum(ADR(Feld),seite,KaroZahl,Boot,wasser);
          AlleKaestchenMarkieren(wiPtr,ADR(Feld),seite,KaroZahl);
          vkx := 0; vky := 0; laenge := 0;
        END;
        IF max[Boot] = 0 THEN
          DEC(Boot);
          IF Boot > 0 THEN
            FeldKommentar(wiPtr^.rPort,Boot,texte[Boot]);
 	  END;
 	END;
      END;

    | UBoot..Schlachtschiff :  (* alles was =< Boot ist lschen   *)

      vkx := 0; vky := 0; laenge := 0;
      Boot := karo;
      FOR x := 1 TO Boot DO
        max[x] := (5 - x) * x;
        WasserHerumWeg(ADR(Feld),seite,KaroZahl,x);
      END;
      FOR x := 1 TO KaroZahl DO
        FOR y := 1 TO KaroZahl DO
          IF Feld[seite,x,y] <= Boot THEN
            Feld[seite,x,y] := nochNichts;
          END;
        END;
      END;
      FeldKommentar(wiPtr^.rPort,Boot,texte[Boot]);
      IF Boot < Schlachtschiff THEN
        FOR x := Boot+1 TO Schlachtschiff DO
          WasserHerum(ADR(Feld),seite,KaroZahl,x,wasser);
        END;
      END;
      AlleKaestchenMarkieren(wiPtr,ADR(Feld),seite,KaroZahl);

    | wasser :     (* bergehe dieses Klicken *)
    ELSE
      Assert(FALSE,ADR("Solche Kstchen gibts nicht !"));
    END;
  UNTIL (Boot < 1);

  FOR x := 1 TO KaroZahl DO		(* mit wasser auffllen *)
    FOR y := 1 TO KaroZahl DO
      IF Feld[seite,x,y] = nochNichts THEN
        Feld[seite,x,y] := wasser;
      END;
    END;
  END;
  AlleKaestchenMarkieren(wiPtr,ADR(Feld),seite,KaroZahl);

END MitDerMausAufbauen;

(***************************************************************)
PROCEDURE KaroZahlErmitteln;
BEGIN
  IF kleinesFeld IN prefs THEN
    KaroZahl := 8;
  ELSIF mittleresFeld IN prefs THEN
    KaroZahl := 10;
  ELSIF grossesFeld IN prefs THEN
    KaroZahl := 12;
  ELSE
    Assert(FALSE,ADR("FeldGrenAuswahl arbeitet nicht korrekt !"));
  END;
  gadBreite := (310 DIV KaroZahl) - 1;
  maxID := KaroZahl*KaroZahl;
END KaroZahlErmitteln;

(***************************************************************)
PROCEDURE MenschTip()  : BOOLEAN;
VAR boot ,x ,y ,id : INTEGER;
    daneben ,ende  : BOOLEAN;
BEGIN
  FeldKommentar(wiPtr^.rPort,15,
  "                                            TIPPEN SIE JETZT !!");
  REPEAT
    REPEAT
      id := GadgetIDHolen(maxID);
      IF id = fertig THEN
        IF ZeigeAbbruch(wiPtr) THEN
          Terminate(0);
        END;
      END;
    UNTIL id # fertig;

    x := (id DIV KaroZahl) + 1;
    y := (id MOD KaroZahl) + 1;

    boot  := Feld[rechts,x,y];

    CASE boot OF
    | UBoot..Schlachtschiff :

      daneben := FALSE;
      EinKaestchenMarkieren(wiPtr,ADR(Feld),rechts,KaroZahl,5,x,y);
      DEC(MTmax[boot]);
      Feld[rechts,x,y] := boot + schonGetippt;
      vkx := x; vky := y;	(* wird in Nacheinander() gebraucht !  *)
      IF VersenktKontrolle(MTmax[boot],boot,rechts) THEN
        EinfaerbenUndWasserHerum(wiPtr,ADR(Feld),
        				rechts,KaroZahl,Feld[rechts,x,y]);
        VersenktTon;
      ELSE
        GetroffenTon;
      END;

    | wasser :

      EinKaestchenMarkieren(wiPtr,ADR(Feld),rechts,KaroZahl,wasser,x,y);
      WasserTon;
      daneben := TRUE;
      Feld[rechts,x,y] := schonGetippt + wasser;

    | schonGetippt..schonGetippt+wasser :

      SchonmalTon;
      daneben := FALSE;

    ELSE
    END;

    ende := TRUE;
    FOR boot := UBoot TO Schlachtschiff DO
      IF MTmax[boot] # 0 THEN
        ende := FALSE;
      END;
    END;

  UNTIL daneben OR ende;

  IF ende THEN
    FeldKommentar(wiPtr^.rPort,5,"                  SIE HABEN GEWONNEN ! ! !");
    MenschSiegTon;
    RETURN TRUE;
  ELSE
    RETURN FALSE;
  END;

END MenschTip;

(***************************************************************)
PROCEDURE platzFuerGroesstesBoot(x,y : INTEGER) : BOOLEAN;
VAR k,p : INTEGER;
    ok : BOOLEAN;
BEGIN
  IF Feld[links,x,y] > schonGetippt THEN
    RETURN FALSE;
  END;

  p := Schlachtschiff;
  WHILE CTmax[p] = 0 DO
    DEC(p);
  END;

  IF p > UBoot THEN  (* Wenn noch grere Boote da sind *)
    k := p-1;

    IF (x+k) <= KaroZahl THEN
      ok := TRUE;
      FOR p := 1 TO k DO
        IF Feld[links,x+p,y] > schonGetippt THEN
          ok := FALSE;
        END;
      END;
    END;

    IF ok THEN
      RETURN TRUE;
    ELSIF (y+k) <= KaroZahl THEN
      ok := TRUE;
      FOR p := 1 TO k DO
        IF Feld[links,x,y+p] > schonGetippt THEN
          ok := FALSE;
        END;
      END;
      RETURN ok;
    ELSE
      RETURN FALSE;
    END;

  ELSE  (* wenn sowieso nur noch UBoote da sind  *)
    RETURN TRUE;
  END;
END platzFuerGroesstesBoot;

(***************************************************************)
PROCEDURE Weitersuchen(VAR x : INTEGER; VAR y : INTEGER);
BEGIN
  IF verfolgen = 1 THEN
    (* suche nach rechts *)
    IF (x < KaroZahl) AND (Feld[links,x+1,y] < schonGetippt) THEN
      INC(x);
    (* suche nach links *)
    ELSIF (x > 1) AND (Feld[links,x-1,y] < schonGetippt) THEN
      DEC(x);
    (* suche nach oben *)
    ELSIF (y < KaroZahl) AND (Feld[links,x,y+1] < schonGetippt) THEN
      INC(y);
    (* suche nach unten *)
    ELSE  (* (y > 1) AND (Feld[links,x,y-1] < schonGetippt) *)
      DEC(y);
    END;
  ELSE
    IF waagrecht THEN
      (* suche nach rechts *)
      IF (x < KaroZahl) AND (Feld[links,x+1,y] < schonGetippt) THEN
        INC(x);
        (* suche nach links *)
      ELSIF (x > 1) AND (Feld[links,x-1,y] < schonGetippt) THEN
        DEC(x);
      ELSE
        x := xAlt;
      END;
    ELSE
      (* suche nach oben *)
      IF (y < KaroZahl) AND (Feld[links,x,y+1] < schonGetippt) THEN
        INC(y);
      (* suche nach unten *)
      ELSIF (y > 1) AND (Feld[links,x,y-1] < schonGetippt) THEN
        DEC(y);
      ELSE
        y := yAlt;
      END;
    END;
  END;
END Weitersuchen;

(***************************************************************)
PROCEDURE CompTip() : BOOLEAN;
VAR boot,cx,cy,id : INTEGER;
    daneben,ende : BOOLEAN;
    msgPtr : IntuiMessagePtr;
BEGIN
  FeldKommentar(wiPtr^.rPort,2,"  COMPUTER TIPPT");

  cx := xAlt; cy := yAlt;(* Ist mir nicht klar, warum man diese Zeile *)
  			 (* reinschreiben mu, aber sonst werden cx  *)
  			 (* und cy von den MenschTipWerten berschrieben *)
  REPEAT
    IF verfolgen # 0 THEN
      Weitersuchen(cx,cy);
    ELSE

      REPEAT
        cx := RND(KaroZahl)+1;
        cy := RND(KaroZahl)+1;
        xAlt := cx; yAlt := cy;
      UNTIL platzFuerGroesstesBoot(cx,cy);
    END;

    boot := Feld[links,cx,cy];

    CASE boot OF
    | UBoot..Schlachtschiff :

      daneben := FALSE;
      EinKaestchenMarkieren(wiPtr,ADR(Feld),links,KaroZahl,0,cx,cy);
      DEC(CTmax[boot]);
      Delay(11);
      Feld[links,cx,cy] := boot + schonGetippt;
      IF VersenktKontrolle(CTmax[boot],boot,links) THEN
        VersenktTon;
        EinfaerbenUndWasserHerum(wiPtr,ADR(Feld),
        			links,KaroZahl,Feld[links,cx,cy]);
        verfolgen := 0;
      ELSE
        GetroffenTon;
        INC(verfolgen);
        IF (verfolgen = 2) THEN
          IF (cx = xAlt) THEN
            waagrecht := FALSE;
          ELSE
            waagrecht := TRUE;
          END;
        ELSE
        END;
      END;

    | wasser :

      EinKaestchenMarkieren(wiPtr,ADR(Feld),links,KaroZahl,0,cx,cy);
      WasserTon;
      Delay(11);
      Feld[links,cx,cy] := boot + schonGetippt;
      daneben := TRUE;
      cx := xAlt; cy := yAlt;

    | schonGetippt..schonGetippt+wasser :

      daneben := FALSE;

    ELSE
      Assert(FALSE,ADR("was war in dem Feld-comptip"));
    END;

    ende := TRUE;
    FOR boot := UBoot TO Schlachtschiff DO
      IF CTmax[boot] # 0 THEN
        ende := FALSE;
      END;
    END;

  UNTIL daneben OR ende;


  IF ende THEN
    FeldKommentar(wiPtr^.rPort,5,"COMPUTER HAT GEWONNEN ! ! !");
    CompSiegTon;

	(* Alle noch nicht gelsten Kstchen markieren ! *)

    FOR cx := 1 TO KaroZahl DO
      FOR cy := 1 TO KaroZahl DO
        IF Feld[rechts,cx,cy] < wasser THEN
          EinKaestchenMarkieren(wiPtr,ADR(Feld),rechts,KaroZahl,14,cx,cy);
        END;
      END;
    END;
    RETURN TRUE;

  ELSE

    REPEAT		(* Entfernt wildes Rumgeklicke ! *)
      msgPtr := GetMsg(wiPtr^.userPort);
      IF msgPtr # NIL THEN
        ReplyMsg(msgPtr);
      END;
    UNTIL msgPtr = NIL;

    RETURN FALSE;
  END;

END CompTip;

(***************************************************************)
PROCEDURE AllesZu;
BEGIN
  IF wiPtr # NIL THEN CloseWindow(wiPtr); END;
  IF scPtr # NIL THEN CloseScreen(scPtr); END;
END AllesZu;

(***************************************************************)
(***************************************************************)
BEGIN
  AllLevelTermProc(AllesZu);
  ScreenAuf(scPtr);
  FensterAuf(scPtr,wiPtr);

  REPEAT
    CurrentTime(ADR(s),ADR(m));  (* Zufalls - Beginn neu *)
    PutSeed(m);

    Malen(wiPtr);
    FestGadgetAufbau(wiPtr);
    Konstellation(wiPtr,prefs);

    IF (bestenliste IN prefs) THEN

      IF MSieg THEN
        restBoote := CTmax[1] + CTmax[2] + CTmax[3] + CTmax[4];
        restWasser := 0;
        FOR xx := 1 TO KaroZahl DO
          FOR yy := 1 TO KaroZahl DO
            IF Feld[links,xx,yy] = wasser THEN
              INC(restWasser);
            END;
          END;
        END;
      ELSIF CSieg THEN
        restBoote := MTmax[1] + MTmax[2] + MTmax[3] + MTmax[4];
        restWasser := 0;
        FOR xx := 1 TO KaroZahl DO
          FOR yy := 1 TO KaroZahl DO
            IF Feld[rechts,xx,yy] = wasser THEN
              INC(restWasser);
            END;
          END;
        END;
      ELSE
        restWasser := 0; restBoote := 0;
      END;

      BestenListe(wiPtr,restWasser,restBoote,MSieg);
      MausTaste(wiPtr);
      MSieg := FALSE;
      CSieg := FALSE;

    ELSIF spielregeln IN prefs THEN

      err := ZeigeSpielRegeln(wiPtr);

    ELSIF OK IN prefs THEN

      KaroZahlErmitteln;
      SpielFelder(wiPtr,KaroZahl);
      FeldKommentar(wiPtr^.rPort,11,"        Bitte ein klein wenig Geduld !!");

      IF AutoAufbau IN prefs THEN
        AutomatischerAufbau(links);
      ELSE
        KaestchenGadgetAufbau(KaroZahl,links);
        MitDerMausAufbauen(links);
        xx := RemoveGList(wiPtr,wiPtr^.firstGadget,-1);
      END;
      FeldKommentar(wiPtr^.rPort,13,"Jetzt baut der Computer sein Feld auf !!");
      AutomatischerAufbau(rechts);
      KaestchenGadgetAufbau(KaroZahl,rechts);

      FOR xx := UBoot TO Schlachtschiff DO
        CTmax[xx] := xx * (5 - xx);
        MTmax[xx] := CTmax[xx];
      END;

      verfolgen := 0;
      waagrecht := TRUE;

      REPEAT
        MSieg := MenschTip();
        IF NOT MSieg THEN
          CSieg := CompTip();
        END;
      UNTIL CSieg OR MSieg;

      xx := RemoveGList(wiPtr,wiPtr^.firstGadget,-1);
      MausTaste(wiPtr);

    ELSE
    END;
    SetRast(wiPtr^.rPort,0);

  UNTIL beenden IN prefs;

END SchiffchenVersenken.
