(* --------------------------------------------------------------------------

:Program.    Colors1.mod
:Contents.   Demo - Program for the use of the procedure LoadColors
:Contents.   from CPicSupport.
:Author.     Thomas Zipproth
:Address.    Dr. Jochner Weg 10, 8948 Mindelheim, Germany
:Phone.      08261/4838
:Copyright.  PD
:Language.   Modula-2
:Translator. M2-Amiga A+l V3.3d
:Imports.    CPicSupport [thz]
:History.    V1.0 [thz] 15.7.90

--------------------------------------------------------------------------- *)

(* $S- $F- $V- $R- *)
MODULE Colors1;

FROM Arts        IMPORT Assert,TermProcedure;
FROM SYSTEM      IMPORT ADR;
FROM Graphics    IMPORT BitMapPtr,RastPortPtr,ViewPortPtr;
FROM Intuition   IMPORT ScreenPtr,CloseScreen;
FROM Dos         IMPORT FileHandlePtr,Delay,Close;
FROM CPicSupport IMPORT ReadInfo,LoadCPicScreen,LoadBitplanes,LoadColors,ci;


VAR sp : ScreenPtr;
    rp : RastPortPtr;
    bp : BitMapPtr;
    vp : ViewPortPtr;
    fp : FileHandlePtr;
    Error : BOOLEAN;


PROCEDURE Ausstieg;
BEGIN
  IF sp#NIL THEN CloseScreen(sp) END;
  IF fp#NIL THEN Close(fp) END;
END Ausstieg;


BEGIN

  TermProcedure(Ausstieg);

  Error := LoadCPicScreen("C0",sp,0,0,TRUE);
  Assert(Error,ADR("Couldn't load picture"));
  rp := ADR(sp^.rastPort);
  bp := rp^.bitMap;
  vp := ADR(sp^.viewPort);
  Delay(100);

  (* --------------------------------------------------- *)

  Error := ReadInfo("C1",ci,fp);
  Assert(Error,ADR("Couldn't load picture"));

  Error := LoadBitplanes(ci,fp,bp,0,24,1);
  (* Load 8-colors Picture into the first 8 colors *)

  LoadColors(ci,vp,bp,1);
  (* Change first 8 colors to those from loaded CPic *)

  Close(fp); fp:=NIL; Delay(100);

  (* --------------------------------------------------- *)

  Error := ReadInfo("C2",ci,fp);
  Assert(Error,ADR("Couldn't load picture"));

  Error := LoadBitplanes(ci,fp,bp,26,24,2);
  (* Load 8-color Picture into the last 8 colors *)

  LoadColors(ci,vp,bp,2);
  (* Change last 8 colors to those from loaded CPic *)

  Close(fp);fp:=NIL;Delay(100);

  (* --------------------------------------------------- *)

  Error := ReadInfo("C3",ci,fp);
  Assert(Error,ADR("Couldn't load picture"));

  Error := LoadBitplanes(ci,fp,bp,26,24,2);
  (* Load 16-color Picture into the last 16 colors *)

  LoadColors(ci,vp,bp,2);
  (* Change last 16 colors to those from loaded CPic *)

  Close(fp);fp:=NIL;Delay(200);


END Colors1.
