(* --------------------------------------------------------------------------

:Program.    Speed.mod
:Contents.   Demo - Program for the use of the procedure LoadBitplanesMem
:Contents.   from CPicSupport.
:Author.     Thomas Zipproth
:Address.    Dr. Jochner Weg 10, 8948 Mindelheim, Germany
:Phone.      08261/4838
:Copyright.  PD
:Language.   Modula-2
:Translator. M2-Amiga A+l V3.3d
:Imports.    CPicSupport [thz]
:History.    V1.0 [thz] 15.7.90

-------------------------------------------------------------------------- *)


(* $S- $V- $R- $F- *)
MODULE Speed;

FROM Arts      IMPORT Assert,TermProcedure;
FROM SYSTEM    IMPORT ADR,ADDRESS;
FROM Exec      IMPORT AllocMem,FreeMem,MemReqs,MemReqSet,UByte;
FROM Graphics  IMPORT BitMapPtr,RastPortPtr;
FROM Intuition IMPORT ScreenPtr,CloseScreen;
FROM Dos       IMPORT Open,Close,Read,oldFile,FileHandlePtr,Seek,Delay;
FROM CPicSupport  IMPORT LoadCPicScreen,LoadBitplanesMem,ci;
FROM RandomNumber IMPORT RND;

TYPE Name = ARRAY[1..3] OF CHAR;

VAR sp : ScreenPtr;
    rp : RastPortPtr;
    bp : BitMapPtr;
    fp : FileHandlePtr;
    Buffer : ADDRESS;
    ad : ARRAY[1..7] OF ADDRESS;
    na : ARRAY[1..7] OF Name;
    le : ARRAY[1..7] OF LONGINT;
    dummy : LONGINT;
    i,a,b,c,d : INTEGER;
    Error : BOOLEAN;


PROCEDURE Ausstieg;
BEGIN
  IF Buffer#NIL THEN FreeMem(Buffer,4000) END;
  FOR i:=1 TO 7 DO
    IF ad[i]#0 THEN FreeMem(ad[i],le[i]) END;
  END;
  IF sp#NIL THEN CloseScreen(sp) END;
END Ausstieg;


BEGIN
  TermProcedure(Ausstieg);

  Buffer := AllocMem(4000,MemReqSet{});
  Assert(Buffer#0,ADR("Not enough Memory"));
  na[1]:="M1"; na[2]:="M2";
  na[3]:="M3"; na[4]:="M4";
  na[5]:="M5"; na[6]:="M6"; na[7]:="M0";

  FOR i:=1 TO 7 DO  (* Read all CPic-Files into Memory *)
    fp:=NIL;fp := Open(ADR(na[i]),oldFile);
    Assert(fp#NIL,ADR("File not found"));
    le[i] := Seek(fp,0,1); le[i] :=Seek(fp,0,-1);
    ad[i] := AllocMem(le[i],MemReqSet{});
    Assert(ad[i]#0,ADR("Not enough Memory"));
    dummy := Read(fp,ad[i],le[i]);
    Close(fp);
  END;

  (* Open Screen with Picture M0 which has 32 Colors *)
  Error := LoadCPicScreen("M0",sp,0,0,TRUE);
  Assert(Error,ADR("Couldn't open Screen "));
  rp := ADR(sp^.rastPort);
  bp := rp^.bitMap;


  FOR i:=0 TO 128 BY 64 DO
    Delay(25);
    LoadBitplanesMem(ci,ad[7],Buffer,bp,0,i,0);
  END;
  Delay(75);


  FOR i:=1 TO 100 DO
    a:=RND(26); (* x-Position of rectangle *)
    b:=RND(150); (* y-Position of rectangle *)
    c:=1+RND(6); (* which picture *)
    d:=1+RND(2); (* first or last 16 Colors to use for Picture *)
    LoadBitplanesMem(ci,ad[c],Buffer,bp,a,b,d);
  END;
  LoadBitplanesMem(ci,ad[6],Buffer,bp,26,0,1);
  LoadBitplanesMem(ci,ad[2],Buffer,bp,0,0,1);
  LoadBitplanesMem(ci,ad[3],Buffer,bp,13,0,2);
  LoadBitplanesMem(ci,ad[1],Buffer,bp,28,96,2);
  LoadBitplanesMem(ci,ad[4],Buffer,bp,0,96,2);
  LoadBitplanesMem(ci,ad[5],Buffer,bp,14,96,1);
  LoadBitplanesMem(ci,ad[7],Buffer,bp,0,192,0);
  Delay(300);

END Speed.
