(**********************************************************************

:Program.    NewFFPInOut.mod
:Contens.    Fast-Floting-Point Ein- und Ausgabe fr NewInOut.
:Author.     Bernd Braun
:Address.    Lippestr. 11, D-3300 Braunschweig
:Phone.      0531/845498
:Copyright.  Public Domain
:Language.   Modula-2
:Translator. M2Amiga A+L V3.3d
:Imports.    NewInOut
:History.    V1.0 25.Sep.1989 Erste lauffhige Version

***********************************************************************)

(* $R- $V- $S- $F- *) (* Programm luft bisher ohne Fehler. *)

IMPLEMENTATION MODULE NewFFPInOut;

   FROM NewInOut IMPORT
      FILE, WriteStringFile, ReadStringFile, stdout, stdin;
   FROM FFPConversions IMPORT
      RealToStr, StrToReal;
   FROM SYSTEM IMPORT
      FFP;

   PROCEDURE WriteFFPFile ( file : FILE; ffp : FFP; m, n : INTEGER );
      VAR
         Str : ARRAY [ 0 .. 79 ] OF CHAR;
         err : BOOLEAN;
   BEGIN
      RealToStr ( ffp, Str, m, n, TRUE, err );
      ffpdone := NOT err;
      WriteStringFile ( file, Str );
   END WriteFFPFile;

   PROCEDURE WriteFFP ( ffp : FFP; m, n : INTEGER );
   BEGIN
      WriteFFPFile ( stdout, ffp, m, n );
   END WriteFFP;

   PROCEDURE ReadFFPFile ( file : FILE; VAR ffp : FFP );
      VAR
         Str : ARRAY [ 0 .. 79 ] OF CHAR;
         err : BOOLEAN;
   BEGIN
      ReadStringFile ( file, Str );
      StrToReal ( Str, ffp, err );
      ffpdone := NOT err;
   END ReadFFPFile;

   PROCEDURE ReadFFP ( VAR ffp : FFP );
   BEGIN
      ReadFFPFile ( stdin, ffp );
   END ReadFFP;

END NewFFPInOut.
