(**********************************************************************

:Program.    NewLongRealInOut.mod
:Contens.    LongReal Ein- und Ausgabe fr NewInOut.
:Author.     Bernd Braun
:Address.    Lippestr. 11, D-3300 Braunschweig
:Phone.      0531/845498
:Copyright.  Public Domain
:Language.   Modula-2
:Translator. M2Amiga A+L V3.3d
:Imports.    NewInOut
:History.    V1.0 25.Sep.1989 Erste lauffhige Version

***********************************************************************)

(* $R- $V- $S- $F- *) (* Programm luft bisher ohne Fehler. *)

IMPLEMENTATION MODULE NewLongRealInOut;

   FROM NewInOut IMPORT
      FILE, WriteStringFile, ReadStringFile, stdout, stdin;
   FROM LongRealConversions IMPORT
      RealToStr, StrToReal;

   PROCEDURE WriteLongRealFile ( file : FILE; LongReal : LONGREAL;
                                 m, n : INTEGER );
      VAR
         Str : ARRAY [ 0 .. 79 ] OF CHAR;
         err : BOOLEAN;
   BEGIN
      RealToStr ( LongReal, Str, m, n, TRUE, err );
      longrealdone := NOT err;
      WriteStringFile ( file, Str );
   END WriteLongRealFile;

   PROCEDURE WriteLongReal ( LongReal : LONGREAL; m, n : INTEGER );
   BEGIN
      WriteLongRealFile ( stdout, LongReal, m, n );
   END WriteLongReal;

   PROCEDURE ReadLongRealFile ( file : FILE; VAR LongReal : LONGREAL );
      VAR
         Str : ARRAY [ 0 .. 79 ] OF CHAR;
         err : BOOLEAN;
   BEGIN
      ReadStringFile ( file, Str );
      StrToReal ( Str, LongReal, err );
      longrealdone := NOT err;
   END ReadLongRealFile;

   PROCEDURE ReadLongReal ( VAR LongReal : LONGREAL );
   BEGIN
      ReadLongRealFile ( stdin, LongReal );
   END ReadLongReal;

END NewLongRealInOut.
