(**********************************************************************

:Program.    NewRealInOut.mod
:Contens.    Real Ein- und Ausgabe fr NewInOut.
:Author.     Bernd Braun
:Address.    Lippestr. 11, D-3300 Braunschweig
:Phone.      0531/845498
:Copyright.  Public Domain
:Language.   Modula-2
:Translator. M2Amiga A+L V3.3d
:Imports.    NewInOut
:History.    V1.0 25.Sep.1989 Erste lauffhige Version

***********************************************************************)

(* $R- $V- $S- $F- *) (* Programm luft bisher ohne Fehler. *)

IMPLEMENTATION MODULE NewRealInOut;

   FROM NewInOut IMPORT
      FILE, WriteStringFile, ReadStringFile, stdout, stdin;
   FROM RealConversions IMPORT
      RealToStr, StrToReal;

   PROCEDURE WriteRealFile ( file : FILE; Real : REAL; m, n : INTEGER );
      VAR
         Str : ARRAY [ 0 .. 79 ] OF CHAR;
         err : BOOLEAN;
   BEGIN
      RealToStr ( Real, Str, m, n, TRUE, err );
      realdone := NOT err;
      WriteStringFile ( file, Str );
   END WriteRealFile;

   PROCEDURE WriteReal ( Real : REAL; m, n : INTEGER );
   BEGIN
      WriteRealFile ( stdout, Real, m, n );
   END WriteReal;

   PROCEDURE ReadRealFile ( file : FILE; VAR Real : REAL );
      VAR
         Str : ARRAY [ 0 .. 79 ] OF CHAR;
         err : BOOLEAN;
   BEGIN
      ReadStringFile ( file, Str );
      StrToReal ( Str, Real, err );
      realdone := NOT err;
   END ReadRealFile;

   PROCEDURE ReadReal ( VAR Real : REAL );
   BEGIN
      ReadRealFile ( stdin, Real );
   END ReadReal;

END NewRealInOut.
