(**********************************************************************

:Program.    ZahlenTest
:Contens.    Testprogramm fr NewInOut
:Author.     Bernd Braun
:Address.    Lippestr. 11, D-3300 Braunschweig
:Phone.      0531/845498
:Copyright.  Public Domain
:Language.   Modula-2
:Translator. M2Amiga A+L V3.3d
:Imports.    NewInOut, NewFFPInOut, NewRealInOut, NewLongRealInOut
:History.    V1.0 27.Sep.1989

***********************************************************************)

MODULE ZahlenTest;

   FROM NewInOut IMPORT
      WriteString, WriteLn, ReadInt, ReadLongInt, ReadCard, ReadLongCard,
      WriteInt, WriteCard, done;
   FROM NewFFPInOut IMPORT
      ReadFFP, WriteFFP, ffpdone;
   FROM NewRealInOut IMPORT
      ReadReal, WriteReal, realdone;
   FROM NewLongRealInOut IMPORT
      ReadLongReal, WriteLongReal, longrealdone;
   FROM SYSTEM IMPORT
      FFP;

   VAR
      int      : INTEGER;
      card     : CARDINAL;
      longint  : LONGINT;
      longcard : LONGCARD;
      ffp      : FFP;
      real     : REAL;
      longreal : LONGREAL;

BEGIN
   WriteString ( "ZahlenTest" );
   WriteLn; WriteLn;
   LOOP
      WriteString
      ( "Bitte einen INTEGER eingeben. Null fr weiter." );
      WriteLn;
      ReadInt ( int );
      IF NOT done THEN
         WriteString ( "Ungltige Eingabe!" );
         WriteLn;
      ELSE
         IF int = 0 THEN EXIT END;
         WriteString ( "Sie haben: " );
         WriteInt    ( int , 4 );
         WriteString ( " eingegeben." );
         WriteLn;
      END;
   END;
   LOOP
      WriteString
      ( "Bitte einen CARDINALeingeben. Null fr weiter." );
      WriteLn;
      ReadCard ( card );
      IF NOT done THEN
         WriteString ( "Ungltige Eingabe!" );
         WriteLn;
      ELSE
         IF card = 0 THEN EXIT END;
         WriteString ( "Sie haben: " );
         WriteCard   ( card , 4 );
         WriteString ( " eingegeben." );
         WriteLn;
      END;
   END;
   LOOP
      WriteString
      ( "Bitte einen LONGINT eingeben. Null fr weiter." );
      WriteLn;
      ReadLongInt ( longint );
      IF NOT done THEN
         WriteString ( "Ungltige Eingabe!" );
         WriteLn;
      ELSE
         IF longint = 0 THEN EXIT END;
         WriteString ( "Sie haben: " );
         WriteInt    ( longint , 4 );
         WriteString ( " eingegeben." );
         WriteLn;
      END;
   END;
   LOOP
      WriteString
      ( "Bitte einen LONGCARD eingeben. Null fr weiter." );
      WriteLn;
      ReadLongCard ( longcard );
      IF NOT done THEN
         WriteString ( "Ungltige Eingabe!" );
         WriteLn;
      ELSE
         IF longcard = 0 THEN EXIT END;
         WriteString ( "Sie haben: " );
         WriteCard   ( longcard , 4 );
         WriteString ( " eingegeben." );
         WriteLn;
      END;
   END;
   LOOP
      WriteString
      ( "Bitte einen FFP eingeben. Null fr weiter." );
      WriteLn;
      ReadFFP ( ffp );
      IF NOT ffpdone THEN
         WriteString ( "Ungltige Eingabe!" );
         WriteLn;
      ELSE
         IF ffp = 0.0 THEN EXIT END;
         WriteString ( "Sie haben: " );
         WriteFFP    ( ffp, 14, 4 );
         WriteString ( " eingegeben." );
         WriteLn;
      END;
   END;
   LOOP
      WriteString
      ( "Bitte einen REAL eingeben. Null fr weiter." );
      WriteLn;
      ReadReal ( real );
      IF NOT realdone THEN
         WriteString ( "Ungltige Eingabe!" );
         WriteLn;
      ELSE
         IF real = 0.0 THEN EXIT END;
         WriteString ( "Sie haben: " );
         WriteReal   ( real, 14, 4 );
         WriteString ( " eingegeben." );
         WriteLn;
      END;
   END;
   LOOP
      WriteString
      ( "Bitte einen LONGREAL eingeben. Null fr weiter." );
      WriteLn;
      ReadLongReal ( longreal );
      IF NOT longrealdone THEN
         WriteString ( "Ungltige Eingabe!" );
         WriteLn;
      ELSE
         IF longreal = 0.0 THEN EXIT END;
         WriteString   ( "Sie haben: " );
         WriteLongReal ( longreal, 14, 4 );
         WriteString   ( " eingegeben." );
         WriteLn;
      END;
   END;
END ZahlenTest.
