(* ------------------------------------------------------------------------
  :Program.       MasterMind
  :Contents.      lst MasterMind
  :Author.        Kai Bolay [kai]
  :Address.       Hoffmannstrae 168
  :Address.       7250 Leonberg 1
  :Phone.         07152/22135
  :History.       v1.0  [kai] 04-Aug-90 created
  :Copyright.     FreeWare
  :Language.      Oberon
  :Translator.    OBERON v1.14
  :Remark.        Durchschaut irgendwer diesen Kot???
  :Remark.        Welchen Sinn hat dieses Programm?
  :Bugs.          Bei falschen Eingaben bleibt er manchmal hngen! (wrg)
------------------------------------------------------------------------ *)
MODULE MasterMind;

IMPORT io, Break;

CONST Boxes    = 4;    (* number of boxes *)
      Colors   = 8;    (* number of colors *)

VAR t, p, c : INTEGER; (* try, place, color *)
    l       : LONGINT; (* help-var for ReadInt() *)
    ok      : BOOLEAN; (* ReadInt() result *)
    F       : ARRAY 20, Boxes OF INTEGER; (* Field[try,place] := color *)
    I       : ARRAY 20, 2 OF INTEGER; (* Info[try,what] := number
                                         what=0 : place & color ok
                                         what=1 : only color ok *)

PROCEDURE Possible() : BOOLEAN; (* Is the current combination possible? *)

VAR ct, cp, cp2 : INTEGER; (* checked try, checked place (2) *)
    FI          : ARRAY 2 OF INTEGER; (* found Infos *)

BEGIN
   cp := p-1; (* check places before *)
   WHILE cp >= 0 DO
      IF F[t,cp] = F[t,p] THEN RETURN FALSE END; (* is color used twice? *)
      DEC (cp);
   END; (* WHILE *)
   ct := t-1; (* check all tries before *)
   WHILE ct >= 0 DO
      FI[0] := 0; FI[1] := 0; (* nothing found *)
      cp := 0;                (* check pieces *)
      WHILE cp <= p DO
         cp2 := 0;            (* compare with actual *)
         WHILE cp2 < Boxes DO
            IF F[t,cp] = F[ct,cp2] THEN (* found same color *)
               IF cp = cp2 THEN INC (FI[0]) ELSE INC (FI[1]) END; (* count b/w *)
            END; (* IF *)
            INC (cp2);
         END; (* WHILE *)
         INC (cp);
      END; (* WHILE *)
      IF (FI[0] > I[ct,0]) OR (FI[1] > I[ct,1]) OR (* found more than possible *)
         (I[ct,0]-FI[0]+I[ct,1]-FI[1] >= Boxes-p) THEN RETURN FALSE END;
         (* more undefined than open places *)
      DEC (ct);
   END; (* WHILE *)
   RETURN TRUE;
END Possible;


BEGIN
   t := 0;                       (* first try *)
   p := 0;                       (* start first place *)
   WHILE p < Boxes DO            (* try all places *)
      c := 0;                    (* start first color *)
      WHILE c < Colors DO        (* try all colors *)
         F[t,p] := c;            (* set color in field *)
         IF Possible() THEN      (* is this possible? *)
            IF p = Boxes-1 THEN  (* all positions set? *)
               io.WriteString ("My guess: ");
               p := 0;
               WHILE p < Boxes DO
                  io.WriteInt (F[t,p], 2); (* show the user our opinion *)
                  INC (p);
               END; (* WHILE *)
               io.WriteLn;
               l := -1;
               WHILE (l < 0) OR (l > Boxes) OR NOT (ok) DO (* ask his answer *)
                  io.WriteString ("How many blacks? "); ok := io.ReadInt (l);
               END; (* WHILE *)
               I[t,0] := SHORT (l);
               l := -1;
               WHILE (l < 0) OR (l + I[t,0] > Boxes) OR NOT (ok) DO (* oh yeah! *)
                  io.WriteString ("How many whites? "); ok := io.ReadInt (l);
               END; (* WHILE *)
               I[t,1] := SHORT (l);
               IF I[t,0] = Boxes THEN (* evrything fine? *)
                  io.WriteString ("\[33;1mOk, boy! That's the code...\[0m\n");
                  HALT (0); (* Gotcha! *)
               END; (* IF *)
               INC (t); p := 0; c := -1; (* next try! *)
            ELSE
               c := Colors; (* set next place *)
            END; (* IF *)
         ELSE
            IF c = Colors-1 THEN (* something before was wrong, skip one back *)
               DEC (p);
               IF (p = -1) THEN
                  p := Boxes; (* someone wants to fool us! *)
               ELSE
                  c := F[t,p]; (* restore color *)
               END; (* IF *)
            END; (* IF *)
         END; (* IF *)
         INC (c); (* next color *)
      END; (* WHILE *)
      INC (p); (* next place *)
   END; (* WHILE *)
   io.WriteString ("\x07\[3mYou wanna fool me, eh? No chance!\[0m\n");
   (* Tried everything, but no solution found... that's not possible! *)
END MasterMind.
