(**********************************************************************

    :Program.    Mice
    :Contents.   Zeichnet eine Graphik
    :Author.     Steffen Reith
    :Address.    Hessenstr. 64, D-8700 Wrzburg
    :Language.   Modula-2
    :Translator. M2Amiga A+L V3.2d

**********************************************************************)
(* Dieses Programm wurde durch eine Anregung der Zeitung             *)
(* "Spektrum der Wissenschaften" Ausgabe 2/90 Seite 10 entwickelt    *)

MODULE Mice;

FROM InOut        IMPORT ReadInt,WriteInt,WriteString,WriteLn;
FROM FFPInOut     IMPORT ReadReal,WriteReal;
FROM Intuition    IMPORT NewScreen,ScreenPtr,ScreenFlags,ScreenFlagSet,
                         CloseScreen,OpenScreen,customScreen,IDCMPFlagSet,
                         WindowFlags,OpenWindow,CloseWindow,NewWindow,WindowPtr,
                         IDCMPFlags,WindowFlagSet;
FROM Graphics     IMPORT ViewModes,ViewModeSet,SetAPen,WritePixel,RastPortPtr,
                         RectFill;
FROM SYSTEM       IMPORT ADDRESS,ADR,CAST,FFP;
FROM Arts         IMPORT TermProcedure,Terminate;
FROM Turtle       IMPORT InitTurtleScr,DrawTo,MoveTo,HideTurtle,PenColor;
FROM Dos          IMPORT Delay;

CONST MiceMax=15;
      h=0.08;

TYPE Point=RECORD
            x,y:FFP;
           END;
     f=ARRAY [1..MiceMax] OF Point;
     d=ARRAY[1..MiceMax] OF FFP;

VAR Scr:ScreenPtr;
    Mice:f;
    DeltaX,DeltaY:d;
    n,m,lm,iter:INTEGER;
    Ciapra[0BFE001H] : SET OF (s0,s1,s2,s3,s4,s5,lmb);

PROCEDURE OwnOpenScreen():ScreenPtr;

VAR NScr:NewScreen;
    Scr:ScreenPtr;

BEGIN
 WITH NScr DO
  leftEdge:=0;
  topEdge:=0;
  width:=640;
  height:=512;
  depth:=4;
  detailPen:=0;
  blockPen:=1;
  viewModes:=ViewModeSet{lace,hires};
  type:=customScreen;
  font:=NIL;
  defaultTitle:=ADR('Loving mice');
  gadgets:=NIL;
  customBitMap:=NIL
 END;
 Scr:=OpenScreen(NScr);
 IF Scr=NIL THEN
  WriteString('Unable to open Screen');WriteLn;
  Terminate(0)
 END;
 RETURN(Scr);
END OwnOpenScreen;

PROCEDURE CleanUp();

BEGIN
 IF Scr#NIL THEN CloseScreen(Scr) END
END CleanUp;

PROCEDURE Abort(VAR A,B:d;N:INTEGER):BOOLEAN;

VAR i:INTEGER;
    sum:FFP;

BEGIN
 sum:=0.0;
 FOR i:=1 TO N DO
  sum:=sum+ABS(A[i])+ABS(B[i]);
 END;
 IF (sum<1.0) THEN
  RETURN (TRUE)
 ELSE
  RETURN (FALSE)
 END
END Abort;

BEGIN
 Scr:=NIL;
 iter:=0;
 TermProcedure(CleanUp);
 WriteString('How many mice ? ');
 ReadInt(n);
 IF n>MiceMax THEN
  WriteString('WARNING: Too many mice');WriteLn;
  n:=MiceMax;
  WriteString('Assume ');WriteInt(n,0);WriteLn
 END;
 WriteString('Coordinates between X:[0..640] Y:[0..512]');WriteLn;
 FOR m:=1 TO n DO
  WITH Mice[m] DO
   WriteString('X-Coordinate ');ReadReal(x);
   WriteString('Y-Coordinate ');ReadReal(y)
  END
 END;
 Scr:=OwnOpenScreen();
 InitTurtleScr(Scr);
 HideTurtle();
 LOOP
  MoveTo(INTEGER(Mice[n].x+0.5),INTEGER(Mice[n].y+0.5));
  FOR m:=1 TO n DO
   PenColor(m);
   DrawTo(INTEGER(Mice[m].x+0.5),INTEGER(Mice[m].y+0.5))
  END;
  FOR m:=1 TO n DO
   lm:=(m MOD n)+1;
   DeltaX[m]:=h*(Mice[lm].x-Mice[m].x);
   Mice[m].x:=Mice[m].x+DeltaX[m];
   DeltaY[m]:=(h*(Mice[lm].y-Mice[m].y));
   Mice[m].y:=Mice[m].y+DeltaY[m];
  END;
  IF Abort(DeltaX,DeltaY,n) THEN EXIT END;
 END;
 WriteLn;
 REPEAT UNTIL NOT (lmb IN Ciapra)
END Mice.
