(*---------------------------------------------------------------------------
  :Program.       ReservierteWoerter.mod
  :Contents.      Modul zur Bestimmung, ob es sich bei einem Bezeichner
  :Contents.      um ein Modula-Schlsselwort handelt
  :Date.          24. Juli 1990
  :Copyright.     PD
  :Language.      MODULA-II
  :Translator.    M2Amiga V3.3
  :Remark.        ReservierteWoerter ist Bestandteil von ModList
---------------------------------------------------------------------------*)

IMPLEMENTATION MODULE ReservierteWoerter;

VAR
  ResWort : ARRAY [1..40] OF ARRAY [0..15] OF CHAR;


PROCEDURE ReserviertesWort( bezeichner: ARRAY OF CHAR ): BOOLEAN;
VAR
  von, bis, mitte : [1..40];

  PROCEDURE kleiner(X,Y : ARRAY OF CHAR) : BOOLEAN;
  VAR
    i, Minimum : CARDINAL;
  BEGIN
    IF HIGH(X) < HIGH(Y) THEN
      Minimum := HIGH(X)
    ELSE
      Minimum := HIGH(Y)
    END;
    i := 0;
    WHILE (i < Minimum) AND (X[i] = Y[i]) AND (X[i] # 0C) AND (Y[i] # 0C) DO
      INC(i);
    END;
    RETURN X[i] < Y[i];
  END kleiner;

BEGIN
  von := 1; bis := 40;
  WHILE von # bis DO
    mitte := (von+bis) DIV 2;
    IF kleiner(ResWort[mitte],bezeichner) THEN
      von := mitte+1;
    ELSE
      bis := mitte
    END;
  END;
  RETURN NOT kleiner(ResWort[von], bezeichner) AND
         NOT kleiner(bezeichner,ResWort[von]);
END ReserviertesWort;


BEGIN  (* main *)
  ResWort[ 1]:="AND";            ResWort[21]:="LOOP";
  ResWort[ 2]:="ARRAY";          ResWort[22]:="MOD";
  ResWort[ 3]:="BEGIN";          ResWort[23]:="MODULE";
  ResWort[ 4]:="BY";             ResWort[24]:="NOT";
  ResWort[ 5]:="CASE";           ResWort[25]:="OF";
  ResWort[ 6]:="CONST";          ResWort[26]:="OR";
  ResWort[ 7]:="DEFINITION";     ResWort[27]:="POINTER";
  ResWort[ 8]:="DIV";            ResWort[28]:="PROCEDURE";
  ResWort[ 9]:="DO";             ResWort[29]:="QUALIFIED";
  ResWort[10]:="ELSE";           ResWort[30]:="RECORD";
  ResWort[11]:="ELSIF";          ResWort[31]:="REPEAT";
  ResWort[12]:="END";            ResWort[32]:="RETURN";
  ResWort[13]:="EXIT";           ResWort[33]:="SET";
  ResWort[14]:="EXPORT";         ResWort[34]:="THEN";
  ResWort[15]:="FOR";            ResWort[35]:="TO";
  ResWort[16]:="FROM";           ResWort[36]:="TYPE";
  ResWort[17]:="IF";             ResWort[37]:="UNTIL";
  ResWort[18]:="IMPLEMENTATION"; ResWort[38]:="VAR";
  ResWort[19]:="IMPORT";         ResWort[39]:="WHILE";
  ResWort[20]:="IN";             ResWort[40]:="WITH";
END ReservierteWoerter.mod

