(* Das ComputerMagazin CT- Magazin fuer Computer und Technik bietet eine   *)
(* 68020 CPU mit 68881 Coprozessor zum Kauf via (ESD Vahrenwalderstrasse 7 *)
(* 3000 Hanover 1) fuer den AMIGA. Dazu ist dann noch Statisches RAM zu    *)
(* haben, welches in verschiedenen  Byte-Groessen geliefert werden kann.   *)
(* Das folgende Programm bindet diesen Speicher ins Amiga-System ein, da   *)
(* dieser  den  Speicher mit solchen  hohen  Adressen nicht  automatisch   *)
(* erkennt,  natuerlich ist das lokale Modul Schutzschirm nicht unbedingt  *)
(* noetig, aber sicher ist sicher........                                  *)  
(* from    Andres Staeubli Waltherhauserstr.7 8820 Waedenswil              *)

MODULE PakMem3;

FROM Exec   IMPORT  Node,NodePtr,NodeType, List,ListPtr, MemList,MemListPtr,
                    MemHeader,MemHeaderPtr,MemReqs,MemReqSet, MemChunk,
                    MemChunkPtr,  ExecBasePtr,Disable,Enable,execBase,
                    ExecBase; 
                    
FROM SYSTEM  IMPORT  ADR,ADDRESS;

CONST MemfStatic = MemReqSet{public,fast,mr3}; (* Attribute  *)
      Position    = 40000000H; (* Speicheradresse *) 
      Menge       = 80000H;    (* 512KB *)


 
VAR
      x,y : LONGCARD;
      i : ADDRESS;

MODULE Schutzschirm;

FROM PakMem IMPORT  Node,NodePtr,NodeType, List,ListPtr, MemList,MemListPtr,
                    MemHeader,MemHeaderPtr,MemReqs,MemReqSet, MemChunk,
                    MemChunkPtr,  ExecBasePtr,Disable,Enable,execBase,
                    ExecBase,ADR,ADDRESS,MemfStatic,Position,Menge ; 
                    
 EXPORT MemHeaderInit;                    
                    
VAR 
    PakPtr     : MemHeaderPtr;  (* Statische Variablen *)
    SystemList : ListPtr;                   
    Erster     : MemChunkPtr;
    PakNodePtr : NodePtr;                
    a,b,i      : ADDRESS;
      l        : LONGCARD;
                  
PROCEDURE MemHeaderInit;
BEGIN
  PakPtr^.node.succ := ADR(SystemList^.head^.succ);
   PakPtr^.node.pred := ADR(SystemList^.head);        
     PakPtr^.node.type := memory;
      PakPtr^.node.pri := 20;
       PakPtr^.node.name := ADR("PakMem");
        PakPtr^.attributes := MemfStatic;
           l := (Position+ 80) ;      (* Berechnung der ersten freien Adr. *)
           l := ( l+(8 - (l MOD 8))); i:= l; Erster := i;
          PakPtr^.first := Erster;
           PakPtr^.lower := i; b := Position + Menge -1;
            PakPtr^.upper := b;
             PakPtr^.free := b - i;
               Erster^.next := NIL;
                Erster^.bytes := Position + Menge - l;
                 PakPtr^.node.succ^.pred := a;  (* Vorgaenger auf PakMem *)
                  SystemList^.head := a;        (* setzen und ebenso die *)
END MemHeaderInit;                              (* die SystemListe       *)

BEGIN
   SystemList :=ADR(execBase^.memList);
   a := Position;
   PakPtr := a ;
END Schutzschirm;                           
                        
                                    
                                                

                  
                                                      
BEGIN
   i := Position;  (* Kontrolle ob schon eingebunden, wenn ja, dann Abbruch *)
    IF i <> execBase^.memList.head   THEN
       FOR x := Position TO (Menge + Position) DO   (* Speicher mit 0 fuellen *)
       i:= x ; i^ := 0;
      END; (* END FOR *)
        Disable(); (* Interrupts and Scheduling out *)
        MemHeaderInit; (* Procedur von Schutzschirm holen und Speicher init. *)
    Enable();  (* Wieder einschalten *)                                   
   END; (* END IF *)
   
END PakMem3.mod   

