(*---------------------------------------------------------------------------
  :Program.       PSDemo.mod
  :Author.        Thomas Clever
  :Address.       Brhausen 9, D-5883 Kierspe 3
  :Phone.         02269/7084
  :ShortCut.      [tcl]
  :Version.       1.0
  :Date.          01. Oktober 1990
  :Copyright.     PD
  :Language.      MODULA-II
  :Translator.    M2Amiga V3.3
  :Contents.      Test und Demonstration der PrinterSupport-Routinen
---------------------------------------------------------------------------*)

MODULE PSDemo;

FROM InOut          IMPORT WriteInt, WriteString, WriteLn, Write;
FROM Printer        IMPORT shorp5, shorp6;
FROM PrinterSupport IMPORT OpenPrinter, ClosePrinter, PrinterError, PWrite,
                           PWriteString, PWriteLn, PCommand, openFail, noErr,
                           PWriteInt, PWriteCard, InstallErrorProc,
                           RemoveErrorProc, BreakOnError;

VAR
  error : INTEGER;

BEGIN
  IF OpenPrinter() THEN

    (* automatische Fehlerbehandlung *)
    InstallErrorProc( BreakOnError );

    PWriteString("Ein kurzer Test-Text.");
    PWrite(" ");
    PWrite("-");
    PWrite("-");
    PWriteLn;
    PWriteString("Eine negative Zahl: ");
    PWriteInt( -123, 5 );
    PWriteLn;
    PWriteString("Eine vorzeichenlose ganze Zahl: ");
    PWriteCard( 3002001000, 5 );
    PWriteLn;

    (* Fehlerbehandlung wieder selbst bernehmen *)
    RemoveErrorProc;

    PCommand( shorp6, 0, 0, 0, 0 );  (* Breitschrift einschalten *)
    IF PrinterError() # noErr THEN
      WriteString("Konnte Schrift 'enlarge' nicht einstellen! Fehler-Nr. ");
      WriteInt( PrinterError(), 1 );
      Write(".");
      WriteLn;
    ELSE
      PWriteString("Diesmal ganz breit.");
      PWriteLn;
      PCommand( shorp5, 0, 0, 0, 0 ); (* Breitschrift ausschalten *)
      IF PrinterError() # noErr THEN
        WriteString("Konnte Schrift 'enlarge' nicht ausschalten! Fehler-Nr. ");
        WriteInt( PrinterError(), 1 );
        Write(".");
        WriteLn;
      END;
    END;

    ClosePrinter;

  ELSE

    error := PrinterError();   (* Fehlercode holen *)
    IF error = openFail THEN
      WriteString("Konnte Drucker nicht ffnen!");
      WriteLn;
    ELSE
      WriteString("OpenPrinter() liefert Fehler-Nr. ");
      WriteInt( error, 1 );
      Write(".");
      WriteLn;
    END;

  END;

END PSDemo.mod

