IMPLEMENTATION MODULE Turtle;

FROM Arts IMPORT Assert;

FROM SYSTEM IMPORT ADR;

FROM MathLib IMPORT
	REAL, pi, sin, cos;

FROM MathLib1 IMPORT
	Signum;

FROM Init IMPORT
	InitializeGraphic, CloseGraphic, ClearDevice, ScreenModes, ScrMode;

FROM UG IMPORT
	SetPt2D, Pt2D, DrawLinePQ2D, WI2D, SetInterval2D, Parameter2D,
	DrawCircle;


VAR
  GraphOn, PenDown	: BOOLEAN;
  Kante 		: REAL;

PROCEDURE Error ( i : INTEGER );
VAR Text : ARRAY[1..80] OF CHAR;
BEGIN
  CASE i OF
      1 : Text:="Figur passt nicht mehr ins Bild";
    | 2 : Text:="zu viele Ecken fr nEck";
  ELSE
    Text:="Unbekannter Fehler";
  END;
  Assert(FALSE,ADR(Text));
  HALT;
END Error;


PROCEDURE SetAngle ( w : INTEGER );
BEGIN
  Angle:=w;
  phi:=REAL(w) * pi / 180.0;
END SetAngle;


PROCEDURE SetPhi ( p : REAL );
BEGIN
  phi:=p;
  Angle:=INTEGER(p * 180.0 / pi);
END SetPhi;


PROCEDURE GMode(	ScreenMode : Screens;
			xleftdown, yleftdown, xrightup, yrightup : REAL);
BEGIN
  CASE ScreenMode OF
      low	: ScrMode:=Low;
    | high	: ScrMode:=High;
    | lowlace	: ScrMode:=LowLace;
    | highlace	: ScrMode:=HighLace;
  END;
  SetInterval2D(WI2D, xleftdown, yleftdown, xrightup, yrightup);
  UserSystem:=WI2D;
  IF NOT GraphOn THEN
    InitializeGraphic;
    GraphOn:=TRUE;
    Parameter2D;
  END;
END GMode;


PROCEDURE GraphMode;
BEGIN
  GMode(high,-10.0, -10.0, 10.0, 10.0);
END GraphMode;


PROCEDURE TextMode;
BEGIN
  IF GraphOn THEN
    CloseGraphic;
    GraphOn:=FALSE;
  END;
END TextMode;


PROCEDURE SetColor ( Col : INTEGER );
BEGIN
  Color:=Col;
END SetColor;

PROCEDURE TurnRad ( p : REAL );
  (* Winkel in Bogenma 0..2pi *)
BEGIN
  phi := phi + p;
  WHILE (phi < 0.0) OR (phi > 2.0 * pi) DO
    phi := phi - Signum(phi) * 2.0 * pi;
  END;
  Angle := INTEGER(180.0 * phi / pi);
END TurnRad;


PROCEDURE Turn ( W : INTEGER );
  (* Winkel in Grad 0..360 *)
BEGIN
  Angle := (Angle + W) MOD 360;
  phi := REAL(Angle)*pi/180.0;
END Turn;


PROCEDURE Left ( w : INTEGER );
BEGIN
  Turn(w);
END Left;


PROCEDURE Right ( w : INTEGER );
BEGIN
  Turn(-w);
END Right;


PROCEDURE Forward ( length : REAL );
VAR p : Pt2D;
BEGIN
  p:=Turtle;
  WITH Turtle DO
    X:=X + cos(phi) * length;
    Y:=Y + sin(phi) * length;
  END;
  IF PenDown THEN DrawLinePQ2D(p,Turtle,Color); END;
END Forward;


PROCEDURE Backward ( length : REAL );
BEGIN
  Forward(-length);
END Backward;


PROCEDURE SetTurtle ( x, y : REAL );
BEGIN
  SetPt2D(Turtle,x,y);
END SetTurtle;


PROCEDURE MoveTo ( x, y : REAL );
BEGIN
  SetPt2D(Turtle,x,y);
END MoveTo;

PROCEDURE Up;
BEGIN
  PenDown:=FALSE;
END Up;

PROCEDURE Down;
BEGIN
  PenDown:=TRUE;
END Down;

PROCEDURE DrawTo ( x, y : REAL);
VAR p : Pt2D;
BEGIN
  p:=Turtle;
  SetPt2D(Turtle,x,y);
  IF PenDown THEN DrawLinePQ2D(p,Turtle,Color); END;
END DrawTo;


PROCEDURE ClearScreen;
BEGIN
  ClearDevice;
  Home;
END ClearScreen;


PROCEDURE Home;
BEGIN
  SetTurtle(0.0,0.0);
  SetAngle(0);
END Home;


PROCEDURE max(a, b : REAL) : REAL;
BEGIN
  IF a>b THEN RETURN a
  ELSE RETURN b
  END;
END max;


PROCEDURE Square ( length : REAL );
BEGIN
  Kante:=max(UserSystem[2].X-UserSystem[1].X, UserSystem[2].Y-UserSystem[1].Y);
  IF length > 2.0 * Kante THEN Error(1);
  ELSE
    Forward(length);
    Turn(90);
    Forward(length);
    Turn(90);
    Forward(length);
    Turn(90);
    Forward(length);
    Turn(90);
  END;
END Square;


PROCEDURE Triangle ( length : REAL );
BEGIN
  Kante:=max(UserSystem[2].X-UserSystem[1].X, UserSystem[2].Y-UserSystem[1].Y);
  IF length > 2.0 * Kante THEN Error(1);
  ELSE
    Forward(length);
    Turn(120);
    Forward(length);
    Turn(120);
    Forward(length);
    Turn(120);
  END;
END Triangle;


PROCEDURE nEck ( length : REAL; n : INTEGER );
VAR p : REAL;
    i : INTEGER;
BEGIN
  Kante:=max(UserSystem[2].X-UserSystem[1].X, UserSystem[2].Y-UserSystem[1].Y);
  IF length > 2.0 * Kante THEN Error(1);
  ELSIF n > 360 THEN Error(2);
  ELSE
    p:=2.0*pi/REAL(n);
    Forward(length);
    FOR i:=1 TO n DO
      TurnRad(p);
      Forward(length);
    END;
  END;
END nEck;


PROCEDURE Circle ( MX, MY : REAL; R : REAL );
VAR M : Pt2D;
BEGIN
  M.X:=MX; M.Y:=MY;
  DrawCircle(UserSystem, TRUE, 20, Color, M, R, 0.0, 360.0);
END Circle;

BEGIN
  GraphOn:=FALSE;
  SetColor(9);
  Home;
  Down;
END Turtle.
