IMPLEMENTATION MODULE TurtleTools;

FROM MathLib IMPORT
	REAL;

FROM Turtle IMPORT
	Forward, Backward, Turn, Turtle, Circle, Color, SetColor;


PROCEDURE Koch ( length : REAL; grad : CARDINAL );
VAR l3 : REAL;
BEGIN
  l3:=length/3.0;
  IF (grad = 0) THEN Forward(length);
  ELSE
    Koch(l3,grad-1);
    Turn(60);
    Koch(l3,grad-1);
    Turn(-120);
    Koch(l3,grad-1);
    Turn(60);
    Koch(l3,grad-1);
  END;
END Koch;


PROCEDURE Sierpinski ( length : REAL; grad : CARDINAL );
VAR l2 : REAL;
BEGIN
  l2:=length/2.0;
  IF (grad = 0) THEN Forward(length);
  ELSE
    Turn(60);
    Sierpinski(l2,grad-1);
    Turn(-60);
    Sierpinski(l2,grad-1);
    Turn(-60);
    Sierpinski(l2,grad-1);
    Turn(60);
  END;
END Sierpinski;


PROCEDURE AlternateKoch ( length : REAL; grad : CARDINAL );
VAR l3 : REAL;
BEGIN
  l3:=length/3.0;
  IF (grad = 0) THEN Forward(length);
  ELSE
    AlternateKoch(l3,grad-1);
    Turn(90);
    AlternateKoch(l3,grad-1);
    Turn(-90);
    AlternateKoch(l3,grad-1);
    Turn(-90);
    AlternateKoch(l3,grad-1);
    Turn(90);
    AlternateKoch(l3,grad-1);
  END;
END AlternateKoch;


PROCEDURE Hilbert( length : REAL; grad : INTEGER; w : INTEGER );
BEGIN
  IF grad > 0 THEN
    Turn(-w * 90);
    Hilbert(length,grad-1,-w);
    Forward(length);
    Turn(w * 90);
    Hilbert(length,grad-1,w);
    Forward(length);
    Hilbert(length,grad-1,w);
    Turn(w * 90);
    Forward(length);
    Hilbert(length,grad-1,-w);
    Turn(-w * 90);
  END;
END Hilbert;



PROCEDURE Tree( length : REAL; grad : INTEGER );
BEGIN
  IF grad>0 THEN
    Turn(-45);
    Forward(length);
    Tree(length/2.0,grad-1);
    Backward(length);
    Turn(90);
    Forward(length);
    Tree(length/2.0,grad-1);
    Backward(length);
    Turn(-45);
  END;
END Tree;



PROCEDURE Drake( length : REAL; grad : INTEGER );
BEGIN
  IF grad=0 THEN
    Forward(length);
  ELSIF grad>0 THEN
    Drake(length,grad-1);
    Turn(90);
    Drake(length,-(grad-1));
  ELSE
    Drake(length,-(grad+1));
    Turn(270);
    Drake(length,grad+1);
  END;
END Drake;



PROCEDURE Blatt ( length : REAL; Col : INTEGER );
VAR OldCol : INTEGER;
BEGIN
  OldCol:=Color;
  SetColor(Col);
  Circle(Turtle.X, Turtle.Y, length/2.0);
  SetColor(OldCol);
END Blatt;

PROCEDURE Stiel(length : REAL);
BEGIN
  Forward(length);
  Blatt(length/2.0,2);
  Backward(length);
END Stiel;


PROCEDURE GraphtalePflanze( length : REAL; grad : CARDINAL; Move : Movings  );
VAR
  k : INTEGER;
BEGIN
  IF (grad<=1) THEN
    CASE Move OF
        left :
        	Turn(45);
        	Stiel(length);
        	Turn(-45);
      | right :
      		Turn(-45);
      		Stiel(length);
      		Turn(45);
      | straighton :
      		Stiel(length);
    END;
  ELSE
    CASE Move OF
        left :
        	Turn(45);
        	GraphtalePflanze(length,grad,straighton);
        	Turn(-45);
      | right :
      		Turn(-45);
      		GraphtalePflanze(length,grad,straighton);
      		Turn(45);
      | straighton :
		Forward(length);
		GraphtalePflanze(length,grad-1,left);
		Forward(length);
		GraphtalePflanze(length,grad-1,right);
		GraphtalePflanze(length,grad-1,straighton);
		Backward(2.0*length);
    END;
  END;
END GraphtalePflanze;



BEGIN
END TurtleTools.
