MODULE TurtleToolsTest;

FROM InOut IMPORT
	ReadInt, WriteString, WriteLn, Read, Write;

FROM MathLib IMPORT
	REAL, pow;

FROM TurtleTools IMPORT
	Koch, Sierpinski, AlternateKoch, Hilbert, Drake, Tree,
	GraphtalePflanze, straighton, Squares, Triangles;

FROM Turtle IMPORT
	GraphMode, TextMode, SetTurtle, SetAngle;


VAR
  i, j 		: INTEGER;
  breite, l	: REAL;
  c		: CHAR;

BEGIN
  WriteString("Bitte machen Sie dieses Fenster gro und drcken Sie Return.");
  Read(c);
  WriteString("Dieses Programm zeichnet Fraktale Kurven."); WriteLn;
  WriteLn;
  WriteLn;
  WriteString(" 1990 Ingo Schtze"); WriteLn;
  WriteLn;
  WriteString("Bei Fragen:"); WriteLn;
  WriteString("Ingo Schtze"); WriteLn;
  WriteString("Grabenstrae 29"); WriteLn;
  WriteString("D-6301 Biebertal"); WriteLn;
  WriteString("06409-2882"); WriteLn;
  WriteLn;

  i:=1;
  j:=1;
  breite:=20.0; (* UserSystem-breite *)
  WHILE (j>0) AND (j<10) DO
    WriteString("[0] Ende"); WriteLn;
    WriteString("[1] Koch"); WriteLn;
    WriteString("[2] Sierpinski"); WriteLn;
    WriteString("[3] Koch2"); WriteLn;
    WriteString("[4] Hilbert"); WriteLn;
    WriteString("[5] Baum"); WriteLn;
    WriteString("[6] Pflanze"); WriteLn;
    WriteString("[7] Drachen"); WriteLn;
    WriteString("[8] Iterierte Dreiecke"); WriteLn;
    WriteString("[9] Iterierte Quadrate"); WriteLn;
    WriteString("[10..] Ende"); WriteLn;
    ReadInt(j);
    IF (j>0) AND (j<10) THEN
      REPEAT
        WriteString("Warnung: Bei zu groen Werten dauert es lange!!");
        WriteLn; WriteLn;
        WriteString("Kurve welchen Grades (0=neuer Kurventyp) :");
        ReadInt(i);
        IF (i > 0) THEN
          GraphMode;
          CASE j OF
              1 :
              	SetTurtle(-8.0,-8.0);
              	SetAngle(0);
		Koch(16.0,i);

            | 2 :
            	SetTurtle(-8.0,-8.0);
            	SetAngle(0);
		Sierpinski(16.0,i);

            | 3 :
            	SetTurtle(-8.0,-8.0);
            	SetAngle(0);
		AlternateKoch(16.0,i);

            | 4 :
            	l:=breite/pow(2.0,REAL(i+1));
          	SetTurtle(-8.0,-8.0);
          	SetAngle(90);
          	Hilbert(l,i,1);

            | 5 :
            	l:=breite/(1.0 + REAL(i));
          	SetTurtle(0.0, -5.0);
          	SetAngle(90);
          	Tree(l,i);

            | 6 :
            	SetTurtle(0.0,-2.0);
          	SetAngle(90);
          	GraphtalePflanze(0.5,i,straighton);

            | 7 :
            	l:=breite/( 2.0 * (REAL(i)) * (REAL(i)) );
            	SetAngle(0);
		SetTurtle(0.0,0.0);
          	Drake(l,i);
            | 8 :
            	SetTurtle(-8.0,-8.0);
            	SetAngle(0);
            	Triangles(16.0,i);
            | 9 :
                SetTurtle(-8.0,-8.0);
            	SetAngle(0);
                Squares(16.0,i);
          END;
        END;
      TextMode;
      UNTIL (i<=0);
    END;
  END;
END TurtleToolsTest.
