(**********************************************************************

    :Program.    Assigndev.mod
    :Contents.   Changes two devices
    :Author.     Gerhard 'Fido' Schneider
    :Address.    Schadewitzstrae 22, D-8700 Wrzburg
    :Copyright.  Buplik Tomain
    :Language.   Modula-2
    :Translator. M2Amiga A+L V3.2d
    :History.    Unknown

**********************************************************************)
MODULE AssignDev;

IMPORT Dos;
FROM Dos       IMPORT DosLibrary,DosLibraryPtr,DeviceList,DeviceListPtr,
                      DosInfo,DosInfoPtr,RootNode,RootNodePtr,DeviceListType,
                      BSTR;
FROM Exec      IMPORT AllocMem,FreeMem,MemReqs,MemReqSet;
FROM SYSTEM    IMPORT ADR,ADDRESS,BPTR;
FROM Terminal  IMPORT WriteString,WriteLn;
FROM Str       IMPORT Compare,Length,CapString,Concat;
FROM Arguments IMPORT NumArgs,GetArg;

TYPE String=ARRAY[0..255] OF CHAR;
     StringFeld=ARRAY[0..1] OF String;
     DevFeld=ARRAY[0..1] OF DeviceListPtr;

PROCEDURE BSTRtoSTRING(VAR StringPtr:BSTR;VAR Name:String);
VAR i,Len:INTEGER;
BEGIN
 Len:=INTEGER(StringPtr^[0]);
 FOR i:=1 TO Len DO
  Name[i-1]:=StringPtr^[i]
 END;
 Name[Len]:=0C
END BSTRtoSTRING;

PROCEDURE STRINGtoBSTR(VAR Name:String;VAR StringPtr:BSTR);
VAR i,Len:INTEGER;
    help:CHAR;
BEGIN
 Len:=Length(Name);
 StringPtr^[0]:=CHAR(Len);
 FOR i:=1 TO Len DO
  help:=Name[i-1];
  StringPtr^[i]:=help
 END
END STRINGtoBSTR;

PROCEDURE RecordCopy(VAR Rec0,Rec1:DeviceListPtr);
BEGIN
 Rec0^.type:=Rec1^.type;
 Rec0^.task:=Rec1^.task;
 Rec0^.lock:=Rec1^.lock;
 Rec0^.handler:=Rec1^.handler;
 Rec0^.stackSize:=Rec1^.stackSize;
 Rec0^.priority :=Rec1^.priority;
 Rec0^.startup:=Rec1^.startup;
 Rec0^.segList:=Rec1^.segList;
 Rec0^.globVec:=Rec1^.globVec;
END RecordCopy;

VAR dosLibPtr:DosLibraryPtr;
    rootNodePtr:RootNodePtr;
    dosInfoPtr:DosInfoPtr;
    deviceListPtr,devPtr,lastPtr:DeviceListPtr;
    dev,last:DevFeld;
    Name,BName:String;
    Assign:StringFeld;
    i,Num,Dummy:INTEGER;
    NewPtr:ADDRESS;

BEGIN
LOOP
 Num:=NumArgs();
 IF Num>1 THEN
  GetArg(1,Assign[0],Dummy);
  GetArg(2,Assign[1],Dummy);
  CapString(Assign[0]);
  CapString(Assign[1]);
  BName:=Assign[0];
  Concat(BName,'.B');
 ELSIF Num=1 THEN
  GetArg(1,Name,Dummy);
  IF Name[0]='?' THEN
   GetArg(0,Name,Dummy);
   WriteString(Name);WriteString(' <DEVICVE1> <DEVICE2>');WriteLn;
   WriteString('Weist einem Device ein anderes zu. ZB: CON NEWCON, CON PAR');
   WriteString(' oder DF0 RAM.');WriteLn;
   WriteString('Zugewiesenes DEVICE1 wird unter DEVICE1.B in der Liste abge');
   WriteString('legt und kann');WriteLn;
   WriteString('wieder zurueckzugewiesen werden.');WriteLn;
   EXIT
  ELSE
   WriteString('Bad parameter');WriteLn;
   EXIT
  END
 ELSE
  WriteString('Bad parameter');WriteLn;
  EXIT
 END;
 dosLibPtr:=ADR(Dos);
 rootNodePtr:=dosLibPtr^.root;
 dosInfoPtr:=rootNodePtr^.info;
 deviceListPtr:=dosInfoPtr^.devInfo;
 FOR i:=0 TO 1 DO
  dev[i]:=NIL;
  last[i]:=NIL;
  Num:=Length(Assign[i])-1;
  IF Assign[i][Num]=':' THEN
   Assign[i][Num]:=0C
  END;
  devPtr:=deviceListPtr;
  lastPtr:=NIL;
  WHILE devPtr#NIL DO
   IF (devPtr^.type=device) THEN
    BSTRtoSTRING(devPtr^.name,Name);
    IF (Compare(Name,BName)=0) AND (Compare(Assign[1],BName)#0) THEN
     WriteString(Assign[0]);WriteString(' is already assigned');WriteLn;
     EXIT;
    END;
    IF Compare(Name,Assign[i])=0 THEN
     dev[i]:=devPtr;
     last[i]:=lastPtr
    END
   END;
   lastPtr:=devPtr;
   devPtr:=devPtr^.next
  END;
  IF dev[i]=NIL THEN
   WriteString(Assign[i]);WriteString(' not found');WriteLn;
   EXIT
  END;
 END;
 IF Compare(BName,Assign[1])#0 THEN
  NewPtr:=AllocMem(SIZE(DeviceList),MemReqSet{});
  devPtr:=DeviceListPtr(BPTR(NewPtr));
  NewPtr:=AllocMem(SIZE(BSTR),MemReqSet{});
  devPtr^.name:=BSTR(BPTR(NewPtr));
  RecordCopy(devPtr,dev[0]);
  STRINGtoBSTR(BName,devPtr^.name);
  devPtr^.next:=dosInfoPtr^.devInfo;
  dosInfoPtr^.devInfo:=devPtr;
  RecordCopy(dev[0],dev[1])
 ELSE
  RecordCopy(dev[0],dev[1]);
  IF last[1]=NIL THEN
   dosInfoPtr^.devInfo:=dev[1]^.next
  ELSE
   last[1]^.next:=dev[1]^.next
  END;
  NewPtr:=ADDRESS(BPTR(dev[1]^.name));
  FreeMem(NewPtr,SIZE(BSTR));
  NewPtr:=ADDRESS(BPTR(dev[1]));
  FreeMem(NewPtr,SIZE(DeviceList));
 END;
 EXIT
END
END AssignDev.

