(**********************************************************************

    :Program.    Config.mod
    :Contents.   Configuration of M2CED
    :Author.     Steffen Reith
    :Address.    Hessenstr. 64, D-8700 Wrzburg
    :Copyright.  Shareware
    :Language.   Modula-2
    :Translator. M2Amiga A+L V3.2d
    :Imports.    req,Msg
    :History.    V1.0 18.June 1990

**********************************************************************)
(* $S- $F- $N- $R- $V- *)
IMPLEMENTATION MODULE Config;

FROM Dos    IMPORT Open,Close,FileHandlePtr,oldFile,Read,Write,newFile;
FROM SYSTEM IMPORT ADR,ADDRESS;
FROM Msg    IMPORT TitleMsg;
FROM req    IMPORT PathType;

CONST Restart='S:M2CED.restart';

PROCEDURE ReadConfig(VAR Parameters:P); (* Prg-configuration lesen *)

VAR Dummy:LONGINT;
    File:FileHandlePtr;

BEGIN
 File:=Open(ADR(ConfigFile),oldFile);
 IF File#NIL THEN
  Dummy:=Read(File,ADR(Parameters),SIZE(P));
  Close(File)
 ELSE
  WITH Para DO
   Window:=WindowDefault;
   ContMsg:=ContMsgDefault;
   compileN:=compileDefault;
   linkN:=linkDefault;
   startN:=startDefault;
   loadN:=loadDefault;
   findErrorN:=findErrorDefault;
   cancelN:=cancelDefault;
   continueN:=continueDefault
  END
 END
END ReadConfig;

PROCEDURE WriteFile(VAR File:PathType);

VAR FileHandle:FileHandlePtr;
    Dummy:LONGINT;

BEGIN
 FileHandle:=Open(ADR(Restart),newFile);
 IF FileHandle#NIL THEN
  Dummy:=Write(FileHandle,ADR(File),SIZE(PathType));
  Close(FileHandle)
 ELSE
  TitleMsg('Kann Restartfile nicht schreiben')
 END
END WriteFile;

PROCEDURE ReadFile (VAR File:PathType);

VAR FileHandle:FileHandlePtr;
    Dummy:LONGINT;

BEGIN
 FileHandle:=Open(ADR(Restart),oldFile);
 IF FileHandle#NIL THEN
  Dummy:=Read(FileHandle,ADR(File),SIZE(PathType));
  Close(FileHandle)
 ELSE
  TitleMsg('Kann Restartfile nicht finden')
 END
END ReadFile;

BEGIN
 ReadConfig(Para);
END Config.
