(**********************************************************************

    :Program.    Keys.mod
    :Contents.   Wait for hotkey
    :Author.     Steffen Reith
    :Address.    Hessenstr. 64, D-8700 Wrzburg
    :Copyright.  Shareware
    :Language.   Modula-2
    :Translator. M2Amiga A+L V3.2d
    :Imports.    Msg, Config
    :History.    V1.0  7.June 1990

**********************************************************************)
(* $S- $F- $N- $R- $V- *)
IMPLEMENTATION MODULE Keys;

FROM Arts        IMPORT TermProcedure;
FROM Exec        IMPORT MsgPort,MsgPortPtr,IOStdReqPtr,IOStdReq,FindTask,DoIO,
                        Forbid,Permit,AllocSignal,OpenDevice,CloseDevice,
                        Interrupt,FreeSignal,Task,TaskPtr,Signal,Wait;
FROM ExecSupport IMPORT CreatePort,CreateStdIO,DeletePort,DeleteStdIO;
FROM SYSTEM      IMPORT ADR,ADDRESS,LONGSET,SETREG;
FROM Input       IMPORT inputName,addHandler,remHandler;
FROM InputEvent  IMPORT InputEvent,InputEventPtr,Qualifiers,QualifierSet,Class;
FROM Msg         IMPORT EndRequest;
FROM Config      IMPORT Para;

VAR Port:MsgPortPtr;
    Request:IOStdReqPtr;
    HandlerStuff:Interrupt;
    SigNum:LONGINT;
    Sig:LONGSET;
    OwnTask:TaskPtr;
    Open:BOOLEAN;

    Event:Action;
    Report:BOOLEAN;

(* $S- $V- $F- *)
PROCEDURE Handler(event{8}:InputEventPtr):InputEventPtr;

CONST MaxCode=060H;

VAR Own:InputEventPtr;

BEGIN
 Own:=event; (* sofort sichern !! *)
 IF Report THEN
  IF (Own^.class=rawkey)       AND
     ((lAlt IN Own^.qualifier) OR (rAlt IN Own^.qualifier)) AND
     (Own^.code < MaxCode)     THEN
   IF Own^.code=Para.compileN THEN
    Event:=compile;Signal(OwnTask,Sig);RETURN(NIL)
   ELSIF Own^.code=Para.linkN THEN
    Event:=link;Signal(OwnTask,Sig);RETURN(NIL)
   ELSIF Own^.code=Para.startN THEN
    Event:=start;Signal(OwnTask,Sig);RETURN(NIL)
   ELSIF Own^.code=Para.loadN THEN
    Event:=load;Signal(OwnTask,Sig);RETURN(NIL)
   ELSIF Own^.code=Para.findErrorN THEN
    Event:=findError;Signal(OwnTask,Sig);RETURN(NIL)
   ELSIF Own^.code=Para.cancelN THEN
    Event:=cancel;Signal(OwnTask,Sig);RETURN(NIL)
   ELSIF Own^.code=Para.continueN THEN
    Event:=continue;Signal(OwnTask,Sig);RETURN(NIL);
   ELSE
    RETURN (Own) (* Inputevent in D0 weitergeben *)
   END
  END
 END;
 RETURN Own (* Inputevent in D0 weitergeben *)
END Handler;
(* $S+ $V+ $F+ *)

PROCEDURE CleanUp();

BEGIN
 IF Open THEN
  Request^.command:=remHandler;
  Request^.data:=ADR(HandlerStuff);
  DoIO(Request);
  CloseDevice(Request);
 END;

 IF Request#NIL THEN DeleteStdIO(Request) END;
 IF Port#NIL    THEN DeletePort(Port)     END;
 IF SigNum#-1   THEN FreeSignal(SigNum)   END;

END CleanUp;

PROCEDURE KeyPressed():Action;

VAR S:LONGSET;

BEGIN
 Report:=TRUE; (* Auf Tastaturevent warten *)
 S:=Wait(Sig);
 Report:=FALSE;
 RETURN Event
END KeyPressed;

BEGIN
 TermProcedure(CleanUp);
 Report:=FALSE;Open:=FALSE;
 Port:=NIL; Request:=NIL;SigNum:=-1;
 OwnTask:=FindTask(NIL);

 Port:=CreatePort(ADR('Key_Port'),0);
 IF Port=NIL THEN
  EndRequest('Kein MsgPort verfuegbar!!')
 END;

 Request:=CreateStdIO(Port);
 IF Request=NIL THEN
  EndRequest('Kein Requeststuktur')
 END;

 OpenDevice(ADR(inputName),0,Request,LONGSET{});
 IF (Request^.error#0) THEN
  EndRequest('Kann Inputdevice nicht oeffnen')
 END;
 Open:=TRUE;

 WITH HandlerStuff DO
  code:=ADR(Handler);
  data:=NIL;
  node.pri:=60;
  node.name:=ADR('Kyrons_Handler');
 END;
 Request^.command:=addHandler;
 Request^.data:=ADR(HandlerStuff);
 DoIO(Request);
 IF(Request^.error#0) THEN
  EndRequest('Kann Handler nicht installieren')
 END;

 SigNum:=AllocSignal(-1);
 IF SigNum=-1 THEN
  EndRequest('Multitasking System ueberlastet')
 END;
 Sig:=LONGSET{SigNum};
END Keys.
