(**********************************************************************

    :Program.    Prim
    :Contents.   Schnelles Sieb des Eratosthenes
    :Author.     Steffen Reith
    :Address.    Hessenstr. 64, D-8700 Wrzburg
    :Language.   Modula-2
    :Translator. M2Amiga A+L V3.2d

**********************************************************************)
MODULE Prim;

FROM InOut    IMPORT WriteCard,WriteLn,WriteString,WriteInt;
FROM MathLib0 IMPORT sqrt;
FROM Exec     IMPORT Forbid,Permit;

CONST n=10000/2;
(* 2*n-2 gibt den Bereich in dem gesucht werden soll *)

VAR lauf,High,wert,Zeiger,NPrim:LONGCARD;
    Feld:ARRAY[1..n] OF BOOLEAN;

BEGIN

 WriteString ('Dieses Programm berechnet die Primzahlen von 2 bis');
 WriteCard (2*n,7);
 WriteLn;

 FOR lauf:=1 TO n DO
  Feld[lauf]:=TRUE;
 END;
 Zeiger:=3;
 wert:=3;
 High:=TRUNC(sqrt(REAL(n)));

 Forbid(); (* Nicht ganz fein, aber wirksam *)
 WHILE (Zeiger<=High) DO
  lauf:=Zeiger;
  REPEAT
   lauf:=lauf+wert;
   Feld[lauf]:=FALSE;
  UNTIL (lauf+wert>=n);
  REPEAT INC(Zeiger) UNTIL (Feld[Zeiger]);
  wert:=2*Zeiger-3;
 END;
 Permit();

 NPrim:=0;
 WriteString('        2');WriteLn;
 FOR lauf:=3 TO n DO
  IF Feld[lauf] THEN
   WriteCard(2*lauf-3,10);
   WriteLn;
   INC(NPrim);
  END
 END;
 WriteString('Es gibt im angegebenen Bereich ');
 WriteCard(NPrim,0);WriteString(' Primzahlen');WriteLn;

END Prim.
