(**********************************************************************

    :Program.    Print.mod
    :Contents.   Sends a textfile via PRT: to Printer
    :Author.     Gerhard 'Fido' Schneider/Kyron Dickflieger
    :Address.    Schadewitzstrae 22, D-8700 Wrzburg
    :Copyright.  Buplic Tomain
    :Language.   Modula-2
    :Translator. M2Amiga A+L V3.2d
    :Imports.    req, Arp
    :History.    V2.1

**********************************************************************)

(* $S- $R- *)
MODULE Print;

IMPORT Intuition;
FROM Arguments       IMPORT GetArg,NumArgs;
FROM Dos             IMPORT Lock,UnLock,Open,Close,Read,Write,oldFile,newFile,
                            FileHandlePtr,sharedLock,FileLockPtr,
                            Examine,FileInfoBlockPtr,FileInfoBlock,Delay;
FROM Intuition       IMPORT WindowPtr,Window,IntuitionBasePtr,SetWindowTitles,
                            Screen,GetPrefs,Preferences,PreferencesPtr,
                            NewWindow,OpenWindow,CloseWindow,ScreenFlags,
                            ScreenFlagSet,WindowFlags,WindowFlagSet,IDCMPFlags,
                            IDCMPFlagSet,IntuiMessage,IntuiMessagePtr;
FROM SYSTEM          IMPORT ADR,ADDRESS;
FROM Str             IMPORT Length,Concat;
FROM RealConversions IMPORT RealToStr;
FROM Conversions     IMPORT ValToStr;
FROM Heap            IMPORT Allocate,Deallocate;
FROM Arts            IMPORT DetectCtrlC,Terminate,TermProcedure;
FROM Exec            IMPORT GetMsg,ReplyMsg;
FROM Arp             IMPORT EscapeString,Puts,Printf;
FROM Req             IMPORT FRequest,FileRequester,DirType,FileType,PathType,
                            FileRequestFlags,FileRequestFlagSet,TextRequest,
                            TRStructure,Center,GadgetBlock,LinkGadget;

CONST
 Laenge=128;
 Version='Print V2.1,  by Fido & Kyron 1990';
 ReqMsg='Hal 9000 sagt: ';

TYPE String=ARRAY[0..127] OF CHAR;
     StrPtr=POINTER TO String;

VAR Num,Len,Anz,GadNo:INTEGER;
    NumSize,P:LONGINT;
    Arg,BName,Size,Title,Title2,NewTitle,Proz,PaperLength:String;
    FilePtr,ParPtr:FileHandlePtr;
    Buffer:ARRAY[0..Laenge-1] OF CHAR;
    CLR,LF,ON,OFF,PERFOFF:String;
    WinPtr:WindowPtr;
    IntBasePtr:IntuitionBasePtr;
    LockPtr:FileLockPtr;
    InfoPtr:FileInfoBlockPtr;
    Du:BOOLEAN;
    OldTitlePtr,OldTitle2Ptr:ADDRESS;
    a,b:REAL;
    File: FileType;
    Dir: DirType;
    Prefs:Preferences;
    PrefPtr:PreferencesPtr;
    TR1:TRStructure;
    OwnWin:NewWindow;
    Win:WindowPtr;
    Gad:GadgetBlock;
    MsgPtr:IntuiMessagePtr;
    OwnFile:FRequest;

PROCEDURE ExtractFileName(VAR FileName:String);

VAR i,j,Len:INTEGER;
    Dummy:String;

BEGIN
 Len:=Length(FileName);
 IF Len=0 THEN
  RETURN
 END;
 i:=Len-1;
 LOOP
  IF (FileName[i]=':') OR (FileName[i]='/') THEN
   FOR j:=i+1 TO Len DO
    Dummy[j-i-1]:=FileName[j];
   END;
   FileName:=Dummy;
   EXIT
  END;
  IF i=0 THEN
   EXIT
  ELSE
   DEC(i)
  END;
 END;
END ExtractFileName;

PROCEDURE FileReq(VAR File:FileType;VAR Dir:DirType);

VAR path:PathType;
    Flag:BOOLEAN;

BEGIN
 WITH OwnFile DO
  versionNumber:=0;
  window:=NIL;
  title:=ADR(Version);
  dir:=ADR(Dir);
  file:=ADR(File);
  pathName:=ADR(path);
  flags:=FileRequestFlagSet{InfoGadget};
  dirNamesColor:=2;
  hide:='*.info';
  show:='*'
 END;
 Flag:=FileRequester(OwnFile);
 IF NOT(Flag) THEN
  File:=0C
 END;
END FileReq;

PROCEDURE CleanUp();

BEGIN
 IF ParPtr#NIL  THEN Close(ParPtr) END;
 IF FilePtr#NIL THEN Close(FilePtr) END;
 IF InfoPtr#NIL THEN Deallocate(InfoPtr) END;
 IF Win#NIL     THEN CloseWindow(Win) END
END CleanUp;

BEGIN
 ParPtr:=NIL;
 FilePtr:=NIL;
 Win:=NIL;
 InfoPtr:=NIL;
 DetectCtrlC(FALSE);
 TermProcedure(CleanUp);
 IntBasePtr:=ADR(Intuition);
 WinPtr:=IntBasePtr^.activeWindow;
 OldTitlePtr:=WinPtr^.title;
 OldTitle2Ptr:=WinPtr^.wScreen^.title;
 PrefPtr:=ADR(Prefs);
 GetPrefs(PrefPtr,SIZE(Prefs));
 ValToStr(PrefPtr^.paperType,FALSE,PaperLength,10,3,' ',Du);
 CLR:=CHAR(12);LF:=12C;
 ON:='*E[1m*E[4m*E[';
 Concat(ON,PaperLength);
 Concat(ON,'t*E#9');
 OFF:='*E[0m';PERFOFF:='*E[0q';
 Len:=EscapeString(ADR(ON));
 Len:=EscapeString(ADR(OFF));
 Len:=EscapeString(ADR(PERFOFF));

 Num:=NumArgs();
 IF Num>0 THEN
  GetArg(1,Arg,Len);
  IF Arg[0]='?' THEN
   GetArg(0,Arg,Len);
   P:=Printf(ADR(Arg),NIL);
   P:=Puts(ADR(' Filename. Kopiert File nach PRT,'));
   P:=Puts(ADR('bercksichtigt LEFT MARGIN in den Preferences zum Einrcken,'));
   P:=Puts(ADR('bercksichtigt PAPERSIZE/LENGTH in den Preferences,'));
   P:=Puts(ADR('macht Perforationssprung mit LENGTH Zeilen,'));
   P:=Puts(ADR('zeigt aktuellen Stand der Ausgabe prozentual im Rahmen an,'));
   P:=Puts(ADR('bei Aufruf ohne Parameter erscheint Filerequester,'));
   P:=Puts(ADR('ermglicht schnellen Druck bei autom. Einzelblatteimzgen,'));
   P:=Puts(ADR('wirft Papier bei Druckende aus,'));
   P:=Puts(ADR('bentigt ARP.library 34.0! und req.library 1!'));
   P:=Puts(ADR(Version));
   Terminate(0)
  END;
 ELSE
  File:='';
  Dir:='';
  Arg:='';
  FileReq(File,Dir);
  IF Length(File)=0 THEN Terminate(0) END;
  IF Length(Dir)>0 THEN
   Concat(Arg,Dir);
   IF Arg[Length(Arg)-1] # ':' THEN
   Concat(Arg,'/')
   END
  END;
 Concat(Arg,File);
 END;
 LockPtr:=Lock(ADR(Arg),sharedLock);
 IF LockPtr=NIL THEN
  WITH TR1 DO
   text:=ADR('File kann nicht geffnet werden!');
   controls:=NIL;
   middleText:=NIL;
   positivText:=NIL;
   negativText:=ADR('Geht Klar');
   title:=ADR('ReqMsg');
   window:=NIL
  END;
  GadNo:=TextRequest(TR1);
  Terminate(0)
 END;
 Allocate(InfoPtr,SIZE(FileInfoBlock));
 Du:=Examine(LockPtr,InfoPtr);
 IF NOT Du THEN
  WITH TR1 DO
   text:=ADR('Fatal Error!');
   controls:=NIL;
   middleText:=NIL;
   positivText:=NIL;
   negativText:=ADR('Sorry!');
   title:=ADR('ReqMsg');
   window:=NIL
  END;
  GadNo:=TextRequest(TR1);
  Terminate(0)
 END;
 Title:='File length:';
 Title2:='Printing ';
 NumSize:=InfoPtr^.size;
 ValToStr(NumSize,FALSE,Size,10,6,' ',Du);
 Concat(Title,Size);
 Concat(Title,' bytes.');
 Concat(Title2,Arg);
 UnLock(LockPtr);
 FilePtr:=Open(ADR(Arg),oldFile);
 IF FilePtr=NIL THEN
  WITH TR1 DO
   text:=ADR('Kann File nicht ffnen!');
   controls:=NIL;
   middleText:=NIL;
   positivText:=NIL;
   negativText:=ADR(' OK ');
   title:=ADR('ReqMsg');
   window:=NIL
  END;
  GadNo:=TextRequest(TR1);
  Terminate(0)
 END;
 ParPtr:=Open(ADR('PRT:'),newFile);
 IF ParPtr=NIL THEN
  WITH TR1 DO
   text:=ADR('Kann PRT: nicht ffnen!');
   controls:=NIL;
   middleText:=NIL;
   positivText:=NIL;
   negativText:=ADR('Check It');
   title:=ADR('ReqMsg');
   window:=NIL
  END;
  GadNo:=TextRequest(TR1);
  Terminate(0)
 END;
 SetWindowTitles(WinPtr,ADR(Title),ADR(Title2));
 ExtractFileName(Arg);
 Len:=Write(ParPtr,ADR(ON),Length(ON));
 Len:=Write(ParPtr,ADR(Arg),Length(Arg));
 Len:=Write(ParPtr,ADR(OFF),Length(OFF));
 Len:=Write(ParPtr,ADR(LF),1);
 Len:=Write(ParPtr,ADR(LF),1);
 Concat(Title,' Now');
 a:=REAL(Laenge)/REAL(NumSize)*100.0;
 b:=100.00;

 WITH OwnWin DO
  width:=150;
  height:=25;
  detailPen:=0;
  blockPen:=1;
  idcmpFlags:=IDCMPFlagSet{gadgetDown,gadgetUp};
  flags:=WindowFlagSet{windowDrag,windowDepth,activate,noCareRefresh};
  firstGadget:=NIL;
  checkMark:=NIL;
  title:=ADR('Printing ..');
  screen:=NIL;
  bitMap:=NIL;
  minWidth:=10;
  minHeight:=10;
  maxWidth:=100;
  maxHeight:=100;
  type:=ScreenFlagSet{wbenchScreen}
 END;
 Center(OwnWin,0,0);
 LinkGadget(Gad,ADR('ABORT'),OwnWin,50,13);
 Win:=OpenWindow(OwnWin);
 IF Win=NIL THEN
  WITH TR1 DO
   text:=ADR('Kann Hilfswindow nicht oeffnen');
   controls:=NIL;
   middleText:=NIL;
   positivText:=NIL;
   negativText:=ADR('No Panic!!');
   title:=ADR('ReqMsg');
   window:=NIL
  END;
  GadNo:=TextRequest(TR1);
  Terminate(0)
 END;

 Len:=Read(FilePtr,ADR(Buffer),Laenge);
 WHILE Len>0 DO

  MsgPtr:=GetMsg(Win^.userPort);
  IF (MsgPtr#NIL) THEN
   ReplyMsg(MsgPtr);
   SetWindowTitles(WinPtr,OldTitlePtr,OldTitle2Ptr);
   Terminate(0)
  END;

  Anz:=Write(ParPtr,ADR(Buffer),Len);
  RealToStr(b,Proz,7,2,FALSE,Du);
  NewTitle:=Title;
  Concat(NewTitle,Proz);
  Concat(NewTitle,'% to go...');
  SetWindowTitles(WinPtr,ADR(NewTitle),-1);
  Len:=Read(FilePtr,ADR(Buffer),Laenge);
  b:=b-a;
 END;

 Len:=Write(ParPtr,ADR(PERFOFF),Length(PERFOFF));
 Len:=Write(ParPtr,ADR(CLR),1);
 SetWindowTitles(WinPtr,OldTitlePtr,OldTitle2Ptr);

END Print.
