(*-------------------------------------------------------------------------
:Program.       Joystick.mod
:Contents.      Prozeduren zum Abfragen von Joysticks
:Author.        Christian Stiens
:Address.       Heustiege 2, D-4710 Ldinghausen
:Phone.         02591/6299
:Copyright.     PD
:Language.      Modula-2
:Translator.    M2Amiga V3.3d,  AMSoft
:History.       V1.0, 17-Jul-90
-------------------------------------------------------------------------*)

IMPLEMENTATION MODULE Joystick;

  FROM SYSTEM IMPORT BITSET;

  VAR joy0dat [0DFF00AH]: BITSET;
      joy1dat [0DFF00CH]: BITSET;
      cia     [0BFE001H]: SET OF [0..7];

  PROCEDURE StickX(port: CARDINAL): INTEGER;
  BEGIN
    CASE port OF
      | 1: IF    1 IN joy0dat THEN RETURN 1
           ELSIF 9 IN joy0dat THEN RETURN -1
           ELSE RETURN 0
           END
      | 2: IF    1 IN joy1dat THEN RETURN 1
           ELSIF 9 IN joy1dat THEN RETURN -1
           ELSE RETURN 0
           END
    END
  END StickX;

  PROCEDURE StickY(port: CARDINAL): INTEGER;
  BEGIN
    CASE port OF
      | 1: IF    (0 IN joy0dat) # (1 IN joy0dat) THEN RETURN 1
           ELSIF (8 IN joy0dat) # (9 IN joy0dat) THEN RETURN -1
           ELSE RETURN 0
           END
      | 2: IF    (0 IN joy1dat) # (1 IN joy1dat) THEN RETURN 1
           ELSIF (8 IN joy1dat) # (9 IN joy1dat) THEN RETURN -1
           ELSE RETURN 0
           END
    END
  END StickY;

  PROCEDURE Fire(port: CARDINAL): BOOLEAN;
  BEGIN
    CASE port OF
      | 1: RETURN NOT (6 IN cia)
      | 2: RETURN NOT (7 IN cia)
    END
  END Fire;

END Joystick.
