(*-------------------------------------------------------------------------
:Program.       Sound.mod
:Contents.      Spielen eines Samples ber das Audio-Device
:Author.        Christian Stiens
:Address.       Heustiege 2, D-4710 Ldinghausen
:Phone.         02591/6299
:Copyright.     PD
:Language.      Modula-2
:Translator.    M2Amiga V3.3d,  AMSoft
:History.       V1.0,19-Jul-90
-------------------------------------------------------------------------*)

IMPLEMENTATION MODULE Sound;

  FROM SYSTEM IMPORT
    LONGSET,ADR,ADDRESS;
  FROM Audio IMPORT
    pervol,IOAudioPtr;
  FROM Exec IMPORT
    MsgPortPtr,write,quick,OpenDevice,CloseDevice;
  FROM ExecSupport IMPORT
    BeginIO,AbortIO,CreateExtIO,DeleteExtIO,CreatePort,DeletePort;
  FROM Arts IMPORT
    TermProcedure,Assert;

  TYPE
    ChannelUnits=(left0,right0,right1,left1);
    ChannelUnitSet=SET OF ChannelUnits;

  VAR
    allocationMask: ARRAY [0..3] OF ChannelUnitSet;
    mp:  MsgPortPtr;
    ioa: IOAudioPtr;
    open: BOOLEAN;

  PROCEDURE OpenAudio;
  BEGIN
    allocationMask[0]:=ChannelUnitSet{left0};
    allocationMask[1]:=ChannelUnitSet{right0};
    allocationMask[2]:=ChannelUnitSet{right1};
    allocationMask[3]:=ChannelUnitSet{left1};
    mp:=CreatePort(NIL,0);
    Assert(mp#NIL,ADR("Can't create port"));
    ioa:=CreateExtIO(mp,SIZE(ioa^));
    Assert(ioa#NIL,ADR("Can't create IO"));
    WITH ioa^ DO
      request.message.node.pri:=10;
      data:=ADR(allocationMask);
      length:=SIZE(allocationMask);
    END;
    OpenDevice(ADR("audio.device"),0,ioa,LONGSET{});
    Assert(ioa^.request.error=0,ADR("Can't open audio device"));
    open:=TRUE;
  END OpenAudio;

  PROCEDURE CloseAudio;
  BEGIN
    IF open    THEN AbortIO(ioa); CloseDevice(ioa) END;
    IF ioa#NIL THEN DeleteExtIO(ioa) END;
    IF mp #NIL THEN DeletePort(mp) END;
  END CloseAudio;

  PROCEDURE PlaySound(sound:ADDRESS; len:LONGCARD; per,vol,cyc:CARDINAL);
  BEGIN
    AbortIO(ioa);
    WITH ioa^ DO
      request.command:=write;
      request.flags:=pervol;
      data:=sound;
      length:=len;
      period:=per;
      volume:=vol;
      cycles:=cyc;
    END;
    BeginIO(ioa)
  END PlaySound;

BEGIN
  open:=FALSE; ioa:=NIL; mp:=NIL;
  TermProcedure(CloseAudio);
  OpenAudio;
END Sound.
