(*-------------------------------------------------------------------------
:Program.       MenuDemo.mod
:Contents.      Demo for `IntuiSupport'
:Author.        Christian Stiens
:Address.       Heustiege 2, D-4710 Ldinghausen
:Phone.         02591/6299
:Copyright.     PD
:Language.      Modula-2
:Translator.    M2Amiga V3.3d,  AMSoft
:Imports.       IntuiSupport V1.1
-------------------------------------------------------------------------*)

MODULE MenuDemo;

  FROM Terminal IMPORT
    waitCloseGadget;
  FROM InOut IMPORT
    WriteString,WriteLn,WriteCard;
  FROM Graphics IMPORT
    jam1;
  FROM Intuition IMPORT
    ScreenPtr,WindowPtr,CloseWindow,ModifyIDCMP,IDCMPFlags,IDCMPFlagSet,
    WindowFlags,WindowFlagSet,ActivationFlagSet,ActivationFlags,IntuiTextPtr,
    MenuItemFlagSet,MenuItemFlags,ClearMenuStrip,MenuPtr,menuNull,noMenu,
    noItem,noSub,ItemAddress,MenuItemPtr,IntuiMessage;
  FROM IntuiSupport IMPORT
    CreateWindow,GetIMes,CreateIntuiText,stdWin,stdItem,DefMenu,DefItem,
    DefSub,InstallMenuStrip;
  FROM SYSTEM IMPORT
    LONGSET,ADR,ADDRESS;
  FROM IntuiMacros IMPORT
    MenuNum,ItemNum,SubNum;


  CONST
    comm    = MenuItemFlagSet{commSeq};
    check   = MenuItemFlagSet{checked};
    checkit = MenuItemFlagSet{checkIt};
    toggle  = MenuItemFlagSet{menuToggle};
    high    = MenuItemFlagSet{highComp};
    noMx    = LONGSET{};

  VAR
    menu     : MenuPtr;
    win      : WindowPtr;
    iMes     : IntuiMessage;
    menuCode : CARDINAL;
    menuNr   : CARDINAL;
    itemNr   : CARDINAL;
    subNr    : CARDINAL;
    item     : MenuItemPtr;

BEGIN
  waitCloseGadget := FALSE;

  win := CreateWindow(ADR("MenuDemo"),0,0,300,70,NIL,stdWin,
         IDCMPFlagSet{closeWindow,menuPick});
  IF win=NIL THEN HALT END;

  (*----------------------- Menu 0 ---------------------*)

  DefMenu(ADR("Project"),10,64,TRUE);

  DefItem(ADR("Load   "),0, 0,120,10,0,noMx,"L",stdItem+comm);
  DefItem(ADR("Save   "),0,10,120,10,0,noMx,"S",stdItem+comm);
  DefItem(ADR("Save As"),0,20,120,10,0,noMx," ",stdItem);
  DefItem(ADR("New    "),0,30,120,10,0,noMx," ",stdItem);
  DefItem(ADR("About  "),0,40,120,10,0,noMx," ",stdItem);

    DefSub(ADR("  This is   "),50,-10,100,10,2,noMx," ",stdItem-high);
    DefSub(ADR(" a Demo for "),50,  0,100,10,2,noMx," ",stdItem-high);
    DefSub(ADR("IntuiSupport"),50, 10,100,10,2,noMx," ",stdItem-high);

  DefItem(ADR("Quit   "),0,50,120,10,3,noMx,"Q",stdItem+comm);

  (*----------------------- Menu 1 ---------------------*)

  DefMenu(ADR("Block"),90,48,TRUE);

  DefItem(ADR("Begin "),0, 0,120,10,0,noMx,"B",stdItem+comm);
  DefItem(ADR("End   "),0,10,120,10,0,noMx,"E",stdItem+comm);
  DefItem(ADR("Delete"),0,20,120,10,0,noMx,"D",stdItem+comm);
  DefItem(ADR("Copy  "),0,30,120,10,0,noMx,"C",stdItem+comm);
  DefItem(ADR("Move  "),0,40,120,10,0,noMx,"M",stdItem+comm);

  (*----------------------- Menu 2 ---------------------*)

  DefMenu(ADR("Misc"),170,40,TRUE);

  DefItem(ADR("   Icon   "),0, 0,90,10,0,noMx," ",stdItem+checkit+toggle+check);
  DefItem(ADR("Help      "),0,10,90,10,0,noMx," ",stdItem);
  DefItem(ADR("New Window"),0,20,90,10,0,noMx," ",stdItem);
  DefItem(ADR("Print     "),0,30,90,10,0,noMx," ",stdItem);

    DefSub(ADR("Draft"),90,-10,50,10,2,noMx," ",stdItem);
    DefSub(ADR("NLQ  "),90,  0,50,10,2,noMx," ",stdItem);

  DefItem(ADR("Planes    "),0,40,90,10,0,noMx," ",stdItem);

    DefSub(ADR("   1"),90,-10,36,10,2,LONGSET{1,2,3}," ",stdItem+checkit);
    DefSub(ADR("   2"),90,  0,36,10,2,LONGSET{0,2,3}," ",stdItem+checkit+check);
    DefSub(ADR("   3"),90, 10,36,10,2,LONGSET{0,1,3}," ",stdItem+checkit);
    DefSub(ADR("   4"),90, 20,36,10,2,LONGSET{0,1,2}," ",stdItem+checkit);

  (*----------------------------------------------------*)

  menu := InstallMenuStrip(win);
  IF menu=NIL THEN CloseWindow(win); HALT END;
  WriteString("            Menu Item Sub"); WriteLn; WriteLn;

  LOOP
    GetIMes(win,iMes,TRUE);
    IF closeWindow IN iMes.class THEN EXIT END;
    IF menuPick IN iMes.class THEN
      menuCode:=iMes.code;
      WHILE menuCode # menuNull DO
        menuNr := MenuNum(menuCode);
        itemNr := ItemNum(menuCode);
        subNr  := SubNum(menuCode);
        WriteString("Selected:");
        WriteCard(menuNr,5); WriteCard(itemNr,5); WriteCard(subNr,5);
        WriteLn;
        IF (menuNr=0) & (itemNr=5) THEN EXIT END;
        item := ItemAddress(menu,menuCode);
        menuCode := item^.nextSelect
      END
    END
  END;
  ClearMenuStrip(win);
  CloseWindow(win)
END MenuDemo.
