(*-------------------------------------------------------------------------
:Program.       KeyConversion.mod
:Contents.      Prozedur zur bersetzung von Rawkey-Codes
:Author.        Christian Stiens
:Address.       Heustiege 2, D-4710 Ldinghausen
:Phone.         02591/6299
:Copyright.     PD
:Language.      Modula-2
:Translator.    M2Amiga V3.3d,  AMSoft
:History.       V1.0, 18-Jul-90
-------------------------------------------------------------------------*)

IMPLEMENTATION MODULE KeyConversion;

  FROM Exec       IMPORT IOStdReq,DevicePtr,OpenDevice,CloseDevice;
  FROM Intuition  IMPORT IntuiMessagePtr,IDCMPFlags,IDCMPFlagSet;
  FROM InputEvent IMPORT Class,InputEvent,QualifierSet,upPrefix;
  FROM KeyMap     IMPORT KeyMapPtr;
  FROM Console    IMPORT RawKeyConvert;
  FROM Arts       IMPORT Assert,TermProcedure;
  FROM SYSTEM     IMPORT ADR,LONGSET,ADDRESS,BITSET,CAST;

  VAR consoleDevice: DevicePtr;
      ioreq:  IOStdReq;

  PROCEDURE DeadKeyConvert(msg: IntuiMessagePtr; VAR kbuffer: ARRAY OF CHAR;
                           kmap: KeyMapPtr ): LONGINT;
    VAR
      ievent: InputEvent;
      num: LONGINT;
      aPtr: POINTER TO ADDRESS;
  BEGIN
    IF msg^.class # IDCMPFlagSet{rawKey} THEN RETURN -2 END;
    IF CAST(BITSET,msg^.code) * CAST(BITSET,upPrefix) # {} THEN RETURN 0 END;
    aPtr := msg^.iAddress;
    WITH ievent DO
      nextEvent := NIL;
      class     := rawkey;
      subClass  := null;
      code      := msg^.code;
      qualifier := msg^.qualifier;
      eventAddress := aPtr^;
    END;
    num := RawKeyConvert(consoleDevice,
                         ADR(ievent),ADR(kbuffer),HIGH(kbuffer),kmap);
    IF (num >= 0) & (num <= HIGH(kbuffer)) THEN
      kbuffer[num] := 0C;
    END;
    RETURN num
  END DeadKeyConvert;

  PROCEDURE Cleanup;
  BEGIN
    IF consoleDevice # NIL THEN CloseDevice(ADR(ioreq)) END;
  END Cleanup;

BEGIN
  consoleDevice := NIL;
  TermProcedure(Cleanup);
  OpenDevice(ADR("console.device"),-1,ADR(ioreq),LONGSET{});
  Assert(ioreq.error=0,ADR("Can't open console device"));
  consoleDevice := ioreq.device;
END KeyConversion.
