(*---------------------------------------------------------------------------
    :Program.    Harp.mod
    :Author.     Achim Siebert
    :Address.    Nobileweg 67, D-7000 Stuttgart-40
    :Phone.      0711/822509
    :Shortcut.   [acs]
    :Version.    1.0
    :Date.       03-Nov-90
    :Copyright.  PD
    :Language.   Oberon
    :Translator. Oberon
    :Imports.    none.
    :UpDate.     none.
    :Contents.   Patience game.
    :Remark.     Req.library needed!
---------------------------------------------------------------------------*)

MODULE Harp;

IMPORT

      KaroData,HerzData,PikData,KreuzData,Backs,
      Harphelp,
      I : Intuition,
      G : Graphics,
      E : Exec,
      Req,
      Dos,
      Requests,
      Conversions,
      Strings,
      Random,
      Lists,
      ol : OberonLib,
      SYSTEM;

TYPE  CardT = RECORD(Lists.Node)
         farbe: INTEGER;
         typ: INTEGER;
         blau: BOOLEAN;
      END;
      CardTP = POINTER TO CardT;

VAR   WinP,oldWinP : I.WindowPtr;
      ScP          : I.ScreenPtr;
      top8         : G.TextAttr;
      IMess        : I.IntuiMessage;
      IMessPtr     : I.IntuiMessagePtr;
      gadblocks    : ARRAY 4 OF Req.GadgetBlock;
      gadgetPtr    : I.GadgetPtr;
      gadgetnum    : INTEGER;
      myproc       : Dos.ProcessPtr;
      velo         : INTEGER;
      NumsOn,stop  : BOOLEAN;
      cardBMs      : ARRAY 4, 13 OF G.BitMapPtr;

      Leerstelle,backred,backblue,SaveBM : G.BitMapPtr;

      Talon,Ablage : Lists.List;

      int,Talonsize,Ablagesize,LastTalon,runde : INTEGER;
      gewonnen,newgame: BOOLEAN;
      zaehler,talontake,ablagetake: BOOLEAN;
      bautake,stapeltake : ARRAY 10 OF BOOLEAN;

      Familie : ARRAY 8 OF Lists.List;
      Bau : ARRAY 10 OF Lists.List;
      OpenBsize,CloseBsize : ARRAY 10 OF INTEGER;

TYPE
  ColorType = ARRAY 20 OF INTEGER;

CONST

  Colors = ColorType(0000H,0FFFH,0C00H,0F53H,00B0H,0FB0H,000FH,02CDH,
                     0F0CH,0A0FH,0EA9H,0EEEH,0ECBH,0BBBH,0888H,0444H,
                     0000H,0D0FH,0EBBH,0555H);

TYPE  BauXCoords = ARRAY 10 OF INTEGER;
      FamCoords = ARRAY 8 OF INTEGER;
      BauYCoords = ARRAY 10 OF INTEGER;

CONST BauX = BauXCoords(25,85,145,205,265,325,385,445,505,565);

      BauY = BauYCoords(50,56,62,68,74,80,86,92,98,104);

   FamX = FamCoords(46,117,188,259,330,401,472,543);
   FamY = 5;

   Mangel  = "Out of memory!";
   as      = 0;      karo     = 0;
   zwei    = 1;      herz     = 1;
   drei    = 2;      pik      = 2;
   vier    = 3;      kreuz    = 3;
   fuenf   = 4;
   sechs   = 5;
   sieben  = 6;
   acht    = 7;
   neun    = 8;
   zehn    = 9;
   bube    = 10;
   dame    = 11;
   koenig  = 12;
   junkx   = 445;    junky    = 217;
   talonx  = 535;    talony   = 217;
   maxx    = 590;    maxy     = 221;
   kbreite =  49;    khoehe   =  35;
   kdx     =  25;    kdy      =  18;

(* ------------------------------------------------------------------ *)

PROCEDURE Ausblenden(screenzeiger: I.ScreenPtr);

VAR      colors,r,g,b: ARRAY 16 OF INTEGER;
            i,j,Rot,Gruen,Blau  : INTEGER;
BEGIN
   i := 0;
   REPEAT
      colors[i] := SHORT(G.GetRGB4(screenzeiger.viewPort.colorMap,i));
      r[i] := colors[i] DIV 256 MOD 16;
      g[i] := colors[i] DIV 16 MOD 16;
      b[i] := colors[i] MOD 16;
      INC(i);
   UNTIL i = 16;
   j := 40;
   REPEAT
      i := 0;   
      REPEAT
         Rot := r[i]*j DIV 40;
         Gruen := g[i]*j DIV 40;
         Blau := b[i]*j DIV 40;
         colors[i] := (Rot*16+Gruen)*16+Blau;
         INC(i);
      UNTIL i = 16;
      G.LoadRGB4(SYSTEM.ADR(screenzeiger.viewPort),colors,16);
      DEC(j);
   UNTIL j < 0;

END Ausblenden;
      
(* ------------------------------------------------------------------ *)

PROCEDURE Einblenden(screenzeiger: I.ScreenPtr;Endfarben:ARRAY OF INTEGER);

VAR      colors,r,g,b: ARRAY 16 OF INTEGER;
            i,j,Rot,Gruen,Blau  : INTEGER;
BEGIN
   i := 0;
   REPEAT
      colors[i] := Endfarben[i];
      r[i] := colors[i] DIV 256 MOD 16;
      g[i] := colors[i] DIV 16 MOD 16;
      b[i] := colors[i] MOD 16;
      INC(i);
   UNTIL i = 16;
   j := 0;
   REPEAT
      i := 0;   
      REPEAT
         Rot := r[i]*j DIV 40;
         Gruen := g[i]*j DIV 40;
         Blau := b[i]*j DIV 40;
         colors[i] := (Rot*16+Gruen)*16+Blau;
         INC(i);
      UNTIL i = 16;
      G.LoadRGB4(SYSTEM.ADR(screenzeiger.viewPort),colors,16);
      INC(j);
   UNTIL j > 40;

END Einblenden;
      
(* ------------------------------------------------------------------ *)

PROCEDURE OpenAll();

VAR
   NSc  : I.NewScreen;
   Nw   : I.NewWindow;
   borderPtr : I.BorderPtr;
   
CONST Black = ColorType(0000H,0000H,0000H,0000H,0000H,0000H,0000H,0000H,
                     0000H,0000H,0000H,0000H,0000H,0000H,0000H,0000H,
                     0000H,0D0FH,0EBBH,0555H);
                     
TYPE gadstringType = ARRAY 4,20 OF CHAR;
     gadxposType = ARRAY 4 OF INTEGER;
     
CONST gadstrings = gadstringType("Q:Quit",
                                 "HELP:Rules",
                                 "ESC:New Game",
                                 "DEL:Toggle Figs");
      gadxpos = gadxposType(25,81,169,273);
      
BEGIN
   
   top8.name        := SYSTEM.ADR("topaz.font");
   top8.ySize       := 8;
   top8.style       := SHORTSET{};
   top8.flags       := SHORTSET{G.romFont};
   IF G.gfx.normalDisplayColumns >= 640 THEN
      NSc.leftEdge := (G.gfx.normalDisplayColumns - 640) DIV 2;
   ELSE NSc.leftEdge := 0;
   END;
   NSc.topEdge := 0;
   NSc.width        := 640;
   NSc.height       := 256;   
   NSc.depth        := 4;
   NSc.detailPen    := 0;    NSc.blockPen     := 9;
   NSc.viewModes    := {G.hires};
   NSc.type         := I.customScreen;
   NSc.font         := SYSTEM.ADR(top8);  NSc.defaultTitle := NIL;
   NSc.gadgets      := NIL;  NSc.customBitMap := NIL;
   INCL(NSc.type,I.screenQuiet);
   ScP := I.OpenScreen(NSc); Requests.Assert(ScP#NIL,"Couldn't open screen!");
   G.LoadRGB4(SYSTEM.ADR(ScP.viewPort),Black,20);
   
   Nw.leftEdge      := 0;    Nw.topEdge       := 0;
   Nw.width         := 640;  Nw.height        := 256;
   Nw.detailPen     := 0;    Nw.blockPen      := 9;
   Nw.idcmpFlags    := LONGSET{};
   Nw.flags         := LONGSET{I.activate,I.borderless,I.backDrop,I.rmbTrap};
   Nw.firstGadget   := NIL;  Nw.checkMark     := NIL;
   Nw.screen        := ScP;  Nw.bitMap        := NIL;
   Nw.minWidth      := 128;  Nw.minHeight     := 24;
   Nw.maxWidth      := -1;   Nw.maxHeight     := -1;
   Nw.title         := NIL;  Nw.type          := I.customScreen;
    
   gadgetnum := 0;
   REPEAT
      Req.LinkGadget(SYSTEM.ADR(gadblocks[gadgetnum]),gadstrings[gadgetnum],Nw,
                     gadxpos[gadgetnum],242);
      gadblocks[gadgetnum].gadget.gadgetID := gadgetnum;
      borderPtr := gadblocks[gadgetnum].gadget.gadgetRender;
      borderPtr.frontPen := 9;
      gadblocks[gadgetnum].gadget.gadgetText.frontPen := 0;
      gadblocks[gadgetnum].gadget.gadgetText.backPen := 11;
      INC(gadgetnum);
   UNTIL gadgetnum = 4;
   WinP := I.OpenWindow(Nw); Requests.Assert(WinP#NIL,"Couldn't open window!");
   G.SetFont(WinP.rPort,G.OpenFont(SYSTEM.ADR(top8)));
   I.SetPointer(WinP,SYSTEM.VAL(LONGINT,Backs.hand1Data),16,16,0,0);
    
END OpenAll;

(* ------------------------------------------------------------------ *)

PROCEDURE WriteNums(switched,ab,ta:BOOLEAN);

VAR str: ARRAY 4 OF CHAR;

BEGIN

   G.SetDrMd(WinP.rPort,G.jam2);
   IF NumsOn THEN
      IF switched THEN
         G.SetAPen(WinP.rPort,0);
         G.RectFill(WinP.rPort,talonx+kbreite+1,talony,talonx+kbreite+25,talony+khoehe);
         G.RectFill(WinP.rPort,junkx-30,junky,junkx-1,junky+khoehe);
         NumsOn := NOT NumsOn;
      ELSE
         IF ta THEN
            G.SetAPen(WinP.rPort,0);
            G.RectFill(WinP.rPort,talonx+kbreite+1,talony,talonx+kbreite+25,talony+khoehe);
            G.SetAPen(WinP.rPort,11);
            G.Move(WinP.rPort,talonx+kbreite+1,talony+20);
            IF Conversions.IntToString(LONG(Talonsize),str,2) THEN END;
            G.Text(WinP.rPort,str,Strings.Length(str));
         END;
         IF ab THEN
            G.SetAPen(WinP.rPort,0);
            G.RectFill(WinP.rPort,junkx-30,junky,junkx-1,junky+khoehe);
            G.SetAPen(WinP.rPort,11);
            G.Move(WinP.rPort,junkx-30,junky+20);
            IF Conversions.IntToString(LONG(Ablagesize),str,2) THEN END;
            G.Text(WinP.rPort,str,Strings.Length(str));
         END;
      END;
   ELSE
      IF switched THEN
         NumsOn := NOT NumsOn;
         WriteNums(FALSE,TRUE,TRUE);
      END;
   END;
         
END WriteNums;

(* ------------------------------------------------------------------ *)

PROCEDURE InitKarten(VAR Ks: Lists.List);

VAR karte : CardTP;
    i,j   : INTEGER;
    first : BOOLEAN;

BEGIN

Lists.Init(Ks);
first := TRUE;
REPEAT
   i := karo;
   REPEAT
      j := as;
      REPEAT
         NEW(karte);Requests.Assert(karte#NIL,Mangel);
         karte.farbe := i;
         karte.typ := j;
         karte.blau := first;
         Lists.AddTail(Ks,karte);
         INC(j);
       UNTIL j > koenig;
       INC(i);
   UNTIL i > kreuz;
   first := NOT first;
UNTIL first;

END InitKarten;

(* ------------------------------------------------------------------ *)

PROCEDURE MischKarten(VAR Ks: Lists.List);

VAR   Zwischen : Lists.List;
      i,zufall : INTEGER;
      naechste : Lists.NodePtr;

BEGIN

i := Talonsize;
Lists.Init(Zwischen);
REPEAT
   zufall := Random.RND(i);
   naechste := Lists.Head(Ks);
   REPEAT
      DEC(zufall);
   UNTIL (zufall < 0) OR NOT Lists.Next(naechste);
   Lists.Remove(Ks,naechste);
   Lists.AddHead(Zwischen,naechste);
   DEC(i);
UNTIL i = 0;
Ks := Zwischen;

END MischKarten;

(* ------------------------------------------------------------------ *)

PROCEDURE InitCardBMs();

TYPE CAPtr = POINTER TO ARRAY 4, 4*35 OF INTEGER; 

VAR  i,j   : INTEGER;

PROCEDURE InitBitMap(bm: G.BitMapPtr;data: CAPtr);

BEGIN
  G.InitBitMap(bm^,4,kbreite,khoehe);
  bm.planes[0] := SYSTEM.ADR(data[0]);
  bm.planes[1] := SYSTEM.ADR(data[1]);
  bm.planes[2] := SYSTEM.ADR(data[2]);
  bm.planes[3] := SYSTEM.ADR(data[3]);
END InitBitMap;

BEGIN
  i := karo;
  REPEAT
     j := as;
     REPEAT
        NEW(cardBMs[i,j]); Requests.Assert(cardBMs[i,j]#NIL,Mangel);
        INC(j);
     UNTIL j > koenig;
     INC(i)
  UNTIL i > kreuz;

  NEW(backblue);Requests.Assert(backblue#NIL,Mangel);
  NEW(backred); Requests.Assert(backred#NIL,Mangel);
  NEW(SaveBM);  Requests.Assert(SaveBM#NIL,Mangel);
  NEW(Leerstelle);  Requests.Assert(Leerstelle#NIL,Mangel);

  G.InitBitMap(SaveBM^,4,kbreite,khoehe);
  INCL(ol.MemReqs,E.chip);
  i := 0;
  REPEAT
    ol.New(SaveBM.planes[i],8*khoehe);
    Requests.Assert(SaveBM.planes[i]#NIL,Mangel);
    INC(i);
  UNTIL i=4;
  EXCL(ol.MemReqs,E.chip);

  InitBitMap(cardBMs[karo,as],SYSTEM.VAL(LONGINT,KaroData.karoasDat));
  InitBitMap(cardBMs[karo,zwei],SYSTEM.VAL(LONGINT,KaroData.karo2Dat));
  InitBitMap(cardBMs[karo,drei],SYSTEM.VAL(LONGINT,KaroData.karo3Dat));
  InitBitMap(cardBMs[karo,vier],SYSTEM.VAL(LONGINT,KaroData.karo4Dat));
  InitBitMap(cardBMs[karo,fuenf],SYSTEM.VAL(LONGINT,KaroData.karo5Dat));
  InitBitMap(cardBMs[karo,sechs],SYSTEM.VAL(LONGINT,KaroData.karo6Dat));
  InitBitMap(cardBMs[karo,sieben],SYSTEM.VAL(LONGINT,KaroData.karo7Dat));
  InitBitMap(cardBMs[karo,acht],SYSTEM.VAL(LONGINT,KaroData.karo8Dat));
  InitBitMap(cardBMs[karo,neun],SYSTEM.VAL(LONGINT,KaroData.karo9Dat));
  InitBitMap(cardBMs[karo,zehn],SYSTEM.VAL(LONGINT,KaroData.karo10Dat));
  InitBitMap(cardBMs[karo,bube],SYSTEM.VAL(LONGINT,KaroData.karobubeDat));
  InitBitMap(cardBMs[karo,dame],SYSTEM.VAL(LONGINT,KaroData.karodameDat));
  InitBitMap(cardBMs[karo,koenig],SYSTEM.VAL(LONGINT,KaroData.karokoenigDat));

  InitBitMap(cardBMs[herz,as],SYSTEM.VAL(LONGINT,HerzData.herzasDat));
  InitBitMap(cardBMs[herz,zwei],SYSTEM.VAL(LONGINT,HerzData.herz2Dat));
  InitBitMap(cardBMs[herz,drei],SYSTEM.VAL(LONGINT,HerzData.herz3Dat));
  InitBitMap(cardBMs[herz,vier],SYSTEM.VAL(LONGINT,HerzData.herz4Dat));
  InitBitMap(cardBMs[herz,fuenf],SYSTEM.VAL(LONGINT,HerzData.herz5Dat));
  InitBitMap(cardBMs[herz,sechs],SYSTEM.VAL(LONGINT,HerzData.herz6Dat));
  InitBitMap(cardBMs[herz,sieben],SYSTEM.VAL(LONGINT,HerzData.herz7Dat));
  InitBitMap(cardBMs[herz,acht],SYSTEM.VAL(LONGINT,HerzData.herz8Dat));
  InitBitMap(cardBMs[herz,neun],SYSTEM.VAL(LONGINT,HerzData.herz9Dat));
  InitBitMap(cardBMs[herz,zehn],SYSTEM.VAL(LONGINT,HerzData.herz10Dat));
  InitBitMap(cardBMs[herz,bube],SYSTEM.VAL(LONGINT,HerzData.herzbubeDat));
  InitBitMap(cardBMs[herz,dame],SYSTEM.VAL(LONGINT,HerzData.herzdameDat));
  InitBitMap(cardBMs[herz,koenig],SYSTEM.VAL(LONGINT,HerzData.herzkoenigDat));

  InitBitMap(cardBMs[pik,as],SYSTEM.VAL(LONGINT,PikData.pikasDat));
  InitBitMap(cardBMs[pik,zwei],SYSTEM.VAL(LONGINT,PikData.pik2Dat));
  InitBitMap(cardBMs[pik,drei],SYSTEM.VAL(LONGINT,PikData.pik3Dat));
  InitBitMap(cardBMs[pik,vier],SYSTEM.VAL(LONGINT,PikData.pik4Dat));
  InitBitMap(cardBMs[pik,fuenf],SYSTEM.VAL(LONGINT,PikData.pik5Dat));
  InitBitMap(cardBMs[pik,sechs],SYSTEM.VAL(LONGINT,PikData.pik6Dat));
  InitBitMap(cardBMs[pik,sieben],SYSTEM.VAL(LONGINT,PikData.pik7Dat));
  InitBitMap(cardBMs[pik,acht],SYSTEM.VAL(LONGINT,PikData.pik8Dat));
  InitBitMap(cardBMs[pik,neun],SYSTEM.VAL(LONGINT,PikData.pik9Dat));
  InitBitMap(cardBMs[pik,zehn],SYSTEM.VAL(LONGINT,PikData.pik10Dat));
  InitBitMap(cardBMs[pik,bube],SYSTEM.VAL(LONGINT,PikData.pikbubeDat));
  InitBitMap(cardBMs[pik,dame],SYSTEM.VAL(LONGINT,PikData.pikdameDat));
  InitBitMap(cardBMs[pik,koenig],SYSTEM.VAL(LONGINT,PikData.pikkoenigDat));

  InitBitMap(cardBMs[kreuz,as],SYSTEM.VAL(LONGINT,KreuzData.kreuzasDat));
  InitBitMap(cardBMs[kreuz,zwei],SYSTEM.VAL(LONGINT,KreuzData.kreuz2Dat));
  InitBitMap(cardBMs[kreuz,drei],SYSTEM.VAL(LONGINT,KreuzData.kreuz3Dat));
  InitBitMap(cardBMs[kreuz,vier],SYSTEM.VAL(LONGINT,KreuzData.kreuz4Dat));
  InitBitMap(cardBMs[kreuz,fuenf],SYSTEM.VAL(LONGINT,KreuzData.kreuz5Dat));
  InitBitMap(cardBMs[kreuz,sechs],SYSTEM.VAL(LONGINT,KreuzData.kreuz6Dat));
  InitBitMap(cardBMs[kreuz,sieben],SYSTEM.VAL(LONGINT,KreuzData.kreuz7Dat));
  InitBitMap(cardBMs[kreuz,acht],SYSTEM.VAL(LONGINT,KreuzData.kreuz8Dat));
  InitBitMap(cardBMs[kreuz,neun],SYSTEM.VAL(LONGINT,KreuzData.kreuz9Dat));
  InitBitMap(cardBMs[kreuz,zehn],SYSTEM.VAL(LONGINT,KreuzData.kreuz10Dat));
  InitBitMap(cardBMs[kreuz,bube],SYSTEM.VAL(LONGINT,KreuzData.kreuzbubeDat));
  InitBitMap(cardBMs[kreuz,dame],SYSTEM.VAL(LONGINT,KreuzData.kreuzdameDat));
  InitBitMap(cardBMs[kreuz,koenig],SYSTEM.VAL(LONGINT,KreuzData.kreuzkoenigDat));

  InitBitMap(backred,SYSTEM.VAL(LONGINT,Backs.rueckenrotDat));
  InitBitMap(backblue,SYSTEM.VAL(LONGINT,Backs.rueckenblauDat));
  InitBitMap(Leerstelle,SYSTEM.VAL(LONGINT,Backs.emptyDat));

END InitCardBMs;

(* ------------------------------------------------------------------ *)

PROCEDURE Depict(card:G.BitMapPtr;x,y:INTEGER);

BEGIN

IF G.BltBitMap(card,0,0,WinP.rPort.bitMap,x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;

END Depict;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawEmpty(x,y:INTEGER);

BEGIN

IF G.BltBitMap(Leerstelle,0,0,WinP.rPort.bitMap,x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;

END DrawEmpty;

(* ------------------------------------------------------------------ *)

PROCEDURE Show(card:Lists.NodePtr;x,y:INTEGER);

BEGIN

   WITH card:CardT DO
      IF G.BltBitMap(cardBMs[card.farbe,card.typ],0,0,WinP.rPort.bitMap,
                     x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   END;

END Show;

(* ------------------------------------------------------------------ *)

PROCEDURE ShowBack(card:Lists.NodePtr;x,y:INTEGER);

BEGIN

      IF card(CardT).blau THEN
         IF G.BltBitMap(backblue,0,0,WinP.rPort.bitMap,
                        x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
      ELSE 
         IF G.BltBitMap(backred,0,0,WinP.rPort.bitMap,
                        x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
      END;

END ShowBack;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLine(bm : G.BitMapPtr;x,y,x1,y1:INTEGER);

VAR ay,ax,dy,dx,iy,ix,hilf,of,ct,times : INTEGER;

BEGIN

ay := 0; ax := 0;

IF x1 >= x THEN dx := x1-x; ix := 1;
ELSE dx := x-x1; ix := -1; END;
IF y1 >= y THEN dy := y1-y; iy := 1;
ELSE dy := y-y1; iy := -1; END;
IF dx < dy THEN hilf := dx; dx := dy; dy := hilf;
ay := ix; ax := iy; ix := 0; iy := 0; END;
of := dx DIV 2;
ct := 1;
times := 0;
LOOP
   IF times = 0 THEN
      IF G.BltBitMap(WinP.rPort.bitMap,x,y,SaveBM,0,0,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
      IF G.BltBitMap(bm,0,0,WinP.rPort.bitMap,x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
      REPEAT UNTIL G.VBeamPos()<y+70; 
      REPEAT UNTIL G.VBeamPos()>y+70;
      IF G.BltBitMap(SaveBM,0,0,WinP.rPort.bitMap,x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   END;
   IF dx < ct THEN EXIT END;
   INC(times); IF times = velo THEN times := 0 END;
   x := x + ix;
   y := y + ax;
   INC(ct);
   of := of + dy;
   IF of > dx THEN of := of-dx; x := x+ay; y := y+iy; END;
END;

END DrawLine;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLineSwitch(karte: Lists.NodePtr;x,y,x1,y1:INTEGER);

VAR dx,dy:INTEGER;

BEGIN
   dx := (x1+x) DIV 2;
   dy := (y1+y) DIV 2;
   WITH karte:CardT DO
      IF karte.blau THEN
         DrawLine(backblue,x,y,dx,dy);
      ELSE DrawLine(backred,x,y,dx,dy);
      END;
      DrawLine(cardBMs[karte.farbe,karte.typ],dx,dy,x1,y1);
   END;

END DrawLineSwitch;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLineSwitchR(karte: Lists.NodePtr;x,y,x1,y1:INTEGER);

VAR dx,dy:INTEGER;

BEGIN
   dx := (x1+x) DIV 2;
   dy := (y1+y) DIV 2;
   WITH karte:CardT DO
      DrawLine(cardBMs[karte.farbe,karte.typ],x,y,dx,dy);
      IF karte.blau THEN
         DrawLine(backblue,dx,dy,x1,y1);
      ELSE DrawLine(backred,dx,dy,x1,y1);
      END;
   END;

END DrawLineSwitchR;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLineBack(karte: Lists.NodePtr;x,y,x1,y1:INTEGER);

BEGIN

      IF karte(CardT).blau THEN
           DrawLine(backblue,x,y,x1,y1);
      ELSE DrawLine(backred,x,y,x1,y1);
      END;

END DrawLineBack;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLineCard(karte: Lists.NodePtr;x,y,x1,y1:INTEGER);

BEGIN
   WITH karte:CardT DO
   DrawLine(cardBMs[karte.farbe,karte.typ],x,y,x1,y1);
   END;

END DrawLineCard;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleAnfang;

VAR i : INTEGER;

BEGIN

i := 0;
REPEAT
   DrawEmpty(FamX[i],FamY);
   INC(i);
UNTIL i = 8;

DrawEmpty(junkx,junky);

END MaleAnfang;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleTalon;

VAR karte:Lists.NodePtr;
BEGIN

WriteNums(FALSE,FALSE,TRUE);
IF Talonsize > 0 THEN
   karte := Lists.Head(Talon);
   ShowBack(karte,talonx,talony);
ELSE DrawEmpty(talonx,talony);
END;

END MaleTalon;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleAblage;

VAR karte:Lists.NodePtr;

BEGIN
WriteNums(FALSE,TRUE,FALSE);
IF Ablagesize > 0 THEN
   karte := Lists.Head(Ablage);
   Show(karte,junkx,junky);
ELSE DrawEmpty(junkx,junky);
END;

END MaleAblage;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleFamilie(i: INTEGER);

VAR karte:Lists.NodePtr;

BEGIN

IF NOT Lists.Empty(Familie[i]) THEN
   karte := Lists.Head(Familie[i]);
   Show(karte,FamX[i],FamY);
ELSE DrawEmpty(FamX[i],FamY);
END;

END MaleFamilie;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleBaustelle(n:INTEGER);

VAR karte : Lists.NodePtr;
    i: INTEGER;

BEGIN
IF (OpenBsize[n] = 0) AND (CloseBsize[n] = 0) THEN
   DrawEmpty(BauX[n],BauY[0]);
   G.SetAPen(WinP.rPort,0);
   G.RectFill(WinP.rPort,BauX[n],BauY[0]+khoehe,
             BauX[n]+kbreite,BauY[9-n]+khoehe+11*9);
ELSIF OpenBsize[n] = 0 THEN
   karte := Lists.Head(Bau[n]);
   ShowBack(karte,BauX[n],BauY[CloseBsize[n]-1]);
   G.SetAPen(WinP.rPort,0);
   G.RectFill(WinP.rPort,BauX[n],BauY[CloseBsize[n]-1]+khoehe,
             BauX[n]+kbreite,BauY[9-n]+khoehe+11*9);
ELSE
   karte := Lists.Head(Bau[n]);
   Show(karte,BauX[n],BauY[CloseBsize[n]]+(OpenBsize[n]-1)*9);
   G.SetAPen(WinP.rPort,0);
   G.RectFill(WinP.rPort,BauX[n],BauY[CloseBsize[n]]+(OpenBsize[n]-1)*9+khoehe,
              BauX[n]+kbreite,BauY[9-n]+11*9+khoehe);
END;
END MaleBaustelle;

(* ------------------------------------------------------------------ *)

PROCEDURE InitStapel;

VAR i,j : INTEGER;
    karte : Lists.NodePtr;

BEGIN

   Lists.Init(Ablage);

   Ablagesize := 0;
   Einblenden(ScP,Colors);   
   i := 0;
   REPEAT
      Lists.Init(Familie[i]);
      INC(i);
   UNTIL i = 8;
   i := 0;
   REPEAT
      Lists.Init(Bau[i]);
      OpenBsize[i] := 0;
      CloseBsize[i]:= 0;
      INC(i);
   UNTIL i = 10;
   i := 10;
   REPEAT
      j := 0;
      DEC(i);
      WHILE j < i DO
         karte := Lists.RemHead(Talon);
         DEC(Talonsize);
         MaleTalon;
         Lists.AddHead(Bau[j],karte);
         INC(CloseBsize[j]);
         MaleBaustelle(j);
         INC(j);
      END;
      karte := Lists.RemHead(Talon);
      DEC(Talonsize);
      MaleTalon;
      DrawLineSwitch(karte,talonx,talony,BauX[i],BauY[9-i]);
      Lists.AddHead(Bau[i],karte);
      INC(OpenBsize[i]);
      MaleBaustelle(i);
   UNTIL i = 0;
   LastTalon := Talonsize;

END InitStapel;

(* ------------------------------------------------------------------ *)

PROCEDURE DragKarte(which : Lists.NodePtr; x,y : INTEGER; VAR lx,ly : INTEGER);

VAR i,farbe,typ,newx,newy : INTEGER;

BEGIN

WITH which : CardT DO

   farbe := which.farbe;
   typ := which.typ;

END;

lx := x; ly := y;
newx := x-kdx; newy := y-kdy;
IF newx < 0 THEN newx := 0 END;
IF newy < 0 THEN newy := 0 END;
IF newx > maxx THEN newx := maxx END;
IF newy > maxy THEN newy := maxy END;

LOOP

   IF G.BltBitMap(WinP.rPort.bitMap,newx,newy,SaveBM,0,0,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   IF G.BltBitMap(cardBMs[farbe,typ],0,0,WinP.rPort.bitMap,newx,newy,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   REPEAT
      REPEAT
         IMessPtr := E.GetMsg(WinP.userPort);
          IF IMessPtr # NIL THEN
            IMess := IMessPtr^;
            E.ReplyMsg(IMessPtr);
            IF (I.mouseButtons IN IMess.class) AND (IMess.code = I.selectDown) THEN
               IF G.BltBitMap(SaveBM,0,0,WinP.rPort.bitMap,newx,newy,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
               I.ModifyIDCMP(WinP,LONGSET{});
               EXIT;
            END;
         END;
      UNTIL IMessPtr = NIL;
      lx := WinP^.mouseX; ly := WinP^.mouseY;
   UNTIL (lx#x) OR (ly#y);
   G.WaitTOF;
   x :=lx; y :=ly;
   IF G.BltBitMap(SaveBM,0,0,WinP.rPort.bitMap,newx,newy,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   newx := lx-kdx; newy := ly-kdy;
   IF newx < 0 THEN newx := 0 END;
   IF newy < 0 THEN newy := 0 END;
   IF newx > maxx THEN newx := maxx END;
   IF newy > maxy THEN newy := maxy END;

END;

END DragKarte;

(* ------------------------------------------------------------------ *)

PROCEDURE ThreeGadReq(titel,text,links,rechts,mitte:ARRAY OF CHAR):INTEGER;

VAR int : INTEGER;
    myTextStruct : Req.TRStructurePtr;
    result : INTEGER;
BEGIN

   NEW(myTextStruct);
   IF text # "" THEN
   	myTextStruct.text := SYSTEM.ADR(text);
   ELSE myTextStruct.text := NIL;
   END;
	myTextStruct.controls := NIL;
	myTextStruct.window := NIL;
	IF mitte # "" THEN
	   myTextStruct.middleText := SYSTEM.ADR(mitte);
	ELSE myTextStruct.middleText := NIL;
	END;
	IF links # "" THEN
   	myTextStruct.positiveText := SYSTEM.ADR(links);
   ELSE myTextStruct.positiveText := NIL;
   END;
   IF rechts # "" THEN
   	myTextStruct.negativeText := SYSTEM.ADR(rechts);
   ELSE myTextStruct.negativeText := NIL;
   END;
   IF titel # "" THEN
   	myTextStruct.title := SYSTEM.ADR(titel);
   ELSE myTextStruct.title := NIL;
   END;
	myTextStruct.keyMask := {};
	myTextStruct.textcolor := 11;
	myTextStruct.detailcolor := 8;
	myTextStruct.blockcolor := 6;
	myTextStruct.versionnumber := 0;
	myTextStruct.rfu1 := 0;
	myTextStruct.rfu2 := 0;
	result := Req.TextRequest(myTextStruct);
   DISPOSE(myTextStruct);
   RETURN result;
   
END ThreeGadReq;

(* ------------------------------------------------------------------ *)

PROCEDURE MoveKarte;

VAR
   x,y,endx,endy,backx,backy,i,j,k,l,numstapel,tomove : INTEGER;
took,totalon,toab,tono,stkblau,mittestapel,drehstapel : BOOLEAN;
                                                tofam : ARRAY 8 OF BOOLEAN;
                                                tobau : ARRAY 10 OF BOOLEAN;
                                         karte,karte2 : Lists.NodePtr;
                                      stkfarbe,stktyp : INTEGER;

PROCEDURE pruefefam(i:INTEGER;karte: Lists.NodePtr) : BOOLEAN;

VAR top:Lists.NodePtr;

BEGIN

   top := Lists.Head(Familie[i]);
   IF top # NIL THEN
      WITH top:CardT DO
         WITH karte:CardT DO
            IF top.typ # koenig THEN
               IF (karte.farbe = top.farbe) AND (karte.typ = top.typ + 1)
               THEN RETURN TRUE;
               ELSE RETURN FALSE;
               END;
            END;
         END;
      END;
   ELSIF karte(CardT).typ = as THEN RETURN TRUE;
   END;
   RETURN FALSE;

END pruefefam;

PROCEDURE pruefebau(i:INTEGER;karte: Lists.NodePtr) : BOOLEAN;

VAR top:Lists.NodePtr;

BEGIN
   IF OpenBsize[i] > 0 THEN
      top := Lists.Head(Bau[i]);
      IF top # NIL THEN
         WITH top:CardT DO
            WITH karte:CardT DO
               IF (karte.typ = top.typ - 1) AND
                  ((((karte.farbe = pik) OR (karte.farbe = kreuz)) AND
                   ((top.farbe = karo) OR (top.farbe = herz))) OR
                   (((karte.farbe = karo) OR (karte.farbe = herz)) AND
                   ((top.farbe = pik) OR (top.farbe = kreuz))))
               THEN RETURN TRUE;
               END;
            END;
         END;
      END;
   ELSIF (CloseBsize[i] = 0) AND (karte(CardT).typ = koenig)
      THEN RETURN TRUE;
   END;
   RETURN FALSE;

END pruefebau;

PROCEDURE TesteEnde;

VAR j,k: INTEGER;
    card,fcard: Lists.NodePtr;
    fertig: BOOLEAN;
    
BEGIN

   IF (Talonsize = 0) AND (Ablagesize = 0) THEN
      j := 0;
      gewonnen := TRUE;
      REPEAT
         IF CloseBsize[j] > 0 THEN gewonnen := FALSE END;
         INC(j);
      UNTIL j = 10;
      IF gewonnen THEN
         DEC(velo,2);
         fertig := TRUE;
         j := 0;
         LOOP
            IF OpenBsize[j] >0 THEN
               fertig := FALSE;
               card := Lists.Head(Bau[j]);
               k := 0;
               REPEAT
                  IF NOT Lists.Empty(Familie[k]) THEN
                     fcard := Lists.Head(Familie[k]);
                     IF (card(CardT).farbe = fcard(CardT).farbe) AND (card(CardT).typ = fcard(CardT).typ+1) THEN
                        card := Lists.RemHead(Bau[j]);
                        DEC(OpenBsize[j]);
                        MaleBaustelle(j);
                        DrawLineCard(card,BauX[j],BauY[0]+9*(OpenBsize[j]),
                                     FamX[k],FamY);
                        Lists.AddHead(Familie[k],card);
                        MaleFamilie(k);
                        k := 7;                        
                     END;
                  ELSIF card(CardT).typ = as THEN
                     card := Lists.RemHead(Bau[j]);
                     DEC(OpenBsize[j]);
                     MaleBaustelle(j);
                     DrawLineCard(card,BauX[j],BauY[0]+9*(OpenBsize[j]),
                                  FamX[k],FamY);
                     Lists.AddHead(Familie[k],card);
                     MaleFamilie(k);
                     k := 7;
                  END;
                  INC(k);
               UNTIL k = 8;
            END;
            INC(j); 
            IF j = 10 THEN
               j := 0;
               IF fertig THEN EXIT; ELSE fertig := TRUE; END;
            END;
         END;
         INC(velo,2);
      END;
   END;

END TesteEnde;

BEGIN

   x := WinP^.mouseX;
   y := WinP^.mouseY;
   took := FALSE; talontake := FALSE; ablagetake := FALSE;
   totalon := FALSE;toab := FALSE;tono := TRUE;
   drehstapel := FALSE; mittestapel := FALSE;
   i := 0;
   REPEAT
      stapeltake[i] := FALSE;
      bautake[i] := FALSE;
      tobau[i] := FALSE;
      INC(i);
   UNTIL i = 10;
   i := 0;
   REPEAT
      tofam[i] := FALSE;
      INC(i);
   UNTIL i = 8;

   IF (x > 620) AND (y < 12) THEN I.ScreenToBack(ScP);END;
   IF (x >= talonx) AND (x <= talonx+kbreite) AND (y >= talony)
      AND (y <= talony+khoehe)
   THEN
      IF Talonsize > 0 THEN
         karte := Lists.RemHead(Talon);
         DEC(Talonsize); talontake := TRUE; took := TRUE;MaleTalon;
      ELSE
         INC(runde);
         IF Ablagesize > 0 THEN
            REPEAT
               karte := Lists.RemHead(Ablage);
               DEC(Ablagesize);
               Lists.AddHead(Talon,karte);
               INC(Talonsize);
            UNTIL Ablagesize = 0;
            MaleAblage;MaleTalon;
            IF runde > 3 THEN
               IF ThreeGadReq("THE HARP","You already played the talon 3 times ! Do you want to continue anyway ?","YES, I cheat","NO, I lost","")=0
               THEN newgame := TRUE;END;
            END;
         END;
         LastTalon := Talonsize;
      END;
   ELSIF
      (Ablagesize > 0) AND (x >= junkx) AND (x <= junkx+kbreite) AND (y >= junky)
      AND (y <= junky+khoehe)
   THEN
      karte := Lists.RemHead(Ablage);
      DEC(Ablagesize); ablagetake := TRUE; took := TRUE;MaleAblage;
   ELSE
      i := 0;
      LOOP
         IF (x >= BauX[i]) AND (x <= BauX[i]+kbreite) THEN
            IF OpenBsize[i] > 0 THEN
               IF y >= BauY[CloseBsize[i]] THEN
                  IF OpenBsize[i] > 1 THEN
                     j := 1;
                     REPEAT
                        IF y <= BauY[CloseBsize[i]] + j*9 THEN
                           stapeltake[i] := TRUE; took := TRUE;
                           stkblau := FALSE;
                           numstapel := j;
                           karte := Lists.Head(Bau[i]);
                           k := j;
                           REPEAT
                              INC(k);
                           UNTIL (NOT Lists.Next(karte)) OR (k = OpenBsize[i]);
                           Lists.Remove(Bau[i],karte);
                           karte2 := Lists.Head(Bau[i]);
                           k := j;
                           REPEAT
                              INC(k);
                           UNTIL (NOT Lists.Next(karte2)) OR (k = OpenBsize[i]);
                           IF j > 1 THEN
                              WITH karte2:CardT DO
                                 IF G.BltBitMap(cardBMs[karte2.farbe,karte2.typ],
                                    0,0,WinP.rPort.bitMap,
                                    BauX[i],BauY[CloseBsize[i]]+(j-2)*9,
                                    kbreite,18,
                                    0C0X,SHORTSET{0..7},0)=0 THEN END;
                                 stkfarbe := karte2.farbe;
                                 stktyp := karte2.typ;
                              END;
                              mittestapel := TRUE;
                           ELSE
                              IF CloseBsize[i] > 0 THEN
                                 IF karte2(CardT).blau THEN
                                    IF G.BltBitMap(backblue,0,0,WinP.rPort.bitMap,
                                       BauX[i],BauY[CloseBsize[i]-1],
                                       kbreite,15,
                                       0C0X,SHORTSET{0..7},0)=0 THEN END;
                                    stkblau := TRUE;
                                 ELSE
                                    IF G.BltBitMap(backred,0,0,WinP.rPort.bitMap,
                                       BauX[i],BauY[CloseBsize[i]-1],
                                       kbreite,15,
                                       0C0X,SHORTSET{0..7},0)=0 THEN END;
                                 END;
                                 drehstapel := TRUE;
                              ELSE
                                 IF G.BltBitMap(Leerstelle,0,0,WinP.rPort.bitMap,
                                    BauX[i],BauY[0],
                                    kbreite,9,
                                    0C0X,SHORTSET{0..7},0)=0 THEN END;
                              END;
                           END;
                           DEC(OpenBsize[i]);
                           EXIT;
                        END;
                        INC(j);
                     UNTIL j = OpenBsize[i];
                     IF y <= BauY[CloseBsize[i]] + (j-1)*9 + khoehe THEN
                        karte := Lists.RemHead(Bau[i]);
                        bautake[i] := TRUE; took := TRUE;
                        DEC(OpenBsize[i]);
                        MaleBaustelle(i);
                        EXIT;
                     END;
                  ELSE
                     IF y <= BauY[CloseBsize[i]]+khoehe THEN
                        karte := Lists.RemHead(Bau[i]);
                        bautake[i] := TRUE; took := TRUE;
                        DEC(OpenBsize[i]);
                        MaleBaustelle(i);
                     END;                     
                  END;
               END;
            ELSE
               IF (CloseBsize[i] > 0) AND (y >= BauY[0]) AND
                  (y <= BauY[CloseBsize[i]]+khoehe) THEN
                  DEC(CloseBsize[i]);
                  INC(OpenBsize[i]);
                  MaleBaustelle(i);
               END;
            END;
         END;
         INC(i);IF i = 10 THEN EXIT END;
      END;
   END;
         
   IF took THEN
      I.SetPointer(WinP,SYSTEM.VAL(LONGINT,Backs.hand2Data),16,15,7,0);
      DragKarte(karte,x,y,endx,endy);
      I.SetPointer(WinP,SYSTEM.VAL(LONGINT,Backs.hand1Data),16,16,0,0);
      I.ModifyIDCMP(WinP,LONGSET{});
      backx := endx-kdx; backy := endy-kdy;
      IF endx > maxx+kdx THEN backx := maxx; END;
      IF endx <      kdx THEN backx :=    0; END;
      IF endy > maxy+kdy THEN backy := maxy; END;
      IF endy <      kdy THEN backy :=    0; END;
      IF (endx >= junkx) AND (endx <= junkx+kbreite) AND (endy >= junky)
         AND (endy <= junky+khoehe) THEN toab := TRUE; tono := FALSE;
      ELSIF (endx >= talonx) AND (endx <= talonx+kbreite) AND (endy >= talony)
         AND (endy <= talony+khoehe) THEN totalon := TRUE; tono := FALSE;
      ELSE
         i := 0;
         LOOP
            IF i < 8 THEN
               IF (endx >= FamX[i]) AND (endx <= FamX[i]+kbreite)
                  AND (endy >= FamY) AND (endy <= FamY+khoehe)
               THEN tofam[i] := TRUE; tono := FALSE; EXIT; END;
            END;
            IF (endx >= BauX[i]) AND (endx <= BauX[i]+kbreite)
               AND (endy >= BauY[0]) AND (endy <= BauY[0]+(9-i)*6+12*9+khoehe)
            THEN tobau[i] := TRUE; tono := FALSE;
               EXIT; END;
            INC(i); IF i = 10 THEN EXIT;END;
         END;
      END;

      IF NOT tono THEN
         tono := TRUE;
         IF talontake OR ablagetake THEN
            IF talontake AND totalon THEN
               Lists.AddHead(Talon,karte);
               INC(Talonsize);tono := FALSE;
               MaleTalon;
            ELSIF toab THEN
               Lists.AddHead(Ablage,karte);
               INC(Ablagesize);tono := FALSE;
               MaleAblage;
            ELSE
               i := 0;
               LOOP
                  IF tobau[i] THEN
                     IF pruefebau(i,karte) THEN
                        Lists.AddHead(Bau[i],karte);
                        INC(OpenBsize[i]);tono := FALSE;
                        MaleBaustelle(i);
                        EXIT;
                     ELSE
                        DrawLineCard(karte,backx,backy,junkx,junky);
                        Lists.AddHead(Ablage,karte);
                        INC(Ablagesize);tono := FALSE;
                        MaleAblage;
                        EXIT;
                     END;
                  END;
                  IF i < 8 THEN
                     IF tofam[i] THEN
                        IF pruefefam(i,karte) THEN
                           Lists.AddHead(Familie[i],karte);tono := FALSE;
                           MaleFamilie(i);
                           EXIT;
                        ELSE
                           DrawLineCard(karte,backx,backy,junkx,junky);
                           Lists.AddHead(Ablage,karte);
                           INC(Ablagesize);tono := FALSE;
                           MaleAblage;
                           EXIT;
                        END;
                     END;
                  END;
                  INC(i);
                  IF i = 10 THEN EXIT;END;
               END;
            END;
         ELSE
            i := 0;
            LOOP
               IF bautake[i] THEN
                  IF tobau[i] THEN Lists.AddHead(Bau[i],karte);INC(OpenBsize[i]);
                     MaleBaustelle(i);tono := FALSE;EXIT;
                  ELSE
                     j := 0;
                     REPEAT
                        IF j < 8 THEN
                           IF tofam[j] THEN
                              IF pruefefam(j,karte) THEN
                                 Lists.AddHead(Familie[j],karte);
                                 MaleFamilie(j);
                                 tono := FALSE;
                                 EXIT;
                              ELSE EXIT;
                              END;
                           END;
                        END;
                        IF (j # i) AND tobau[j] THEN
                          IF pruefebau(j,karte) THEN
                             Lists.AddHead(Bau[j],karte);
                             INC(OpenBsize[j]);tono := FALSE;
                             MaleBaustelle(j);
                             EXIT;
                          ELSE EXIT;
                          END;
                        END;
                        INC(j);
                     UNTIL j = 10;
                  END;
               ELSIF stapeltake[i] THEN
                  IF tobau[i] THEN
                     INC(OpenBsize[i]);
                     karte2 := Lists.Head(Bau[i]);
                     k := OpenBsize[i];
                     REPEAT
                        DEC(k);
                     UNTIL (NOT Lists.Next(karte2)) OR (k = numstapel);
                     IF karte2 # NIL THEN
                        Lists.AddBefore(Bau[i],karte,karte2);
                     ELSE
                        Lists.AddTail(Bau[i],karte);
                     END;
                     WITH karte:CardT DO
                        IF G.BltBitMap(cardBMs[karte.farbe,karte.typ],0,0,
                           WinP.rPort.bitMap,
                           BauX[i],BauY[CloseBsize[i]]+(numstapel-1)*9,
                           kbreite,9,0C0X,SHORTSET{0..7},0)=0 THEN END;
                     END;
                     tono := FALSE;EXIT;
                  ELSE         
                     j := 0;
                     REPEAT
                        IF j # i THEN
                           IF tobau[j] THEN
                              IF pruefebau(j,karte) THEN
                                 INC(OpenBsize[j]);
                                 Lists.AddHead(Bau[j],karte);
                                 MaleBaustelle(j);
                                 tono := FALSE;
                                 tomove := OpenBsize[i]-numstapel;
                                 l := 0;
                                 REPEAT
                                    IF mittestapel THEN
                                       CASE l OF
                                          0:
                                             IF G.BltBitMap(cardBMs[stkfarbe,stktyp],
                                                0,0,WinP.rPort.bitMap,
                                                BauX[i],BauY[CloseBsize[i]]+(numstapel-2)*9,
                                                kbreite,27,0C0X,SHORTSET{0..7},0)=0 THEN END;
                                             |
                                          1:
                                             Depict(cardBMs[stkfarbe,stktyp],BauX[i],BauY[CloseBsize[i]]+(numstapel-2)*9);
                                             G.SetAPen(WinP.rPort,0);
                                             G.RectFill(WinP.rPort,BauX[i],BauY[CloseBsize[i]]+(numstapel-2)*9+khoehe,
                                                        BauX[i]+kbreite,BauY[CloseBsize[i]]+(numstapel-2)*9+khoehe);
                                       ELSE
                                          G.SetAPen(WinP.rPort,0);
                                          G.RectFill(WinP.rPort,BauX[i],BauY[CloseBsize[i]]+(numstapel+l)*9,
                                                     BauX[i]+kbreite,BauY[CloseBsize[i]]+(numstapel+l)*9+8);
                                       END;
                                    ELSIF drehstapel THEN
                                       CASE l OF
                                          0:
                                             IF stkblau THEN
                                                IF G.BltBitMap(backblue,0,0,WinP.rPort.bitMap,
                                                   BauX[i],BauY[CloseBsize[i]-1],
                                                   kbreite,24,0C0X,SHORTSET{0..7},0)=0 THEN END;
                                             ELSE
                                                IF G.BltBitMap(backred,0,0,WinP.rPort.bitMap,
                                                BauX[i],BauY[CloseBsize[i]-1],
                                                kbreite,24,0C0X,SHORTSET{0..7},0)=0 THEN END;
                                             END;
                                             |
                                          1:
                                             IF stkblau THEN
                                                IF G.BltBitMap(backblue,0,0,WinP.rPort.bitMap,
                                                   BauX[i],BauY[CloseBsize[i]-1],
                                                   kbreite,33,0C0X,SHORTSET{0..7},0)=0 THEN END;
                                             ELSE
                                                IF G.BltBitMap(backred,0,0,WinP.rPort.bitMap,
                                                BauX[i],BauY[CloseBsize[i]-1],
                                                kbreite,33,0C0X,SHORTSET{0..7},0)=0 THEN END;
                                             END;
                                             |
                                           2:
                                             IF stkblau THEN
                                                Depict(backblue,BauX[i],BauY[CloseBsize[i]-1]);
                                             ELSE
                                                Depict(backred,BauX[i],BauY[CloseBsize[i]-1]);
                                             END;
                                             G.SetAPen(WinP.rPort,0);
                                             G.RectFill(WinP.rPort,BauX[i],BauY[CloseBsize[i]-1]+khoehe,
                                                        BauX[i]+kbreite,BauY[CloseBsize[i]-1]+khoehe+6);|
                                       ELSE
                                          G.SetAPen(WinP.rPort,0);
                                          G.RectFill(WinP.rPort,BauX[i],BauY[CloseBsize[i]]+(numstapel+l)*9,
                                                     BauX[i]+kbreite,BauY[CloseBsize[i]]+(numstapel+l)*9+8);
                                       END;
                                    ELSE
                                       CASE l OF
                                          0:
                                            IF G.BltBitMap(Leerstelle,0,0,WinP.rPort.bitMap,
                                            BauX[i],BauY[0],
                                            kbreite,18,0C0X,SHORTSET{0..7},0)=0 THEN END;|
                                          1:
                                            IF G.BltBitMap(Leerstelle,0,0,WinP.rPort.bitMap,
                                            BauX[i],BauY[0],
                                            kbreite,27,0C0X,SHORTSET{0..7},0)=0 THEN END;|
                                          2:
                                            Depict(Leerstelle,BauX[i],BauY[0]);
                                            G.SetAPen(WinP.rPort,0);
                                            G.RectFill(WinP.rPort,BauX[i],BauY[0]+khoehe,
                                                       BauX[i]+kbreite,BauY[0]+khoehe);|
                                       ELSE
                                          G.SetAPen(WinP.rPort,0);
                                          G.RectFill(WinP.rPort,BauX[i],BauY[CloseBsize[i]]+(numstapel+l)*9,
                                                     BauX[i]+kbreite,BauY[CloseBsize[i]]+(numstapel+l)*9+8);
                                       END;
                                    END;
                                    karte2 := Lists.Head(Bau[i]);
                                       k := 0;
                                       WHILE (k < tomove-l) DO
                                          IF Lists.Next(karte2) THEN END;
                                          INC(k);
                                       END;
                                    Lists.Remove(Bau[i],karte2);
                                    DEC(OpenBsize[i]);
                                    IF (l = tomove) THEN MaleBaustelle(i);END;
                                    DrawLineCard(karte2,BauX[i],BauY[CloseBsize[i]]+(numstapel+l)*9,
                                                       BauX[j],BauY[CloseBsize[j]]+OpenBsize[j]*9);
                                    INC(OpenBsize[j]);
                                    Lists.AddHead(Bau[j],karte2);
                                    MaleBaustelle(j);
                                    INC(l);
                                 UNTIL l >= tomove+1;
                                 EXIT;
                              ELSE EXIT;
                              END;
                           END;
                        END;
                        INC(j);
                     UNTIL j = 10;
                  END;
               END;
               INC(i); IF i = 10 THEN EXIT END;
            END;
         END;
      END;               (* IF NOT tono ...   *)

      IF tono THEN
         IF talontake OR ablagetake THEN
            DrawLineCard(karte,backx,backy,junkx,junky);
            Lists.AddHead(Ablage,karte);INC(Ablagesize);
            MaleAblage;
         ELSE
            i := 0;
            LOOP
               IF bautake[i] THEN
                  Lists.AddHead(Bau[i],karte);INC(OpenBsize[i]);
                  DrawLineCard(karte,backx,backy,BauX[i],BauY[CloseBsize[i]]+(OpenBsize[i]-1)*9);
                  MaleBaustelle(i);EXIT;
               END;
               IF stapeltake[i] THEN
                  DrawLineCard(karte,backx,backy,BauX[i],BauY[CloseBsize[i]]+(numstapel-1)*9);
                  INC(OpenBsize[i]);
                  karte2 := Lists.Head(Bau[i]);
                  k := OpenBsize[i];
                  REPEAT
                     DEC(k);
                  UNTIL (NOT Lists.Next(karte2)) OR (k = numstapel);
                  IF karte2 # NIL THEN
                     Lists.AddBefore(Bau[i],karte,karte2);
                  ELSE
                     Lists.AddTail(Bau[i],karte);
                  END;
                  WITH karte:CardT DO
                     IF G.BltBitMap(cardBMs[karte.farbe,karte.typ],0,0,
                        WinP.rPort.bitMap,
                        BauX[i],BauY[CloseBsize[i]]+(numstapel-1)*9,
                        kbreite,9,0C0X,SHORTSET{0..7},0)=0 THEN END;
                  END;
                  EXIT;
               END;
               INC(i); IF i = 10 THEN EXIT END;
            END;
         END;
      END;        (* IF tono ... *)       
   END;                    (* IF took ... *)
   TesteEnde;
   I.ModifyIDCMP(WinP,LONGSET{I.mouseButtons,I.rawKey,I.gadgetUp});
   
END MoveKarte;

(* ------------------------------------------------------------------ *)

PROCEDURE ReturnKarten(VAR Ks : Lists.List);

VAR karte : Lists.NodePtr;
        j : INTEGER;
BEGIN

   WHILE Ablagesize > 0 DO
         karte := Lists.RemHead(Ablage);
         DEC(Ablagesize);
         Lists.AddHead(Ks,karte);
   END;
   j := 0;
   REPEAT
      WHILE OpenBsize[j] > 0 DO
            karte := Lists.RemHead(Bau[j]);
            DEC(OpenBsize[j]);
            Lists.AddHead(Ks,karte);
            MaleBaustelle(j);
      END;
      WHILE CloseBsize[j] > 0 DO
            karte := Lists.RemHead(Bau[j]);
            DEC(CloseBsize[j]);
            Lists.AddHead(Ks,karte);
            MaleBaustelle(j);
      END;
      INC(j);
   UNTIL j = 10;
   j := 0;
   REPEAT
      WHILE NOT Lists.Empty(Familie[j]) DO
            karte := Lists.RemHead(Familie[j]);
            Lists.AddHead(Ks,karte);
      END;
      INC(j);
   UNTIL j = 8;

END ReturnKarten;

(* ------------------------------------------------------------------ *)
(* ------------------------------------------------------------------ *)

BEGIN

OpenAll();
myproc := SYSTEM.VAL(Dos.ProcessPtr,E.FindTask(NIL));
oldWinP := myproc.windowPtr;
myproc.windowPtr := WinP;
InitCardBMs;
velo := 9;
NumsOn := TRUE; stop := FALSE;
InitKarten(Talon);

REPEAT
   Talonsize := 104;
   runde := 1;
   gewonnen := FALSE;
   newgame := FALSE;
   MischKarten(Talon);
   MaleAnfang;
   WriteNums(FALSE,TRUE,TRUE);
   InitStapel;
   I.ModifyIDCMP(WinP,LONGSET{I.mouseButtons,I.rawKey,I.gadgetUp});
   
   LOOP
      LOOP
        IMessPtr := E.GetMsg(WinP.userPort);
        IF IMessPtr # NIL THEN EXIT END;
        E.WaitPort(WinP.userPort);
      END;
      IMess := IMessPtr^;
      E.ReplyMsg(IMessPtr);

      IF (I.mouseButtons IN IMess.class) AND (IMess.code = I.selectDown) THEN
         MoveKarte;
         IF gewonnen THEN
            IF ThreeGadReq(" BRAVO! You made it! ","      Another game ?      ","  NO !  "," YES ! ","")=0 THEN
               I.ModifyIDCMP(WinP,LONGSET{});
            ELSE
               stop := TRUE;
            END;
            EXIT;
         END;
      END;        
      
      IF newgame THEN I.ModifyIDCMP(WinP,LONGSET{});EXIT;END;
      
      IF (I.rawKey IN IMess.class) THEN
         CASE IMess.code OF
            70: WriteNums(TRUE,TRUE,TRUE);|
            95: Harphelp.Help;
                I.ActivateWindow(WinP);|
            69: IF ThreeGadReq(" Start a new game ? ","                    "," Oh no! "," YES ! ","")=0 THEN
                I.ModifyIDCMP(WinP,LONGSET{});EXIT;END;|
            16: IF ThreeGadReq(" Really quit ? ","               "," Oh no! "," Quit ! ","")=0 THEN
                stop := TRUE;EXIT;END;|
         ELSE
         END;   
      END;
      
      IF (I.gadgetUp IN IMess.class) THEN
         gadgetPtr := IMess.iAddress;
         gadgetnum := gadgetPtr.gadgetID;
   
         CASE gadgetnum OF

            0: IF ThreeGadReq(" Really quit ? ","               "," Oh no! "," Quit ! ","")=0 THEN
               stop := TRUE;EXIT;END;|
            1: Harphelp.Help;
               I.ActivateWindow(WinP);|
            2: IF ThreeGadReq(" Start a new game ? ","                    "," Oh no! "," YES ! ","")=0 THEN
               I.ModifyIDCMP(WinP,LONGSET{});EXIT;END;|
            3: WriteNums(TRUE,TRUE,TRUE);|
         ELSE
         END;
      END;

   END;
   
   IF stop THEN
      int := 1;      
      REPEAT
         I.MoveScreen(ScP,0,3);
         INC(int);
      UNTIL int = 96;
   ELSE
      Ausblenden(ScP);
      ReturnKarten(Talon);
      WriteNums(FALSE,TRUE,TRUE);
      MaleAnfang;
   END;

UNTIL stop;

CLOSE

IF (myproc # NIL) AND (myproc.windowPtr # NIL) THEN myproc.windowPtr := oldWinP;END;
IF WinP # NIL THEN I.CloseWindow(WinP);END;
IF ScP # NIL THEN I.CloseScreen(ScP);END;

END Harp.
