MODULE Harphelp;

IMPORT
      I : Intuition,
      G : Graphics,
      E : Exec,
      ol: OberonLib,
      Requests,
      Backs,
      SYSTEM;

VAR
   HlpScP     : I.ScreenPtr;
   HlpWinP    : I.WindowPtr;

(* ------------------------------------------------------------------ *)

PROCEDURE WaitLeftButton*(VAR WindowZeiger:I.WindowPtr);

VAR
   IMess      : I.IntuiMessage;
   IMessPtr   : I.IntuiMessagePtr;

BEGIN

LOOP
   LOOP
      IMessPtr := E.GetMsg(WindowZeiger.userPort);
      IF IMessPtr # NIL THEN EXIT END;
      E.WaitPort(WindowZeiger.userPort);
   END;

  IMess := IMessPtr^;
  E.ReplyMsg(IMessPtr);
  IF (I.mouseButtons IN IMess.class) AND (IMess.code = I.selectDown) THEN
  EXIT; END;
END;

END WaitLeftButton;

(* ------------------------------------------------------------------ *)

PROCEDURE Openhelp() : BOOLEAN;

VAR
   Nw   : I.NewWindow;
   NSc  : I.NewScreen;
   top8 : G.TextAttr;
   
BEGIN

   IF G.gfx.normalDisplayColumns >= 640 THEN
      NSc.leftEdge := (G.gfx.normalDisplayColumns - 640) DIV 2;
   ELSE NSc.leftEdge := 0;
   END;
   NSc.topEdge      := 0;
   NSc.width        := 640;  NSc.height       := 256;
   NSc.depth        := 1;    NSc.detailPen    := 0;
   NSc.blockPen     := 1;    NSc.viewModes    := {G.hires};
   NSc.type         := I.customScreen;
   NSc.font := NIL;
   NSc.defaultTitle := NIL;
   NSc.gadgets      := NIL;  NSc.customBitMap := NIL;
   INCL(NSc.type,I.screenQuiet);
   INCL(NSc.type,I.screenBehind);
   
   LOOP
      
      HlpScP := I.OpenScreen(NSc);
      IF HlpScP = NIL THEN
         IF NOT Requests.Request("Patience:","Couldn't open help screen !","Retry","Abort")
            THEN EXIT;
         END;
      ELSE
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),0,0,0,0);
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),1,13,13,13);
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),17,13,0,15);
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),18,14,11,11);
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),19,5,5,5);

            Nw.leftEdge      := 0;      Nw.topEdge       := 0;
            Nw.width         := 640;    Nw.height        := 256;
            Nw.detailPen     := 0;      Nw.blockPen      := 1;
            Nw.idcmpFlags    := LONGSET{I.mouseButtons};
            Nw.flags         := LONGSET{I.activate,I.borderless,I.rmbTrap};
            Nw.firstGadget   := NIL;    Nw.checkMark     := NIL;
            Nw.screen        := HlpScP; Nw.bitMap        := NIL;
            Nw.minWidth      := 128;    Nw.minHeight     := 24;
            Nw.maxWidth      := -1;     Nw.maxHeight     := -1;
            Nw.title         := NIL;    Nw.type          := I.customScreen;

         LOOP
            HlpWinP := I.OpenWindow(Nw);
            IF HlpWinP = NIL THEN
               IF NOT Requests.Request("Patience:","Couldn't open help window !","Retry","Abort")
                  THEN I.CloseScreen(HlpScP);EXIT;
               END;
            ELSE
               I.SetPointer(HlpWinP,SYSTEM.VAL(LONGINT,Backs.hand1Data),16,16,0,0);
               top8.name        := SYSTEM.ADR("topaz.font");
               top8.ySize       := 8;
               top8.style       := SHORTSET{};
               top8.flags       := SHORTSET{G.romFont};
               G.SetFont(HlpWinP.rPort,G.OpenFont(SYSTEM.ADR(top8)));
               RETURN TRUE;
            END;
         END;
      END;
      EXIT;
   END;
   RETURN FALSE;

END Openhelp;

(* ------------------------------------------------------------------ *)

PROCEDURE Help*();

VAR int: INTEGER;
    lib: G.BitMapPtr;

PROCEDURE Text(y: INTEGER; s: ARRAY OF CHAR);

BEGIN

  G.Move(HlpWinP.rPort,15,y);
  G.Text(HlpWinP.rPort,s,75);

END Text;

BEGIN

IF Openhelp() THEN

NEW(lib);
IF lib # NIL THEN
   G.InitBitMap(lib^,1,59,30);
   lib.planes[0] := SYSTEM.VAL(LONGINT,Backs.LibertyData);
END;

I.MoveScreen(HlpScP,0,285);
G.SetDrMd(HlpWinP.rPort,G.jam2);

Text(12,"                                 THE HARP                                  ");
Text(24,"The aim of this patience game is to complete the card families on the piles");
Text(36,"of the top line.  They start with an ace and should end with a king  of the");
Text(48,"same  suit  ( for absolute  beginners - the order to accomplish should be :");
Text(60,"ace, two, three, ...  , ten, jack, queen, king).                           ");
Text(72,"   So, whereever an ace should appear you should put it to the top row.  On");
Text(84,"the  harp shaped rows you may build rows of cards in descending order.  But");
Text(96,"here  they  must  not  have  the  same  suit.   There  has to be a red card");
Text(108,"(diamonds or hearts) and a black card (spades or clubs) alternately.  It is");
Text(120,"possible  to  move a whole stack of cards to another row by clicking on any");
Text(132,"card in the row and moving this card to the bottom of the other row.       ");
Text(144,"When  you  come  to  a  card  that lies upside down, click on it to turn it");
Text(156,"around.  While building on the rows, there will be empty rows sometime.  On");
Text(168,"those  you  may put kings or rows of cards ending with a king respectively.");
Text(180,"No other card is allowed there.                                            ");
Text(192,"When  there is no more possibility to build within the rows or to put cards");
Text(204,"up  to their family in the top line, you take new cards from the talon pile");
Text(216,"in the right bottom corner.  If they don't fit, put them on the pile on the");
Text(228,"left  of  the talon.  You may always take the top card of this pile and put");
Text(240,"                             Click for more !                              ");

I.ScreenToFront(HlpScP);
int := 1;
REPEAT
   I.MoveScreen(HlpScP,0,-4);
   INC(int);
UNTIL int = 73;

WaitLeftButton(HlpWinP);

Text(12,"it  onto  the  rows of the harp or to its family.  Once the talon is empty,");
Text(24,"click on its empty box to turn around the junk pile and make it to your new");
Text(36,"talon.   Usually,  it is allowed to play the talon three times, but in this");
Text(48,"conversion  you  may  play  on  and  on  and  on...   -  or  click  on  the");
Text(60,"self-explanatory  gadgets  to  begin a new game or to quit out if you don't");
Text(72,"see  any  sense in going on.  But since this patience game is quite easy to");
Text(84,"solve, you won't have to do that too often.                                ");
Text(96,"   Not  a  game  for those who like lots of action - for me it was even too");
Text(108,"much  action  to  shuffle  the  cards  (that's  why I started to write this");
Text(120,"program  in  the  first  place).   If you like the game, please let me know");
Text(132,"(there  are  lots  of  different patience games on the waiting list).  Send");
Text(144,"picture postcards, greetings, whatever (even donations are welcome) to:    ");
Text(156,"                                                                           ");
Text(168,"                                                                           ");
Text(180,"Achim Siebert                                                              ");
Text(192,"Nobileweg 67                                                               ");
Text(204,"7000 Stuttgart 40 , Germany                         1990 by Achim Siebert.");
Text(216,"     No use of any part of the program without my special permission.      ");
Text(228,"        Source in Oberon (thanks to brother dear for the compiler).        ");
Text(240,"                             Click to continue !                           ");

IF (lib # NIL) AND (lib.planes[0] # NIL) THEN
   IF G.BltBitMap(lib,0,0,HlpWinP.rPort.bitMap,291,175,59,30,0C0X,SHORTSET{0..7},0)=0 THEN END;
END;
WaitLeftButton(HlpWinP);
int := 1;
REPEAT
   I.MoveScreen(HlpScP,0,4);
   INC(int);
UNTIL int = 73;

I.ScreenToBack(HlpScP);

I.CloseWindow(HlpWinP);
I.CloseScreen(HlpScP);

END; (* IF Openhelp() ... *)

END Help; 

END Harphelp.
