(*---------------------------------------------------------------------------
    :Program.    Plait.mod
    :Author.     Achim Siebert
    :Address.    Nobileweg 67, D-7000 Stuttgart-40
    :Phone.      0711/822509
    :Shortcut.   [acs]
    :Version.    1.0
    :Date.       02-Dec-90
    :Copyright.  PD
    :Language.   Oberon
    :Translator. Oberon
    :Imports.    none.
    :UpDate.     none.
    :Contents.   Patience game.
    :Remark.     Req.library needed!
---------------------------------------------------------------------------*)

MODULE Plait;

IMPORT
      KaroData,HerzData,PikData,KreuzData,Backs,
      Plaithelp,
      I : Intuition,
      G : Graphics,
      E : Exec,
      Dos,
      Req,
      Requests,
      Conversions,
      Strings,
      Random,
      Lists,
      ol : OberonLib,
      SYSTEM;

TYPE  CardT = RECORD(Lists.Node)
         farbe: INTEGER;
         typ: INTEGER;
         blau: BOOLEAN;
      END;
      CardTP = POINTER TO CardT;

VAR   WinP,oldWinP : I.WindowPtr;
      ScP          : I.ScreenPtr;
      top8         : G.TextAttr;
      IMess        : I.IntuiMessage;
      IMessPtr     : I.IntuiMessagePtr;
      gadblocks    : ARRAY 5 OF Req.GadgetBlock;
      gadgetPtr    : I.GadgetPtr;
      gadgetnum    : INTEGER;
      myproc       : Dos.ProcessPtr;
      velo         : INTEGER;
      NumsOn,stop  : BOOLEAN;
      cardBMs      : ARRAY 4, 13 OF G.BitMapPtr;

      Pfeilup,Pfeildown,Leerstelle,backred,backblue,SaveBM : G.BitMapPtr;

      Talon,Ablage,Zopf : Lists.List;

      dreimal,bezugstyp,endtyp,endfarbe,int,Zopfsize,Talonsize,Ablagesize : INTEGER;
      fallend,entschieden,gewonnen,verloren: BOOLEAN;
      text,zaehler,talontake,zopftake,ablagetake: BOOLEAN;
      bautake : ARRAY 10 OF BOOLEAN;

      Familie : ARRAY 8 OF Lists.List;
      Bau : ARRAY 12 OF Lists.List;
      
TYPE
      ColorType = ARRAY 20 OF INTEGER;

CONST

      Colors = ColorType(0000H,0FFFH,0C00H,0F53H,00B0H,0FB0H,000FH,02CDH,
                         0F0CH,0A0FH,0EA9H,0EEEH,0ECBH,078AH,0888H,0444H,
                         0000H,0D0FH,0EBBH,0555H);

TYPE  BauCoords = ARRAY 12 OF INTEGER;
      FamCoords = ARRAY 8 OF INTEGER;
      ZopfCoords= ARRAY 20 OF INTEGER;
      
CONST BauX = BauCoords(100,100,100,100,100,100,297,297,297,297,297,297);
      BauY = BauCoords(10,50,90,130,170,210,10,50,90,130,170,210);
      
      FamX = FamCoords(35,35,35,35,364,364,364,364);
      FamY = FamCoords(50,90,130,170,50,90,130,170);

      ZopfX = ZopfCoords(199,179,199,219,199,179,199,219,199,179,
                         199,219,199,179,199,219,199,179,199,219);
      ZopfY = ZopfCoords(16,26,36,46,56,66,76,86,96,106,
                         116,126,136,146,156,166,176,186,196,206);
                         
      Mangel  = "Out of memory!";
      as      = 0;      karo     = 0;
      zwei    = 1;      herz     = 1;
      drei    = 2;      pik      = 2;
      vier    = 3;      kreuz    = 3;
      fuenf   = 4;
      sechs   = 5;
      sieben  = 6;
      acht    = 7;
      neun    = 8;
      zehn    = 9;
      bube    = 10;
      dame    = 11;
      koenig  = 12;
      gadsx   = 458;    gadsy    =  25;
      junkx   = 472;    junky    = 170;
      referenzx = junkx;referenzy= 108;
      talonx  = 546;    talony   = 170;
      endkx   = talonx; endky    = 108;
      maxx    = 590;    maxy     = 221;
      kbreite =  49;    khoehe   =  35;
      kdx     =  25;    kdy      =  18;

(* ------------------------------------------------------------------ *)

PROCEDURE Ausblenden(screenzeiger: I.ScreenPtr);

VAR      colors,r,g,b: ARRAY 16 OF INTEGER;
            i,j,Rot,Gruen,Blau  : INTEGER;
BEGIN
   i := 0;
   REPEAT
      colors[i] := SHORT(G.GetRGB4(screenzeiger.viewPort.colorMap,i));
      r[i] := colors[i] DIV 256 MOD 16;
      g[i] := colors[i] DIV 16 MOD 16;
      b[i] := colors[i] MOD 16;
      INC(i);
   UNTIL i = 16;
   j := 40;
   REPEAT
      i := 0;   
      REPEAT
         Rot := r[i]*j DIV 40;
         Gruen := g[i]*j DIV 40;
         Blau := b[i]*j DIV 40;
         colors[i] := (Rot*16+Gruen)*16+Blau;
         INC(i);
      UNTIL i = 16;
      G.LoadRGB4(SYSTEM.ADR(screenzeiger.viewPort),colors,16);
      DEC(j);
   UNTIL j < 0;

END Ausblenden;
      
(* ------------------------------------------------------------------ *)

PROCEDURE Einblenden(screenzeiger: I.ScreenPtr;Endfarben:ARRAY OF INTEGER);

VAR      colors,r,g,b: ARRAY 16 OF INTEGER;
            i,j,Rot,Gruen,Blau  : INTEGER;
BEGIN
   i := 0;
   REPEAT
      colors[i] := Endfarben[i];
      r[i] := colors[i] DIV 256 MOD 16;
      g[i] := colors[i] DIV 16 MOD 16;
      b[i] := colors[i] MOD 16;
      INC(i);
   UNTIL i = 16;
   j := 0;
   REPEAT
      i := 0;   
      REPEAT
         Rot := r[i]*j DIV 40;
         Gruen := g[i]*j DIV 40;
         Blau := b[i]*j DIV 40;
         colors[i] := (Rot*16+Gruen)*16+Blau;
         INC(i);
      UNTIL i = 16;
      G.LoadRGB4(SYSTEM.ADR(screenzeiger.viewPort),colors,16);
      INC(j);
   UNTIL j > 40;

END Einblenden;
      
(* ------------------------------------------------------------------ *)

PROCEDURE OpenAll();

VAR
   NSc  : I.NewScreen;
   Nw   : I.NewWindow;
   borderPtr : I.BorderPtr;
   
CONST Black = ColorType(0000H,0000H,0000H,0000H,0000H,0000H,0000H,0000H,
                     0000H,0000H,0000H,0000H,0000H,0000H,0000H,0000H,
                     0000H,0D0FH,0EBBH,0555H);
                     
TYPE gadstringType = ARRAY 5,20 OF CHAR;

CONST gadstrings = gadstringType("    Q = Quit       ",
                                 " HELP = Rules      ",
                                 "  ESC = New Game   ",
                                 "  DEL = Toggle Figs",
                                 "SPACE = Toggle Text");
   
BEGIN
   
   top8.name        := SYSTEM.ADR("topaz.font");
   top8.ySize       := 8;
   top8.style       := SHORTSET{};
   top8.flags       := SHORTSET{G.romFont};
   IF G.gfx.normalDisplayColumns >= 640 THEN
      NSc.leftEdge := (G.gfx.normalDisplayColumns - 640) DIV 2;
   ELSE NSc.leftEdge := 0;
   END;
   NSc.topEdge := 0;
   NSc.width        := 640;
   NSc.height       := 256;   
   NSc.depth        := 4;
   NSc.detailPen    := 0;    NSc.blockPen     := 9;
   NSc.viewModes    := {G.hires};
   NSc.type         := I.customScreen;
   NSc.font         := SYSTEM.ADR(top8);  NSc.defaultTitle := NIL;
   NSc.gadgets      := NIL;  NSc.customBitMap := NIL;
   INCL(NSc.type,I.screenQuiet);
   ScP := I.OpenScreen(NSc); Requests.Assert(ScP#NIL,"Couldn't open screen!");
   G.LoadRGB4(SYSTEM.ADR(ScP.viewPort),Black,20);
   
   Nw.leftEdge      := 0;    Nw.topEdge       := 0;
   Nw.width         := 640;  Nw.height        := 256;
   Nw.detailPen     := 0;    Nw.blockPen      := 9;
   Nw.idcmpFlags    := LONGSET{};
   Nw.flags         := LONGSET{I.activate,I.borderless,I.backDrop,I.rmbTrap};
   Nw.firstGadget   := NIL;  Nw.checkMark     := NIL;
   Nw.screen        := ScP;  Nw.bitMap        := NIL;
   Nw.minWidth      := 128;  Nw.minHeight     := 24;
   Nw.maxWidth      := -1;   Nw.maxHeight     := -1;
   Nw.title         := NIL;  Nw.type          := I.customScreen;
    
   gadgetnum := 0;
   REPEAT
      Req.LinkGadget(SYSTEM.ADR(gadblocks[gadgetnum]),gadstrings[gadgetnum],Nw,
                     gadsx,gadsy+15*gadgetnum);
      gadblocks[gadgetnum].gadget.gadgetID := gadgetnum;
      borderPtr := gadblocks[gadgetnum].gadget.gadgetRender;
      borderPtr.frontPen := 9;
      gadblocks[gadgetnum].gadget.gadgetText.frontPen := 0;
      gadblocks[gadgetnum].gadget.gadgetText.backPen := 11;
      INC(gadgetnum);
   UNTIL gadgetnum = 5;
   WinP := I.OpenWindow(Nw); Requests.Assert(WinP#NIL,"Couldn't open window!");
   G.SetFont(WinP.rPort,G.OpenFont(SYSTEM.ADR(top8)));
   I.SetPointer(WinP,SYSTEM.VAL(LONGINT,Backs.hand1Data),16,16,0,0);
    
END OpenAll;

(* ------------------------------------------------------------------ *)

PROCEDURE WriteText(On:BOOLEAN);

BEGIN
   G.SetDrMd(WinP.rPort,G.jam2);
   IF On THEN
      G.SetAPen(WinP.rPort,11);
      G.Move(WinP.rPort,junkx+7,junky+43);
      G.Text(WinP.rPort,"Junk",4);
      G.Move(WinP.rPort,talonx+5,talony+43);
      G.Text(WinP.rPort,"Talon",5);
      gadgetPtr := WinP.firstGadget;
      REPEAT
         I.OnGadget(gadgetPtr,WinP,NIL);
         gadgetPtr := gadgetPtr.nextGadget;
      UNTIL gadgetPtr = NIL;
   ELSE
      G.SetAPen(WinP.rPort,0);
      G.RectFill(WinP.rPort,junkx,junky+36,junkx+kbreite,junky+46);
      G.RectFill(WinP.rPort,talonx,talony+36,talonx+kbreite,talony+46);
      gadgetPtr := WinP.firstGadget;
      REPEAT
         I.OffGadget(gadgetPtr,WinP,NIL);
         gadgetPtr := gadgetPtr.nextGadget;
      UNTIL gadgetPtr = NIL;
      G.RectFill(WinP.rPort,gadsx-2,gadsy-2,gadsx+153,gadsy+75);
   END;

END WriteText;

(* ------------------------------------------------------------------ *)

PROCEDURE WriteNums(switched,ab,ta:BOOLEAN);

VAR str: ARRAY 8 OF CHAR;

BEGIN

   G.SetDrMd(WinP.rPort,G.jam2);
   IF NumsOn THEN
      IF switched THEN
         G.SetAPen(WinP.rPort,0);
         G.RectFill(WinP.rPort,talonx,talony-14,talonx+kbreite,talony-1);
         G.RectFill(WinP.rPort,junkx,junky-14,junkx+kbreite,junky-1);
         NumsOn := NOT NumsOn;
      ELSE
         IF ta THEN
            G.SetAPen(WinP.rPort,0);
            G.RectFill(WinP.rPort,talonx,talony-14,talonx+kbreite,talony-1);
            G.SetAPen(WinP.rPort,11);
            IF Talonsize < 10 THEN 
               G.Move(WinP.rPort,talonx+4,talony-3);
               IF Conversions.IntToString(LONG(Talonsize),str,2) THEN END;
               G.Text(WinP.rPort,str,Strings.Length(str));
            ELSE
               G.Move(WinP.rPort,talonx+8,talony-3);
               IF Conversions.IntToString(LONG(Talonsize),str,2) THEN END;
               G.Text(WinP.rPort,str,Strings.Length(str));
            END;
         END;
         IF ab THEN
            G.SetAPen(WinP.rPort,0);
            G.RectFill(WinP.rPort,junkx,junky-14,junkx+kbreite,junky-1);
            G.SetAPen(WinP.rPort,11);
            IF Ablagesize < 10 THEN 
               G.Move(WinP.rPort,junkx+4,junky-3);
               IF Conversions.IntToString(LONG(Ablagesize),str,2) THEN END;
               G.Text(WinP.rPort,str,Strings.Length(str));
            ELSE
               G.Move(WinP.rPort,junkx+8,junky-3);
               IF Conversions.IntToString(LONG(Ablagesize),str,2) THEN END;
               G.Text(WinP.rPort,str,Strings.Length(str));
            END;
         END;
      END;
   ELSE
      IF switched THEN
         NumsOn := NOT NumsOn;
         WriteNums(FALSE,TRUE,TRUE);
      END;
   END;
         
END WriteNums;

(* ------------------------------------------------------------------ *)

PROCEDURE InitKarten(VAR Ks: Lists.List);

VAR karte : CardTP;
    i,j   : INTEGER;
    first : BOOLEAN;

BEGIN

Lists.Init(Ks);
first := TRUE;
REPEAT
   i := karo;
   REPEAT
      j := as;
      REPEAT
         NEW(karte);Requests.Assert(karte#NIL,Mangel);
         karte.farbe := i;
         karte.typ := j;
         karte.blau := first;
         Lists.AddTail(Ks,karte);
         INC(j);
       UNTIL j > koenig;
       INC(i);
   UNTIL i > kreuz;
   first := NOT first;
UNTIL first;

END InitKarten;

(* ------------------------------------------------------------------ *)

PROCEDURE MischKarten(VAR Ks: Lists.List);

VAR   Zwischen : Lists.List;
      i,zufall : INTEGER;
      naechste : Lists.NodePtr;

BEGIN

i := Talonsize;
Lists.Init(Zwischen);
REPEAT
   zufall := Random.RND(i);
   naechste := Lists.Head(Ks);
   REPEAT
      DEC(zufall);
   UNTIL (zufall < 0) OR NOT Lists.Next(naechste);
   Lists.Remove(Ks,naechste);
   Lists.AddHead(Zwischen,naechste);
   DEC(i);
UNTIL i = 0;
Ks := Zwischen;

END MischKarten;

(* ------------------------------------------------------------------ *)

PROCEDURE InitCardBMs();

TYPE CAPtr = POINTER TO ARRAY 4, 4*35 OF INTEGER; 
     PfeilPtr = POINTER TO ARRAY 4, 29 OF INTEGER;
     
VAR  i,j   : INTEGER;

PROCEDURE InitBitMap(bm: G.BitMapPtr;data: CAPtr);

BEGIN
  G.InitBitMap(bm^,4,kbreite,khoehe);
  bm.planes[0] := SYSTEM.ADR(data[0]);
  bm.planes[1] := SYSTEM.ADR(data[1]);
  bm.planes[2] := SYSTEM.ADR(data[2]);
  bm.planes[3] := SYSTEM.ADR(data[3]);
END InitBitMap;

PROCEDURE InitPfeile(bm: G.BitMapPtr;data: PfeilPtr);

BEGIN
  G.InitBitMap(bm^,4,15,29);
  bm.planes[0] := SYSTEM.ADR(data[0]);
  bm.planes[1] := SYSTEM.ADR(data[1]);
  bm.planes[2] := SYSTEM.ADR(data[2]);
  bm.planes[3] := SYSTEM.ADR(data[3]);
END InitPfeile;

BEGIN
  i := karo;
  REPEAT
     j := as;
     REPEAT
        NEW(cardBMs[i,j]); Requests.Assert(cardBMs[i,j]#NIL,Mangel);
        INC(j);
     UNTIL j > koenig;
     INC(i)
  UNTIL i > kreuz;

  NEW(backblue);Requests.Assert(backblue#NIL,Mangel);
  NEW(backred); Requests.Assert(backred#NIL,Mangel);
  NEW(SaveBM);  Requests.Assert(SaveBM#NIL,Mangel);
  NEW(Leerstelle);  Requests.Assert(Leerstelle#NIL,Mangel);
  NEW(Pfeilup); Requests.Assert(Pfeilup#NIL,Mangel);
  NEW(Pfeildown); Requests.Assert(Pfeildown#NIL,Mangel);
    
  InitPfeile(Pfeilup,SYSTEM.VAL(LONGINT,Backs.Pfeilhoch));
  InitPfeile(Pfeildown,SYSTEM.VAL(LONGINT,Backs.Pfeilrunter));
  
  G.InitBitMap(SaveBM^,4,kbreite,khoehe);
  INCL(ol.MemReqs,E.chip);
  i := 0;
  REPEAT
    ol.New(SaveBM.planes[i],8*khoehe);
    Requests.Assert(SaveBM.planes[i]#NIL,Mangel);
    INC(i);
  UNTIL i=4;
  EXCL(ol.MemReqs,E.chip);

  InitBitMap(cardBMs[karo,as],SYSTEM.VAL(LONGINT,KaroData.karoasDat));
  InitBitMap(cardBMs[karo,zwei],SYSTEM.VAL(LONGINT,KaroData.karo2Dat));
  InitBitMap(cardBMs[karo,drei],SYSTEM.VAL(LONGINT,KaroData.karo3Dat));
  InitBitMap(cardBMs[karo,vier],SYSTEM.VAL(LONGINT,KaroData.karo4Dat));
  InitBitMap(cardBMs[karo,fuenf],SYSTEM.VAL(LONGINT,KaroData.karo5Dat));
  InitBitMap(cardBMs[karo,sechs],SYSTEM.VAL(LONGINT,KaroData.karo6Dat));
  InitBitMap(cardBMs[karo,sieben],SYSTEM.VAL(LONGINT,KaroData.karo7Dat));
  InitBitMap(cardBMs[karo,acht],SYSTEM.VAL(LONGINT,KaroData.karo8Dat));
  InitBitMap(cardBMs[karo,neun],SYSTEM.VAL(LONGINT,KaroData.karo9Dat));
  InitBitMap(cardBMs[karo,zehn],SYSTEM.VAL(LONGINT,KaroData.karo10Dat));
  InitBitMap(cardBMs[karo,bube],SYSTEM.VAL(LONGINT,KaroData.karobubeDat));
  InitBitMap(cardBMs[karo,dame],SYSTEM.VAL(LONGINT,KaroData.karodameDat));
  InitBitMap(cardBMs[karo,koenig],SYSTEM.VAL(LONGINT,KaroData.karokoenigDat));

  InitBitMap(cardBMs[herz,as],SYSTEM.VAL(LONGINT,HerzData.herzasDat));
  InitBitMap(cardBMs[herz,zwei],SYSTEM.VAL(LONGINT,HerzData.herz2Dat));
  InitBitMap(cardBMs[herz,drei],SYSTEM.VAL(LONGINT,HerzData.herz3Dat));
  InitBitMap(cardBMs[herz,vier],SYSTEM.VAL(LONGINT,HerzData.herz4Dat));
  InitBitMap(cardBMs[herz,fuenf],SYSTEM.VAL(LONGINT,HerzData.herz5Dat));
  InitBitMap(cardBMs[herz,sechs],SYSTEM.VAL(LONGINT,HerzData.herz6Dat));
  InitBitMap(cardBMs[herz,sieben],SYSTEM.VAL(LONGINT,HerzData.herz7Dat));
  InitBitMap(cardBMs[herz,acht],SYSTEM.VAL(LONGINT,HerzData.herz8Dat));
  InitBitMap(cardBMs[herz,neun],SYSTEM.VAL(LONGINT,HerzData.herz9Dat));
  InitBitMap(cardBMs[herz,zehn],SYSTEM.VAL(LONGINT,HerzData.herz10Dat));
  InitBitMap(cardBMs[herz,bube],SYSTEM.VAL(LONGINT,HerzData.herzbubeDat));
  InitBitMap(cardBMs[herz,dame],SYSTEM.VAL(LONGINT,HerzData.herzdameDat));
  InitBitMap(cardBMs[herz,koenig],SYSTEM.VAL(LONGINT,HerzData.herzkoenigDat));

  InitBitMap(cardBMs[pik,as],SYSTEM.VAL(LONGINT,PikData.pikasDat));
  InitBitMap(cardBMs[pik,zwei],SYSTEM.VAL(LONGINT,PikData.pik2Dat));
  InitBitMap(cardBMs[pik,drei],SYSTEM.VAL(LONGINT,PikData.pik3Dat));
  InitBitMap(cardBMs[pik,vier],SYSTEM.VAL(LONGINT,PikData.pik4Dat));
  InitBitMap(cardBMs[pik,fuenf],SYSTEM.VAL(LONGINT,PikData.pik5Dat));
  InitBitMap(cardBMs[pik,sechs],SYSTEM.VAL(LONGINT,PikData.pik6Dat));
  InitBitMap(cardBMs[pik,sieben],SYSTEM.VAL(LONGINT,PikData.pik7Dat));
  InitBitMap(cardBMs[pik,acht],SYSTEM.VAL(LONGINT,PikData.pik8Dat));
  InitBitMap(cardBMs[pik,neun],SYSTEM.VAL(LONGINT,PikData.pik9Dat));
  InitBitMap(cardBMs[pik,zehn],SYSTEM.VAL(LONGINT,PikData.pik10Dat));
  InitBitMap(cardBMs[pik,bube],SYSTEM.VAL(LONGINT,PikData.pikbubeDat));
  InitBitMap(cardBMs[pik,dame],SYSTEM.VAL(LONGINT,PikData.pikdameDat));
  InitBitMap(cardBMs[pik,koenig],SYSTEM.VAL(LONGINT,PikData.pikkoenigDat));

  InitBitMap(cardBMs[kreuz,as],SYSTEM.VAL(LONGINT,KreuzData.kreuzasDat));
  InitBitMap(cardBMs[kreuz,zwei],SYSTEM.VAL(LONGINT,KreuzData.kreuz2Dat));
  InitBitMap(cardBMs[kreuz,drei],SYSTEM.VAL(LONGINT,KreuzData.kreuz3Dat));
  InitBitMap(cardBMs[kreuz,vier],SYSTEM.VAL(LONGINT,KreuzData.kreuz4Dat));
  InitBitMap(cardBMs[kreuz,fuenf],SYSTEM.VAL(LONGINT,KreuzData.kreuz5Dat));
  InitBitMap(cardBMs[kreuz,sechs],SYSTEM.VAL(LONGINT,KreuzData.kreuz6Dat));
  InitBitMap(cardBMs[kreuz,sieben],SYSTEM.VAL(LONGINT,KreuzData.kreuz7Dat));
  InitBitMap(cardBMs[kreuz,acht],SYSTEM.VAL(LONGINT,KreuzData.kreuz8Dat));
  InitBitMap(cardBMs[kreuz,neun],SYSTEM.VAL(LONGINT,KreuzData.kreuz9Dat));
  InitBitMap(cardBMs[kreuz,zehn],SYSTEM.VAL(LONGINT,KreuzData.kreuz10Dat));
  InitBitMap(cardBMs[kreuz,bube],SYSTEM.VAL(LONGINT,KreuzData.kreuzbubeDat));
  InitBitMap(cardBMs[kreuz,dame],SYSTEM.VAL(LONGINT,KreuzData.kreuzdameDat));
  InitBitMap(cardBMs[kreuz,koenig],SYSTEM.VAL(LONGINT,KreuzData.kreuzkoenigDat));

  InitBitMap(backred,SYSTEM.VAL(LONGINT,Backs.rueckenrotDat));
  InitBitMap(backblue,SYSTEM.VAL(LONGINT,Backs.rueckenblauDat));
  InitBitMap(Leerstelle,SYSTEM.VAL(LONGINT,Backs.emptyDat));

END InitCardBMs;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawEmpty(x,y:INTEGER);

BEGIN

IF G.BltBitMap(Leerstelle,0,0,WinP.rPort.bitMap,x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;

END DrawEmpty;

(* ------------------------------------------------------------------ *)

PROCEDURE Depict(card:G.BitMapPtr;x,y:INTEGER);

BEGIN

IF G.BltBitMap(card,0,0,WinP.rPort.bitMap,x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;

END Depict;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLine(bm : G.BitMapPtr;x,y,x1,y1:INTEGER);

VAR ay,ax,dy,dx,iy,ix,hilf,of,ct,times : INTEGER;

BEGIN

ay := 0; ax := 0;

IF x1 >= x THEN dx := x1-x; ix := 1;
ELSE dx := x-x1; ix := -1; END;
IF y1 >= y THEN dy := y1-y; iy := 1;
ELSE dy := y-y1; iy := -1; END;
IF dx < dy THEN hilf := dx; dx := dy; dy := hilf;
ay := ix; ax := iy; ix := 0; iy := 0; END;
of := dx DIV 2;
ct := 1;
times := 0;
LOOP
   IF times = 0 THEN
      IF G.BltBitMap(WinP.rPort.bitMap,x,y,SaveBM,0,0,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
      IF G.BltBitMap(bm,0,0,WinP.rPort.bitMap,x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
      REPEAT UNTIL G.VBeamPos()<y+70; 
      REPEAT UNTIL G.VBeamPos()>y+70;
      IF G.BltBitMap(SaveBM,0,0,WinP.rPort.bitMap,x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   END;
   IF dx < ct THEN EXIT END;
   INC(times); IF times = velo THEN times := 0 END;
   x := x + ix;
   y := y + ax;
   INC(ct);
   of := of + dy;
   IF of > dx THEN of := of-dx; x := x+ay; y := y+iy; END;
END;

END DrawLine;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLineSwitch(karte: Lists.NodePtr;x,y,x1,y1:INTEGER);

VAR dx,dy:INTEGER;

BEGIN
   dx := (x1+x) DIV 2;
   dy := (y1+y) DIV 2;
   WITH karte:CardT DO
      IF karte.blau THEN
         DrawLine(backblue,x,y,dx,dy);
      ELSE DrawLine(backred,x,y,dx,dy);
      END;
      DrawLine(cardBMs[karte.farbe,karte.typ],dx,dy,x1,y1);
   END;

END DrawLineSwitch;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLineCard(karte: Lists.NodePtr;x,y,x1,y1:INTEGER);

BEGIN
   WITH karte:CardT DO
   DrawLine(cardBMs[karte.farbe,karte.typ],x,y,x1,y1);
   END;

END DrawLineCard;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleTalon;

VAR karte:Lists.NodePtr;
BEGIN

WriteNums(FALSE,FALSE,TRUE);
IF Talonsize > 0 THEN
   karte := Lists.Head(Talon);
   IF karte(CardT).blau THEN
      Depict(backblue,talonx,talony);
   ELSE Depict(backred,talonx,talony); END;
ELSE DrawEmpty(talonx,talony);
END;

END MaleTalon;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleAblage;

VAR karte:Lists.NodePtr;

BEGIN
WriteNums(FALSE,TRUE,FALSE);
IF Ablagesize > 0 THEN
   karte := Lists.Head(Ablage);
   WITH karte:CardT DO
      Depict(cardBMs[karte.farbe,karte.typ],junkx,junky);
   END;
ELSE DrawEmpty(junkx,junky);
END;

END MaleAblage;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleFamilie(i: INTEGER);

VAR karte:Lists.NodePtr;

BEGIN

   IF NOT Lists.Empty(Familie[i]) THEN
      karte := Lists.Head(Familie[i]);
      WITH karte:CardT DO
         Depict(cardBMs[karte.farbe,karte.typ],FamX[i],FamY[i]);
      END;
   ELSE DrawEmpty(FamX[i],FamY[i]);
   END;

END MaleFamilie;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleZopf(hin:BOOLEAN);

VAR karte:Lists.NodePtr;
    j : INTEGER;
    
BEGIN

   IF Zopfsize > 0 THEN
      IF Zopfsize < 20 THEN
         G.SetAPen(WinP.rPort,0);
         G.RectFill(WinP.rPort,ZopfX[Zopfsize],ZopfY[Zopfsize],ZopfX[Zopfsize]+kbreite,ZopfY[Zopfsize]+khoehe);
      END;
      karte := Lists.Head(Zopf);
      j := 1;
      REPEAT
         IF j < Zopfsize THEN
            IF Lists.Next(karte) THEN END;
            INC(j);
         END;
      UNTIL (j = 3) OR (j = Zopfsize);
      REPEAT
         WITH karte:CardT DO
            Depict(cardBMs[karte.farbe,karte.typ],ZopfX[Zopfsize-j],ZopfY[Zopfsize-j]);
         END;
         IF Lists.Previous(karte) THEN END;
         DEC(j);
      UNTIL j = 0;
   ELSE
      G.SetAPen(WinP.rPort,0);
      G.RectFill(WinP.rPort,ZopfX[0],ZopfY[0],ZopfX[0]+kbreite,ZopfY[0]+khoehe);
   END;

END MaleZopf;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleBau(n:INTEGER);

VAR karte:Lists.NodePtr;

BEGIN

   IF NOT Lists.Empty(Bau[n]) THEN
      karte := Lists.Head(Bau[n]);
      WITH karte:CardT DO
         Depict(cardBMs[karte.farbe,karte.typ],BauX[n],BauY[n]);
      END;
   ELSE DrawEmpty(BauX[n],BauY[n]);
   END;
   
END MaleBau;

(* ------------------------------------------------------------------ *)

PROCEDURE Show(card:Lists.NodePtr;x,y:INTEGER);

BEGIN

   WITH card:CardT DO
      IF G.BltBitMap(cardBMs[card.farbe,card.typ],0,0,WinP.rPort.bitMap,
                     x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   END;

END Show;

(* ------------------------------------------------------------------ *)

PROCEDURE InitStapel;

VAR i,zufall : INTEGER;
    karte,zkarte,stelle : Lists.NodePtr;
    neukarte : BOOLEAN;

BEGIN

   Lists.Init(Zopf);
   Lists.Init(Ablage);
   Ablagesize := 0;
   MaleAblage;
   MaleTalon;
   i := 0;
   REPEAT
      Lists.Init(Bau[i]);
      MaleBau(i);
      IF i < 8 THEN
       Lists.Init(Familie[i]);
       MaleFamilie(i);
      END;
      INC(i);
   UNTIL i = 12;
   
   Einblenden(ScP,Colors);
   
   Zopfsize := 0;
   REPEAT
      karte := Lists.RemHead(Talon);
      DEC(Talonsize);
      LOOP
         neukarte := FALSE;
         IF Zopfsize > 0 THEN
            zkarte := Lists.Head(Zopf);
            REPEAT
               WITH karte:CardT DO
                  WITH zkarte:CardT DO
                     IF (karte.typ = zkarte.typ) AND (karte.farbe = zkarte.farbe) THEN
                        neukarte := TRUE;
                     END;
                  END;
               END;
            UNTIL (NOT Lists.Next(zkarte)) OR neukarte;
         END;
         IF neukarte THEN
            zufall := Random.RND(Talonsize);
            stelle := Lists.Head(Talon);
            REPEAT
            DEC(zufall);
            UNTIL (zufall < 0) OR NOT Lists.Next(stelle);
            Lists.AddBehind(Talon,karte,stelle);
            INC(Talonsize);
            karte := Lists.RemHead(Talon);
            DEC(Talonsize);
         ELSE
            EXIT;
         END;
      END;
      MaleTalon;
      DrawLineSwitch(karte,talonx,talony,ZopfX[Zopfsize],ZopfY[Zopfsize]);
      Show(karte,ZopfX[Zopfsize],ZopfY[Zopfsize]);
      Lists.AddHead(Zopf,karte);
      INC(Zopfsize);
   UNTIL  Zopfsize = 20;
   
   i := 0;
   REPEAT
      karte := Lists.RemHead(Talon);
      DEC(Talonsize);
      MaleTalon;
      DrawLineSwitch(karte,talonx,talony,BauX[i],BauY[i]);
      Lists.AddHead(Bau[i],karte);
      MaleBau(i);
      INC(i);
   UNTIL i = 12;
   
   karte := Lists.RemHead(Talon);
   DEC(Talonsize);
   WITH karte:CardT DO
      bezugstyp := karte.typ;
      endfarbe  := karte.farbe;
   END;
   MaleTalon;
   DrawLineSwitch(karte,talonx,talony,referenzx,referenzy);
   Show(karte,referenzx,referenzy);
   DrawLineCard(karte,referenzx,referenzy,FamX[0],FamY[0]);
   Lists.AddHead(Familie[0],karte);
   MaleFamilie(0);
   
END InitStapel;

(* ------------------------------------------------------------------ *)

PROCEDURE DragKarte(which : Lists.NodePtr; x,y : INTEGER; VAR lx,ly : INTEGER);

VAR i,farbe,typ,newx,newy : INTEGER;

BEGIN

WITH which : CardT DO

   farbe := which.farbe;
   typ := which.typ;

END;

lx := x; ly := y;
newx := x-kdx; newy := y-kdy;
IF newx < 0 THEN newx := 0 END;
IF newy < 0 THEN newy := 0 END;
IF newx > maxx THEN newx := maxx END;
IF newy > maxy THEN newy := maxy END;

LOOP

   IF G.BltBitMap(WinP.rPort.bitMap,newx,newy,SaveBM,0,0,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   IF G.BltBitMap(cardBMs[farbe,typ],0,0,WinP.rPort.bitMap,newx,newy,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   REPEAT
      REPEAT
         IMessPtr := E.GetMsg(WinP.userPort);
          IF IMessPtr # NIL THEN
            IMess := IMessPtr^;
            E.ReplyMsg(IMessPtr);
            IF (I.mouseButtons IN IMess.class) AND (IMess.code = I.selectDown) THEN
               IF G.BltBitMap(SaveBM,0,0,WinP.rPort.bitMap,newx,newy,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
               I.ModifyIDCMP(WinP,LONGSET{});
               EXIT;
            END;
         END;
      UNTIL IMessPtr = NIL;
      lx := WinP^.mouseX; ly := WinP^.mouseY;
   UNTIL (lx#x) OR (ly#y);
   G.WaitTOF;
   x :=lx; y :=ly;
   IF G.BltBitMap(SaveBM,0,0,WinP.rPort.bitMap,newx,newy,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   newx := lx-kdx; newy := ly-kdy;
   IF newx < 0 THEN newx := 0 END;
   IF newy < 0 THEN newy := 0 END;
   IF newx > maxx THEN newx := maxx END;
   IF newy > maxy THEN newy := maxy END;

END;

END DragKarte;

(* ------------------------------------------------------------------ *)

PROCEDURE MoveKarte;

VAR
      x,y,endx,endy,backx,backy,i,j : INTEGER;
             took,totalon,toab,tono : BOOLEAN;
                      famtake,tofam : ARRAY 8 OF BOOLEAN;
                      tobau,bautake : ARRAY 12 OF BOOLEAN;
                              karte : Lists.NodePtr;

PROCEDURE pruefefam(i:INTEGER;karte: Lists.NodePtr) : BOOLEAN;

VAR top:Lists.NodePtr;

BEGIN

   top := Lists.Head(Familie[i]);
   IF top # NIL THEN
      WITH top:CardT DO
         WITH karte:CardT DO
            IF karte.farbe = top.farbe THEN
               IF entschieden THEN
                  IF (top.typ # endtyp) THEN
                     IF fallend THEN
                        IF (karte.typ = top.typ - 1) OR
                           ((karte.typ = koenig) AND (top.typ = as))
                        THEN RETURN TRUE;
                        END;
                     ELSE
                        IF (karte.typ = top.typ + 1) OR
                           ((karte.typ = as) AND (top.typ = koenig))
                        THEN RETURN TRUE;
                        END;
                     END;
                  ELSE RETURN FALSE;
                  END;
               ELSE
                  IF (karte.typ = bezugstyp + 1) OR
                     ((karte.typ = as) AND (bezugstyp = koenig))
                  THEN
                     fallend := FALSE; entschieden := TRUE;
                     IF G.BltBitMap(Pfeilup,0,0,WinP.rPort.bitMap,referenzx+kbreite+5,referenzy+3,15,29,0C0X,SHORTSET{0..7},0)=0 THEN END;
                     IF bezugstyp = as THEN
                        endtyp := koenig;
                     ELSE endtyp := bezugstyp - 1;
                     END;
                     Depict(cardBMs[endfarbe,endtyp],endkx,endky);
                     RETURN TRUE;
                  ELSIF (karte.typ = bezugstyp - 1) OR
                        ((karte.typ = koenig) AND (bezugstyp = as))
                  THEN
                     fallend := TRUE; entschieden := TRUE;
                     IF G.BltBitMap(Pfeildown,0,0,WinP.rPort.bitMap,referenzx+kbreite+5,referenzy+3,15,29,0C0X,SHORTSET{0..7},0)=0 THEN END;
                     IF bezugstyp = koenig THEN
                        endtyp := as;
                     ELSE endtyp := bezugstyp + 1;
                     END;
                     Depict(cardBMs[endfarbe,endtyp],endkx,endky);
                     RETURN TRUE;
                  ELSE RETURN FALSE;
                  END;    
               END;
            ELSE
               RETURN FALSE;
            END;
         END;
      END;
   ELSIF karte(CardT).typ = bezugstyp THEN RETURN TRUE;
   END;
   
   RETURN FALSE;

END pruefefam;

PROCEDURE TesteEnde;

VAR j,k: INTEGER;
    card: Lists.NodePtr;
    test: BOOLEAN;

BEGIN
   
   IF Zopfsize = 0 THEN
      IF Ablagesize = 0 THEN
         gewonnen := TRUE;
      ELSE
         j := 0; k := 0;
         REPEAT
            IF Lists.Empty(Bau[j]) THEN INC(k) END;
            INC(j);
         UNTIL j = 12;
         IF Ablagesize <= k THEN gewonnen := TRUE; END;
      END;
   END;

   IF NOT gewonnen THEN

      LOOP
         IF Ablagesize > 0 THEN
            card := Lists.Head(Ablage);
            k := 0;
            REPEAT
               IF Lists.Empty(Bau[k]) OR ((k < 8) AND pruefefam(k,card))
               THEN EXIT; END;
               INC(k);
            UNTIL k = 12;
         END;
         k := 0;
         REPEAT
            IF NOT Lists.Empty(Bau[k]) THEN
               card := Lists.Head(Bau[k]);
               j := 0;
               REPEAT
                  IF pruefefam(j,card) THEN EXIT END;
                  INC(j);
               UNTIL j = 8;
            END;
            INC(k);
         UNTIL k = 12;
         IF NOT Lists.Empty(Zopf) THEN
            card := Lists.Head(Zopf);
            j := 0;
            REPEAT
               IF pruefefam(j,card) THEN EXIT END;
               INC(j);
            UNTIL j = 8;
            IF Lists.Empty(Bau[0]) OR Lists.Empty(Bau[5])
               OR Lists.Empty(Bau[6]) OR Lists.Empty(Bau[11])
            THEN EXIT;
            END;
         END;
         verloren := TRUE;EXIT;
      END;
   END;

END TesteEnde;

BEGIN

   x := WinP^.mouseX;
   y := WinP^.mouseY;
   took := FALSE; talontake := FALSE; ablagetake := FALSE; zopftake := FALSE;
   totalon := FALSE;toab := FALSE;tono := TRUE;

   i := 0;
   REPEAT
      bautake[i] := FALSE;
      tobau[i] := FALSE;
      IF i < 8 THEN tofam[i] := FALSE; famtake[i] := FALSE END;
      INC(i);
   UNTIL i = 12;
   
   IF (x > 620) AND (y < 12) THEN I.ScreenToBack(ScP);END;
   IF (x >= talonx) AND (x <= talonx+kbreite) AND (y >= talony)
      AND (y <= talony+khoehe)
   THEN
      IF Talonsize > 0 THEN
         karte := Lists.RemHead(Talon);
         DEC(Talonsize); talontake := TRUE; took := TRUE;MaleTalon;
      ELSE
         IF dreimal = 3 THEN TesteEnde;
         ELSE INC(dreimal);
            LOOP
               karte := Lists.RemHead(Ablage);
               IF karte # NIL THEN
                  Lists.AddHead(Talon,karte);
               ELSE EXIT;
               END;
            END;
            Talonsize := Ablagesize;
            Ablagesize := 0;
            MaleTalon; MaleAblage;
         END;
      END;
   ELSIF
      (Ablagesize > 0) AND (x >= junkx) AND (x <= junkx+kbreite) AND (y >= junky)
      AND (y <= junky+khoehe)
   THEN
      karte := Lists.RemHead(Ablage);
      DEC(Ablagesize); ablagetake := TRUE; took := TRUE;MaleAblage;
   ELSIF
      (Zopfsize > 0) AND (x >= ZopfX[Zopfsize-1]) AND (x <= ZopfX[Zopfsize-1]+kbreite)
      AND (y >= ZopfY[Zopfsize-1]) AND (y <= ZopfY[Zopfsize-1]+khoehe)
   THEN
      karte := Lists.RemHead(Zopf);
      DEC(Zopfsize); zopftake := TRUE; took := TRUE; MaleZopf(FALSE);
   ELSE
      i := 0;
      LOOP
         IF (NOT Lists.Empty(Bau[i])) AND (x >= BauX[i]) AND (x <= BauX[i]+kbreite)
            AND (y >= BauY[i]) AND (y <= BauY[i]+khoehe)
         THEN
            karte := Lists.RemHead(Bau[i]);
            bautake[i] := TRUE; took := TRUE;MaleBau(i);
            EXIT;
         ELSIF (i < 8) AND (NOT Lists.Empty(Familie[i])) AND (x >= FamX[i])
               AND (x <= FamX[i]+kbreite) AND (y >= FamY[i]) AND (y <= FamY[i]+khoehe)
         THEN
            karte := Lists.RemHead(Familie[i]);
            famtake[i] := TRUE; took := TRUE;DrawEmpty(FamX[i],FamY[i]);
            EXIT;
         END;
         INC(i); IF i = 12 THEN EXIT END;
      END;
   END;

   IF took THEN
      I.SetPointer(WinP,SYSTEM.VAL(LONGINT,Backs.hand2Data),16,15,7,0);
      DragKarte(karte,x,y,endx,endy);
      I.SetPointer(WinP,SYSTEM.VAL(LONGINT,Backs.hand1Data),16,16,0,0);
      I.ModifyIDCMP(WinP,LONGSET{});
      backx := endx-kdx; backy := endy-kdy;
      IF endx > maxx+kdx THEN backx := maxx; END;
      IF endx <      kdx THEN backx :=    0; END;
      IF endy > maxy+kdy THEN backy := maxy; END;
      IF endy <      kdy THEN backy :=    0; END;
      IF (endx >= junkx) AND (endx <= junkx+kbreite) AND (endy >= junky)
         AND (endy <= junky+khoehe) THEN toab := TRUE; tono := FALSE;
      ELSIF (endx >= talonx) AND (endx <= talonx+kbreite) AND (endy >= talony)
         AND (endy <= talony+khoehe) THEN totalon := TRUE; tono := FALSE;
      ELSE
         i := 0;
         LOOP
            IF i < 8 THEN 
               IF (endx >= FamX[i]) AND (endx <= FamX[i]+kbreite)
                  AND (endy >= FamY[i]) AND (endy <= FamY[i]+khoehe)
               THEN tofam[i] := TRUE; tono := FALSE; EXIT; END;
            END;
            IF (endx >= BauX[i]) AND (endx <= BauX[i]+kbreite)
               AND (endy >= BauY[i]) AND (endy <= BauY[i]+khoehe)
            THEN tobau[i] := TRUE; tono := FALSE; EXIT; END;
            INC(i); IF i = 12 THEN EXIT;END;
         END;
      END;
      IF NOT tono THEN
         tono := TRUE;
         IF talontake OR ablagetake OR zopftake THEN
            IF talontake AND totalon THEN
               Lists.AddHead(Talon,karte);
               INC(Talonsize);tono := FALSE;
               MaleTalon;
            ELSIF (NOT zopftake) AND toab THEN
               Lists.AddHead(Ablage,karte);
               INC(Ablagesize);tono := FALSE;
               MaleAblage;
            ELSE
               i := 0;
               LOOP
                  IF (NOT zopftake) AND tobau[i] THEN
                     IF Lists.Empty(Bau[i]) THEN
                        Lists.AddHead(Bau[i],karte);
                        tono := FALSE;
                        MaleBau(i);
                        EXIT;
                     ELSE
                        DrawLineCard(karte,backx,backy,junkx,junky);
                        Lists.AddHead(Ablage,karte);
                        INC(Ablagesize);tono := FALSE;
                        MaleAblage;
                        EXIT;
                     END;
                  ELSIF zopftake AND tobau[i] AND ((i = 0) OR (i = 5) OR (i = 6) OR (i = 11))
                  THEN
                     IF Lists.Empty(Bau[i]) THEN
                        Lists.AddHead(Bau[i],karte);
                        tono := FALSE;
                        MaleBau(i);
                        EXIT;
                     ELSE
                        DrawLineCard(karte,backx,backy,ZopfX[Zopfsize],ZopfY[Zopfsize]);
                        Lists.AddHead(Zopf,karte);
                        INC(Zopfsize);tono := FALSE;
                        MaleZopf(TRUE);
                        EXIT;
                     END;
                  END;
                  IF i < 8 THEN
                     IF tofam[i] THEN
                        IF pruefefam(i,karte) THEN
                           Lists.AddHead(Familie[i],karte);tono := FALSE;
                           MaleFamilie(i);
                           EXIT;
                        ELSE
                           IF (NOT zopftake) THEN
                              DrawLineCard(karte,backx,backy,junkx,junky);
                              Lists.AddHead(Ablage,karte);
                              INC(Ablagesize);tono := FALSE;
                              MaleAblage;
                              EXIT;
                           ELSE
                              DrawLineCard(karte,backx,backy,ZopfX[Zopfsize],ZopfY[Zopfsize]);
                              Lists.AddHead(Zopf,karte);
                              INC(Zopfsize);tono := FALSE;
                              MaleZopf(TRUE);
                              EXIT;
                           END;
                        END;
                     END;
                  END;
                  INC(i);
                  IF i = 12 THEN EXIT;END;
               END;
            END;
         ELSE
            i := 0;
            LOOP
               IF bautake[i] THEN
                  IF tobau[i] THEN Lists.AddHead(Bau[i],karte);
                     MaleBau(i);tono := FALSE;EXIT;
                  ELSE
                     j := 0;
                     REPEAT
                        IF tofam[j] AND pruefefam(j,karte) THEN
                           Lists.AddHead(Familie[j],karte);
                           MaleFamilie(j);
                           tono := FALSE;
                           EXIT;
                        END;
                        INC(j);
                     UNTIL j = 8;
                  END;
               ELSIF (i < 8) AND famtake[i] THEN
                  IF tofam[i] THEN Lists.AddHead(Familie[i],karte);
                     MaleFamilie(i); tono := FALSE;EXIT;
                  ELSE
                     j := 0;
                     REPEAT
                        IF tofam[j] AND Lists.Empty(Familie[j]) THEN
                           Lists.AddHead(Familie[j],karte);
                           LOOP
                              karte := Lists.RemHead(Familie[i]);
                              IF karte # NIL THEN
                                 Lists.AddTail(Familie[j],karte);
                              ELSE EXIT;
                              END;
                           END;
                           MaleFamilie(j);
                           tono := FALSE;
                           EXIT;
                        END;
                        INC(j);
                     UNTIL j = 8;
                  END;
               END;
               INC(i); IF i = 12 THEN EXIT END;
            END;
         END;
      END;               (* IF NOT tono ...   *)

      IF tono THEN
         IF talontake OR ablagetake THEN
            DrawLineCard(karte,backx,backy,junkx,junky);
            Lists.AddHead(Ablage,karte);INC(Ablagesize);
            MaleAblage;
         ELSIF zopftake THEN
            Lists.AddHead(Zopf,karte);INC(Zopfsize);
            DrawLineCard(karte,backx,backy,ZopfX[Zopfsize-1],ZopfY[Zopfsize-1]);
            MaleZopf(TRUE);
         ELSE
            i := 0;
            LOOP
               IF bautake[i] THEN
                  Lists.AddHead(Bau[i],karte);
                  DrawLineCard(karte,backx,backy,BauX[i],BauY[i]);
                  MaleBau(i);EXIT;
               ELSIF (i < 8) AND famtake[i] THEN
                  Lists.AddHead(Familie[i],karte);
                  DrawLineCard(karte,backx,backy,FamX[i],FamY[i]);
                  MaleFamilie(i);EXIT;
               END;
               INC(i); IF i = 12 THEN EXIT END;
            END;
         END;
      END;        (* IF tono ... *)
      
   END;                    (* IF took ... *)
   
   IF (Talonsize = 0) AND (dreimal = 3) THEN TesteEnde END;
   I.ModifyIDCMP(WinP,LONGSET{I.mouseButtons,I.rawKey,I.gadgetUp});
   
END MoveKarte;

(* ------------------------------------------------------------------ *)

PROCEDURE ReturnKarten(VAR Ks : Lists.List);

VAR karte : Lists.NodePtr;
        j : INTEGER;
BEGIN

   WHILE Ablagesize > 0 DO
         karte := Lists.RemHead(Ablage);
         DEC(Ablagesize);
         Lists.AddHead(Ks,karte);
   END;
   
   j := 0;
   REPEAT
      IF NOT Lists.Empty(Bau[j]) THEN
            karte := Lists.RemHead(Bau[j]);
            Lists.AddHead(Ks,karte);
      END;
      INC(j);
   UNTIL j = 12;
   
   j := 0;   
   REPEAT
      WHILE NOT Lists.Empty(Familie[j]) DO
         karte := Lists.RemHead(Familie[j]);
         Lists.AddHead(Ks,karte);
      END;
      INC(j);
   UNTIL j = 8;
   
   WHILE Zopfsize > 0 DO
      karte := Lists.RemHead(Zopf);
      DEC(Zopfsize);
      Lists.AddHead(Ks,karte);
   END;
   
END ReturnKarten;

PROCEDURE ThreeGadReq(titel,text,links,rechts,mitte:ARRAY OF CHAR):INTEGER;

VAR int : INTEGER;
    myTextStruct : Req.TRStructurePtr;
    result : INTEGER;
BEGIN

   NEW(myTextStruct);
   IF text # "" THEN
      myTextStruct.text := SYSTEM.ADR(text);
   ELSE myTextStruct.text := NIL;
   END;
   myTextStruct.controls := NIL;
   myTextStruct.window := NIL;
   IF mitte # "" THEN
      myTextStruct.middleText := SYSTEM.ADR(mitte);
   ELSE myTextStruct.middleText := NIL;
   END;
   IF links # "" THEN
      myTextStruct.positiveText := SYSTEM.ADR(links);
   ELSE myTextStruct.positiveText := NIL;
   END;
   IF rechts # "" THEN
      myTextStruct.negativeText := SYSTEM.ADR(rechts);
   ELSE myTextStruct.negativeText := NIL;
   END;
   IF titel # "" THEN
      myTextStruct.title := SYSTEM.ADR(titel);
   ELSE myTextStruct.title := NIL;
   END;
   myTextStruct.keyMask := {};
   myTextStruct.textcolor := 11;
   myTextStruct.detailcolor := 8;
   myTextStruct.blockcolor := 6;
   myTextStruct.versionnumber := 0;
   myTextStruct.rfu1 := 0;
   myTextStruct.rfu2 := 0;
   result := Req.TextRequest(myTextStruct);
   DISPOSE(myTextStruct);
   RETURN result;
   
END ThreeGadReq;

PROCEDURE Gewinn;

VAR  i,j : INTEGER;
     karte,baukarte : Lists.NodePtr;

BEGIN
   velo := 8;
   WHILE Ablagesize > 0 DO
      karte := Lists.RemHead(Ablage);
      DEC(Ablagesize);
      i := 0;
      LOOP
         IF Lists.Empty(Bau[i]) THEN
            MaleAblage;
            DrawLineCard(karte,junkx,junky,BauX[i],BauY[i]);
            Lists.AddHead(Bau[i],karte);
            MaleBau(i);
            EXIT;
         END;
         INC(i);
      END;
   END;
      
   i := 0;
   REPEAT
      LOOP
         karte := Lists.Head(Familie[i]);
         WITH karte:CardT DO
            IF NOT (karte.typ = endtyp) THEN
               j := 0;
               REPEAT
                  IF NOT Lists.Empty(Bau[j]) THEN
                     baukarte := Lists.RemHead(Bau[j]);
                     WITH baukarte:CardT DO
                        IF (baukarte.farbe = karte.farbe) AND
                           ((fallend  AND 
                           ((baukarte.typ = karte.typ - 1) OR
                           ((baukarte.typ = koenig) AND (karte.typ = as))))
                             OR
                           ((NOT fallend) AND ((baukarte.typ = karte.typ + 1) OR
                           ((baukarte.typ = as) AND (karte.typ = koenig)))))
                        THEN
                           MaleBau(j);
                           DrawLineCard(baukarte,BauX[j],BauY[j],FamX[i],FamY[i]);
                           Lists.AddHead(Familie[i],baukarte);
                           MaleFamilie(i);
                           j := 11;
                        ELSE
                           Lists.AddHead(Bau[j],baukarte);
                        END;
                     END;
                  END;
                  INC(j);
               UNTIL j = 12;
            ELSE EXIT;
            END;
         END;
      END;
      INC(i);      
   UNTIL i = 8;
   velo := 11;   
   
END Gewinn;

(* ------------------------------------------------------------------ *)
(* ------------------------------------------------------------------ *)

BEGIN

OpenAll();
myproc := SYSTEM.VAL(Dos.ProcessPtr,E.FindTask(NIL));
oldWinP := myproc.windowPtr;
myproc.windowPtr := WinP;
InitCardBMs;
velo := 11;
text := TRUE; NumsOn := TRUE; stop := FALSE;
InitKarten(Talon);
REPEAT
   Talonsize := 104;
   dreimal := 1;
   WriteText(text);
   MischKarten(Talon);
   InitStapel;
   entschieden := FALSE; gewonnen := FALSE; verloren := FALSE;
   I.ModifyIDCMP(WinP,LONGSET{I.mouseButtons,I.rawKey,I.gadgetUp});
   
   LOOP
      LOOP
        IMessPtr := E.GetMsg(WinP.userPort);
        IF IMessPtr # NIL THEN EXIT END;
        E.WaitPort(WinP.userPort);
      END;
      IMess := IMessPtr^;
      E.ReplyMsg(IMessPtr);

      IF (I.mouseButtons IN IMess.class) AND (IMess.code = I.selectDown) THEN
         MoveKarte;
         IF gewonnen THEN
            Gewinn;
            IF ThreeGadReq(" BRAVO! You made it! ","      Another game ?      ","  NO !  "," YES ! ","")=0 THEN
               I.ModifyIDCMP(WinP,LONGSET{});
            ELSE
               stop := TRUE;
            END;
            EXIT;
         END;
         IF verloren THEN
            IF ThreeGadReq("What a pity..."," RIEN NE VA PLUS ! ",
               "New Game","Quit Out","")=0 THEN
               stop := TRUE;
            END;
            EXIT;
         END;
      END;           

      IF (I.rawKey IN IMess.class) THEN
         CASE IMess.code OF
            64: text := NOT text;
                WriteText(text);|
            70: WriteNums(TRUE,TRUE,TRUE);|
            95: Plaithelp.Help;
                I.ActivateWindow(WinP);|
            69: IF ThreeGadReq("Start a new game ?","                    "," Oh no! "," YES ! ","")=0 THEN
                I.ModifyIDCMP(WinP,LONGSET{});EXIT;END;|
            16: IF ThreeGadReq("Really quit ?","               "," Oh no! "," Quit ! ","")=0 THEN
                stop := TRUE;I.ModifyIDCMP(WinP,LONGSET{});EXIT;END;|
         ELSE
         END;   
      END;
      
      IF (I.gadgetUp IN IMess.class) THEN
         gadgetPtr := IMess.iAddress;
         gadgetnum := gadgetPtr.gadgetID;
   
         CASE gadgetnum OF
            0: IF ThreeGadReq(" Really quit ? ","               "," Oh no! "," Quit ! ","")=0 THEN
               stop := TRUE;I.ModifyIDCMP(WinP,LONGSET{});EXIT;END;|
            1: Plaithelp.Help;
               I.ActivateWindow(WinP);|
            2: IF ThreeGadReq(" Start a new game ? ","                    "," Oh no! "," YES ! ","")=0 THEN
               I.ModifyIDCMP(WinP,LONGSET{});EXIT;END;|
            3: WriteNums(TRUE,TRUE,TRUE);|
            4: text := NOT text;
               WriteText(text);|
         ELSE
         END;
      END;
   END;
   
   IF stop THEN
      int := 1;      
      REPEAT
         I.MoveScreen(ScP,0,3);
         INC(int);
      UNTIL int = ScP.height DIV 3 + 20;
   ELSE
      IF gewonnen THEN
         int := 1;      
         REPEAT
            I.MoveScreen(ScP,0,-3);
            INC(int);
         UNTIL int = ScP.height DIV 3 + 20;
      END;
      Ausblenden(ScP);
      G.SetAPen(SYSTEM.ADR(ScP.rastPort),0);
      G.RectFill(SYSTEM.ADR(ScP.rastPort),0,0,639,255);
      ReturnKarten(Talon);
   END;
   
UNTIL stop

CLOSE

IF (myproc # NIL) AND (myproc.windowPtr # NIL) THEN myproc.windowPtr := oldWinP;END;
IF WinP # NIL THEN I.CloseWindow(WinP);END;
IF ScP # NIL THEN I.CloseScreen(ScP);END;

END Plait.
