MODULE Plaithelp;

IMPORT
      I : Intuition,
      G : Graphics,
      E : Exec,
      ol: OberonLib,
      Requests,
      Backs,
      SYSTEM;

VAR
   HlpScP     : I.ScreenPtr;
   HlpWinP    : I.WindowPtr;

(* ------------------------------------------------------------------ *)

PROCEDURE WaitLeftButton*(VAR WindowZeiger:I.WindowPtr);

VAR
   IMess      : I.IntuiMessage;
   IMessPtr   : I.IntuiMessagePtr;

BEGIN

LOOP
   LOOP
      IMessPtr := E.GetMsg(WindowZeiger.userPort);
      IF IMessPtr # NIL THEN EXIT END;
      E.WaitPort(WindowZeiger.userPort);
   END;

  IMess := IMessPtr^;
  E.ReplyMsg(IMessPtr);
  IF (I.mouseButtons IN IMess.class) AND (IMess.code = I.selectDown) THEN
  EXIT; END;
END;

END WaitLeftButton;

(* ------------------------------------------------------------------ *)

PROCEDURE Openhelp() : BOOLEAN;

VAR
   Nw   : I.NewWindow;
   NSc  : I.NewScreen;
   top8 : G.TextAttr;
   
BEGIN

   IF G.gfx.normalDisplayColumns >= 640 THEN
      NSc.leftEdge := (G.gfx.normalDisplayColumns - 640) DIV 2;
   ELSE NSc.leftEdge := 0;
   END;
   NSc.topEdge      := 0;
   NSc.width        := 640;  NSc.height       := 256;
   NSc.depth        := 1;    NSc.detailPen    := 0;
   NSc.blockPen     := 1;    NSc.viewModes    := {G.hires};
   NSc.type         := I.customScreen;
   NSc.font := NIL;
   NSc.defaultTitle := NIL;
   NSc.gadgets      := NIL;  NSc.customBitMap := NIL;
   INCL(NSc.type,I.screenQuiet);
   INCL(NSc.type,I.screenBehind);
   
   LOOP
      
      HlpScP := I.OpenScreen(NSc);
      IF HlpScP = NIL THEN
         IF NOT Requests.Request("Patience:","Couldn't open help screen !","Retry","Abort")
            THEN EXIT;
         END;
      ELSE
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),0,0,0,0);
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),1,13,13,13);
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),17,13,0,15);
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),18,14,11,11);
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),19,5,5,5);

            Nw.leftEdge      := 0;      Nw.topEdge       := 0;
            Nw.width         := 640;    Nw.height        := 256;
            Nw.detailPen     := 0;      Nw.blockPen      := 1;
            Nw.idcmpFlags    := LONGSET{I.mouseButtons};
            Nw.flags         := LONGSET{I.activate,I.borderless,I.rmbTrap};
            Nw.firstGadget   := NIL;    Nw.checkMark     := NIL;
            Nw.screen        := HlpScP; Nw.bitMap        := NIL;
            Nw.minWidth      := 128;    Nw.minHeight     := 24;
            Nw.maxWidth      := -1;     Nw.maxHeight     := -1;
            Nw.title         := NIL;    Nw.type          := I.customScreen;

         LOOP
            HlpWinP := I.OpenWindow(Nw);
            IF HlpWinP = NIL THEN
               IF NOT Requests.Request("Patience:","Couldn't open help window !","Retry","Abort")
                  THEN I.CloseScreen(HlpScP);EXIT;
               END;
            ELSE
               I.SetPointer(HlpWinP,SYSTEM.VAL(LONGINT,Backs.hand1Data),16,16,0,0);
               top8.name        := SYSTEM.ADR("topaz.font");
               top8.ySize       := 8;
               top8.style       := SHORTSET{};
               top8.flags       := SHORTSET{G.romFont};
               G.SetFont(HlpWinP.rPort,G.OpenFont(SYSTEM.ADR(top8)));
               RETURN TRUE;
            END;
         END;
      END;
      EXIT;
   END;
   RETURN FALSE;

END Openhelp;

(* ------------------------------------------------------------------ *)

PROCEDURE Help*();

VAR int: INTEGER;
    lib: G.BitMapPtr;

PROCEDURE Text(y: INTEGER; s: ARRAY OF CHAR);

BEGIN

  G.Move(HlpWinP.rPort,15,y);
  G.Text(HlpWinP.rPort,s,75);

END Text;

BEGIN

IF Openhelp() THEN

NEW(lib);
IF lib # NIL THEN
   G.InitBitMap(lib^,1,59,30);
   lib.planes[0] := SYSTEM.VAL(LONGINT,Backs.LibertyData);
END;

I.MoveScreen(HlpScP,0,285);
G.SetDrMd(HlpWinP.rPort,G.jam2);

Text(12 ,"                                 THE PLAIT                                 ");
Text(24 ,"This  is  a  patience  game  not  easy  to solve.  You will have to be very");
Text(36 ,"careful to make the right decisions.  In this solitaire game you should try");
Text(48 ,"to  get  rid  of the cards in the plait as fast as possible.  The same card");
Text(60 ,"cannot  occur  twice  in  the plait (that would make the game impossible to");
Text(72 ,"solve).   Next  thing  to  occur  on  the screen after the plait are twelve");
Text(84 ,"helping  cards.   The  last card taken from the talon is the card you build");
Text(96 ,"the  card  families  on  - let's call it the head.  There will be a copy of");
Text(108,"this  card  below  the  five  gadgets on the right so that you won't forget");
Text(120,"which  card  to start the families with.  The families must be of one suit.");
Text(132,"Whenever a head card appears, put it to one of the four empty fields on the");
Text(144,"left or on the right.  You may decide wether to build upwards or downwards.");
Text(156,"This  depends on the cards occuring in the plait.  The decision you come to");
Text(168,"will  be valid for every one of the eight families.  Once you put a card on");
Text(180,"one  of  the  heads,  one  card lower or one card higher, depending on your");
Text(192,"decision,  'Plait' will show the direction and the last card of a family on");
Text(204,"the right.  An example:  if your head card is a three and you put a four on");
Text(216,"it, you will have to build all of the families in the order :  three, four,");
Text(228,"five  ....  ten, jack, queen, king, ace, one, two.  If you put a two on it,");
Text(240,"the order will be reversed and end with the four.    - - - Click for more !");

I.ScreenToFront(HlpScP);
int := 1;
REPEAT
   I.MoveScreen(HlpScP,0,-4);
   INC(int);
UNTIL int = 73;

WaitLeftButton(HlpWinP);

Text(12 ,"To  build  your families, you may take one of the twelve helping cards, the");
Text(24 ,"open card of the plait or the topmost card of the 'Junk' pile.  Or you take");
Text(36 ,"a  card  from  the  talon and try to use that one - or put it on the 'Junk'");
Text(48 ,"pile.  If you get a free space by taking away one of the helping cards, you");
Text(60 ,"may  put  one of the talon cards there - wait for a fitting card to appear!");
Text(72 ,"The  top  and  bottom  of  these places have a special function:  there you");
Text(84 ,"might  put  a  card from the plait.  So you better don't fill those corners");
Text(96 ,"with  cards  from  the  talon,  except  when there are no cards left in the");
Text(108,"plait.                                                                     ");
Text(120,"When  you  played  all  of the cards of the talon, click on the empty field");
Text(132,"again  to  put  the cards of the 'Junk' pile back to the talon.  You may do");
Text(144,"that two times, i.e. you may play the talon three times altogether.        ");
Text(156,"Donations  and  rules  for your favourite patience games highly appreciated");
Text(168,"by:                                                                        ");
Text(180,"Achim Siebert                                                              ");
Text(192,"Nobileweg 67                                                               ");
Text(204,"7000 Stuttgart 40 , Germany                         1990 by Achim Siebert.");
Text(216,"     No use of any part of the program without my special permission.      ");
Text(228,"        Source in Oberon (thanks to brother dear for the compiler).        ");
Text(240,"                             Click to continue !                           ");

IF (lib # NIL) AND (lib.planes[0] # NIL) THEN
   IF G.BltBitMap(lib,0,0,HlpWinP.rPort.bitMap,291,175,59,30,0C0X,SHORTSET{0..7},0)=0 THEN END;
END;
WaitLeftButton(HlpWinP);
int := 1;
REPEAT
   I.MoveScreen(HlpScP,0,4);
   INC(int);
UNTIL int = 73;

I.ScreenToBack(HlpScP);

I.CloseWindow(HlpWinP);
I.CloseScreen(HlpScP);

END; (* IF Openhelp() ... *)

END Help; 

END Plaithelp.
