(*---------------------------------------------------------------------------
    :Program.    Queens.mod
    :Author.     Achim Siebert
    :Address.    Nobileweg 67, D-7000 Stuttgart-40
    :Phone.      0711/822509
    :Shortcut.   [acs]
    :Version.    1.0
    :Date.       03-Nov-90
    :Copyright.  PD
    :Language.   Oberon
    :Translator. Oberon
    :Imports.    none.
    :UpDate.     none.
    :Contents.   Patience game.
    :Remark.     Req.library needed!
---------------------------------------------------------------------------*)

MODULE Queens;

IMPORT
      KaroData,HerzData,PikData,KreuzData,Backs,
      Queenshelp,
      I : Intuition,
      G : Graphics,
      E : Exec,
      Dos,
      Req,
      Requests,
      Conversions,
      Strings,
      Random,
      Lists,
      ol : OberonLib,
      SYSTEM;

TYPE  CardT = RECORD(Lists.Node)
         farbe: INTEGER;
         typ: INTEGER;
         blau: BOOLEAN;
      END;
      CardTP = POINTER TO CardT;

VAR   WinP,oldWinP : I.WindowPtr;
      ScP          : I.ScreenPtr;
      top8 : G.TextAttr;
      IMess        : I.IntuiMessage;
      IMessPtr     : I.IntuiMessagePtr;
      gadblocks: ARRAY 5 OF Req.GadgetBlock;
      gadgetPtr    : I.GadgetPtr;
      gadgetnum    : INTEGER;
      myproc : Dos.ProcessPtr;
      velo         : INTEGER;
      NumsOn,stop  : BOOLEAN;
      cardBMs      : ARRAY 4, 13 OF G.BitMapPtr;

      Leerstelle,backred,backblue,SaveBM : G.BitMapPtr;

      Karten,Hilfsstapel,Talon,Ablage : Lists.List;

      int,Hilfsstapelsize,Talonsize,Ablagesize,Kartensize : INTEGER;
      gewonnen,verloren: BOOLEAN;
      text,zaehler,talontake,hilfstake,ablagetake: BOOLEAN;
      bautake,baustapel : ARRAY 8 OF BOOLEAN;

      Familie,Bau : ARRAY 8 OF Lists.List;
      Bausize : ARRAY 8 OF INTEGER;

TYPE
  ColorType = ARRAY 20 OF INTEGER;

CONST

  Colors = ColorType(0000H,0FFFH,0C00H,0F53H,00B0H,0FB0H,000FH,02CDH,
                     0F0CH,0A0FH,0EA9H,0EEEH,0ECBH,0BBBH,0888H,0444H,
                     0000H,0D0FH,0EBBH,0555H);

TYPE  BauCoords = ARRAY 8 OF INTEGER;
      FamCoords = ARRAY 8 OF INTEGER;
      BauOffsets = ARRAY 8,8 OF INTEGER;
      BauOffsets1 = ARRAY 12,8 OF INTEGER;

CONST BauX = BauCoords(188,259,330,401,188,259,330,401);

      BauOffs = BauOffsets(50,50,50,50,153,153,153,153,
                           59,59,59,59,162,162,162,162,
                           68,68,68,68,171,171,171,171,
                           77,77,77,77,180,180,180,180,
                           86,86,86,86,189,189,189,189,
                           95,95,95,95,198,198,198,198,
                           104,104,104,104,207,207,207,207,
                           113,113,113,113,216,216,216,216);

      BauOffs1 = BauOffsets1(50,50,50,50,153,153,153,153,
                             59,59,59,59,162,162,162,162,
                             64,64,64,64,167,167,167,167,
                             69,69,69,69,172,172,172,172,
                             74,74,74,74,177,177,177,177,
                             79,79,79,79,182,182,182,182,
                             84,84,84,84,187,187,187,187,
                             89,89,89,89,192,192,192,192,
                             94,94,94,94,197,197,197,197,
                             99,99,99,99,202,202,202,202,
                             104,104,104,104,207,207,207,207,
                             109,109,109,109,212,212,212,212);
                           
   FamX = FamCoords(46,117,188,259,330,401,472,543);
   FamY = FamCoords(23, 15, 10, 10, 10, 10, 15, 23);

   Mangel  = "Out of memory!";
   as      = 0;      karo     = 0;
   zwei    = 1;      herz     = 1;
   drei    = 2;      pik      = 2;
   vier    = 3;      kreuz    = 3;
   fuenf   = 4;
   sechs   = 5;
   sieben  = 6;
   acht    = 7;
   neun    = 8;
   zehn    = 9;
   bube    = 10;
   dame    = 11;
   koenig  = 12;
   hilfsx  =  82;    hilfsy   =  98;
   junkx   = 509;    junky    = 195;
   talonx  = 509;    talony   =  98;
   maxx    = 590;    maxy     = 221;
   kbreite =  49;    khoehe   =  35;
   kdx     =  25;    kdy      =  18;

(* ------------------------------------------------------------------ *)

PROCEDURE Ausblenden(screenzeiger: I.ScreenPtr);

VAR      colors,r,g,b: ARRAY 16 OF INTEGER;
            i,j,Rot,Gruen,Blau  : INTEGER;
BEGIN
   i := 0;
   REPEAT
      colors[i] := SHORT(G.GetRGB4(screenzeiger.viewPort.colorMap,i));
      r[i] := colors[i] DIV 256 MOD 16;
      g[i] := colors[i] DIV 16 MOD 16;
      b[i] := colors[i] MOD 16;
      INC(i);
   UNTIL i = 16;
   j := 40;
   REPEAT
      i := 0;   
      REPEAT
         Rot := r[i]*j DIV 40;
         Gruen := g[i]*j DIV 40;
         Blau := b[i]*j DIV 40;
         colors[i] := (Rot*16+Gruen)*16+Blau;
         INC(i);
      UNTIL i = 16;
      G.LoadRGB4(SYSTEM.ADR(screenzeiger.viewPort),colors,16);
      DEC(j);
   UNTIL j < 0;

END Ausblenden;
      
(* ------------------------------------------------------------------ *)

PROCEDURE Einblenden(screenzeiger: I.ScreenPtr;Endfarben:ARRAY OF INTEGER);

VAR      colors,r,g,b: ARRAY 16 OF INTEGER;
            i,j,Rot,Gruen,Blau  : INTEGER;
BEGIN
   i := 0;
   REPEAT
      colors[i] := Endfarben[i];
      r[i] := colors[i] DIV 256 MOD 16;
      g[i] := colors[i] DIV 16 MOD 16;
      b[i] := colors[i] MOD 16;
      INC(i);
   UNTIL i = 16;
   j := 0;
   REPEAT
      i := 0;   
      REPEAT
         Rot := r[i]*j DIV 40;
         Gruen := g[i]*j DIV 40;
         Blau := b[i]*j DIV 40;
         colors[i] := (Rot*16+Gruen)*16+Blau;
         INC(i);
      UNTIL i = 16;
      G.LoadRGB4(SYSTEM.ADR(screenzeiger.viewPort),colors,16);
      INC(j);
   UNTIL j > 40;

END Einblenden;
      
(* ------------------------------------------------------------------ *)

PROCEDURE OpenAll();

VAR
   NSc  : I.NewScreen;
   Nw   : I.NewWindow;
   borderPtr : I.BorderPtr;
   
CONST Black = ColorType(0000H,0000H,0000H,0000H,0000H,0000H,0000H,0000H,
                     0000H,0000H,0000H,0000H,0000H,0000H,0000H,0000H,
                     0000H,0D0FH,0EBBH,0555H);
                     
TYPE gadstringType = ARRAY 5,20 OF CHAR;

CONST gadstrings = gadstringType("    Q = Quit       ",
                                 " HELP = Rules      ",
                                 "  ESC = New Game   ",
                                 "  DEL = Toggle Figs",
                                 "SPACE = Toggle Text");
   
BEGIN
   
   top8.name        := SYSTEM.ADR("topaz.font");
   top8.ySize       := 8;
   top8.style       := SHORTSET{};
   top8.flags       := SHORTSET{G.romFont};
   IF G.gfx.normalDisplayColumns >= 640 THEN
      NSc.leftEdge := (G.gfx.normalDisplayColumns - 640) DIV 2;
   ELSE NSc.leftEdge := 0;
   END;
   NSc.topEdge := 0;
   NSc.width        := 640;
   NSc.height       := 256;   
   NSc.depth        := 4;
   NSc.detailPen    := 0;    NSc.blockPen     := 9;
   NSc.viewModes    := {G.hires};
   NSc.type         := I.customScreen;
   NSc.font         := SYSTEM.ADR(top8);  NSc.defaultTitle := NIL;
   NSc.gadgets      := NIL;  NSc.customBitMap := NIL;
   INCL(NSc.type,I.screenQuiet);
   ScP := I.OpenScreen(NSc); Requests.Assert(ScP#NIL,"Couldn't open screen!");
   G.LoadRGB4(SYSTEM.ADR(ScP.viewPort),Black,20);
   
   Nw.leftEdge      := 0;    Nw.topEdge       := 0;
   Nw.width         := 640;  Nw.height        := 256;
   Nw.detailPen     := 0;    Nw.blockPen      := 9;
   Nw.idcmpFlags    := LONGSET{};
   Nw.flags         := LONGSET{I.activate,I.borderless,I.backDrop,I.rmbTrap};
   Nw.firstGadget   := NIL;  Nw.checkMark     := NIL;
   Nw.screen        := ScP;  Nw.bitMap        := NIL;
   Nw.minWidth      := 128;  Nw.minHeight     := 24;
   Nw.maxWidth      := -1;   Nw.maxHeight     := -1;
   Nw.title         := NIL;  Nw.type          := I.customScreen;
    
   gadgetnum := 0;
   REPEAT
      Req.LinkGadget(SYSTEM.ADR(gadblocks[gadgetnum]),gadstrings[gadgetnum],Nw,
                     18,164+15*gadgetnum);
      gadblocks[gadgetnum].gadget.gadgetID := gadgetnum;
      borderPtr := gadblocks[gadgetnum].gadget.gadgetRender;
      borderPtr.frontPen := 9;
      gadblocks[gadgetnum].gadget.gadgetText.frontPen := 0;
      gadblocks[gadgetnum].gadget.gadgetText.backPen := 11;
      INC(gadgetnum);
   UNTIL gadgetnum = 5;
   WinP := I.OpenWindow(Nw); Requests.Assert(WinP#NIL,"Couldn't open window!");
   G.SetFont(WinP.rPort,G.OpenFont(SYSTEM.ADR(top8)));
   I.SetPointer(WinP,SYSTEM.VAL(LONGINT,Backs.hand1Data),16,16,0,0);
    
END OpenAll;

(* ------------------------------------------------------------------ *)

PROCEDURE WriteText(On:BOOLEAN);

BEGIN
   G.SetDrMd(WinP.rPort,G.jam2);
   IF On THEN
      G.SetAPen(WinP.rPort,11);
      G.Move(WinP.rPort,hilfsx+5,hilfsy+43);
      G.Text(WinP.rPort,"Extra",5);
      G.Move(WinP.rPort,junkx+7,junky+43);
      G.Text(WinP.rPort,"Junk",4);
      G.Move(WinP.rPort,talonx+5,talony+43);
      G.Text(WinP.rPort,"Talon",5);
      gadgetPtr := WinP.firstGadget;
      REPEAT
         I.OnGadget(gadgetPtr,WinP,NIL);
         gadgetPtr := gadgetPtr.nextGadget;
      UNTIL gadgetPtr = NIL;
   ELSE
      G.SetAPen(WinP.rPort,0);
      G.RectFill(WinP.rPort,hilfsx,hilfsy+36,hilfsx+kbreite,hilfsy+46);
      G.RectFill(WinP.rPort,junkx,junky+36,junkx+kbreite,junky+46);
      G.RectFill(WinP.rPort,talonx,talony+36,talonx+kbreite,talony+46);
      gadgetPtr := WinP.firstGadget;
      REPEAT
         I.OffGadget(gadgetPtr,WinP,NIL);
         gadgetPtr := gadgetPtr.nextGadget;
      UNTIL gadgetPtr = NIL;
      G.RectFill(WinP.rPort,10,160,180,250);
   END;

END WriteText;

(* ------------------------------------------------------------------ *)

PROCEDURE WriteNums(switched,hi,ab,ta:BOOLEAN);

VAR str: ARRAY 8 OF CHAR;

BEGIN

   G.SetDrMd(WinP.rPort,G.jam2);
   IF NumsOn THEN
      IF switched THEN
         G.SetAPen(WinP.rPort,0);
         G.RectFill(WinP.rPort,talonx,talony-14,talonx+kbreite,talony-1);
         G.RectFill(WinP.rPort,junkx,junky-14,junkx+kbreite,junky-1);
         G.RectFill(WinP.rPort,hilfsx,hilfsy-14,hilfsx+kbreite,hilfsy-1);
         NumsOn := NOT NumsOn;
      ELSE
         IF hi THEN
            G.SetAPen(WinP.rPort,0);
            G.RectFill(WinP.rPort,hilfsx,hilfsy-14,hilfsx+kbreite,hilfsy-1);
            G.SetAPen(WinP.rPort,11);
            IF Hilfsstapelsize < 10 THEN 
               G.Move(WinP.rPort,hilfsx+4,hilfsy-3);
               IF Conversions.IntToString(LONG(Hilfsstapelsize),str,2) THEN END;

               G.Text(WinP.rPort,str,Strings.Length(str));
            ELSE
               G.Move(WinP.rPort,hilfsx+8,hilfsy-3);
               IF Conversions.IntToString(LONG(Hilfsstapelsize),str,2) THEN END;
               G.Text(WinP.rPort,str,Strings.Length(str));
            END;
         END;
         IF ta THEN
            G.SetAPen(WinP.rPort,0);
            G.RectFill(WinP.rPort,talonx,talony-14,talonx+kbreite,talony-1);
            G.SetAPen(WinP.rPort,11);
            IF Talonsize < 10 THEN 
               G.Move(WinP.rPort,talonx+4,talony-3);
               IF Conversions.IntToString(LONG(Talonsize),str,2) THEN END;
               G.Text(WinP.rPort,str,Strings.Length(str));
            ELSE
               G.Move(WinP.rPort,talonx+8,talony-3);
               IF Conversions.IntToString(LONG(Talonsize),str,2) THEN END;
               G.Text(WinP.rPort,str,Strings.Length(str));
            END;
         END;
         IF ab THEN
            G.SetAPen(WinP.rPort,0);
            G.RectFill(WinP.rPort,junkx,junky-14,junkx+kbreite,junky-1);
            G.SetAPen(WinP.rPort,11);
            IF Ablagesize < 10 THEN 
               G.Move(WinP.rPort,junkx+4,junky-3);
               IF Conversions.IntToString(LONG(Ablagesize),str,2) THEN END;
               G.Text(WinP.rPort,str,Strings.Length(str));
            ELSE
               G.Move(WinP.rPort,junkx+8,junky-3);
               IF Conversions.IntToString(LONG(Ablagesize),str,2) THEN END;
               G.Text(WinP.rPort,str,Strings.Length(str));
            END;
         END;
      END;
   ELSE
      IF switched THEN
         NumsOn := NOT NumsOn;
         WriteNums(FALSE,TRUE,TRUE,TRUE);
      END;
   END;
         
END WriteNums;

(* ------------------------------------------------------------------ *)

PROCEDURE InitKarten(VAR Ks: Lists.List);

VAR karte : CardTP;
    i,j   : INTEGER;
    first : BOOLEAN;

BEGIN

Lists.Init(Ks);
first := TRUE;
REPEAT
   i := karo;
   REPEAT
      j := as;
      REPEAT
         NEW(karte);Requests.Assert(karte#NIL,Mangel);
         karte.farbe := i;
         karte.typ := j;
         karte.blau := first;
         Lists.AddTail(Ks,karte);
         INC(j);
       UNTIL j > koenig;
       INC(i);
   UNTIL i > kreuz;
   first := NOT first;
UNTIL first;

END InitKarten;

(* ------------------------------------------------------------------ *)

PROCEDURE MischKarten(VAR Ks: Lists.List);

VAR   Zwischen : Lists.List;
      i,zufall : INTEGER;
      naechste : Lists.NodePtr;

BEGIN

i := Kartensize;
Lists.Init(Zwischen);
REPEAT
   zufall := Random.RND(i);
   naechste := Lists.Head(Ks);
   REPEAT
      DEC(zufall);
   UNTIL (zufall < 0) OR NOT Lists.Next(naechste);
   Lists.Remove(Ks,naechste);
   Lists.AddHead(Zwischen,naechste);
   DEC(i);
UNTIL i = 0;
Ks := Zwischen;

END MischKarten;

(* ------------------------------------------------------------------ *)

PROCEDURE InitCardBMs();

TYPE CAPtr = POINTER TO ARRAY 4, 4*35 OF INTEGER; 

VAR  i,j   : INTEGER;

PROCEDURE InitBitMap(bm: G.BitMapPtr;data: CAPtr);

BEGIN
  G.InitBitMap(bm^,4,kbreite,khoehe);
  bm.planes[0] := SYSTEM.ADR(data[0]);
  bm.planes[1] := SYSTEM.ADR(data[1]);
  bm.planes[2] := SYSTEM.ADR(data[2]);
  bm.planes[3] := SYSTEM.ADR(data[3]);
END InitBitMap;

BEGIN
  i := karo;
  REPEAT
     j := as;
     REPEAT
        NEW(cardBMs[i,j]); Requests.Assert(cardBMs[i,j]#NIL,Mangel);
        INC(j);
     UNTIL j > koenig;
     INC(i)
  UNTIL i > kreuz;

  NEW(backblue);Requests.Assert(backblue#NIL,Mangel);
  NEW(backred); Requests.Assert(backred#NIL,Mangel);
  NEW(SaveBM);  Requests.Assert(SaveBM#NIL,Mangel);
  NEW(Leerstelle);  Requests.Assert(Leerstelle#NIL,Mangel);

  G.InitBitMap(SaveBM^,4,kbreite,khoehe);
  INCL(ol.MemReqs,E.chip);
  i := 0;
  REPEAT
    ol.New(SaveBM.planes[i],8*khoehe);
    Requests.Assert(SaveBM.planes[i]#NIL,Mangel);
    INC(i);
  UNTIL i=4;
  EXCL(ol.MemReqs,E.chip);

  InitBitMap(cardBMs[karo,as],SYSTEM.VAL(LONGINT,KaroData.karoasDat));
  InitBitMap(cardBMs[karo,zwei],SYSTEM.VAL(LONGINT,KaroData.karo2Dat));
  InitBitMap(cardBMs[karo,drei],SYSTEM.VAL(LONGINT,KaroData.karo3Dat));
  InitBitMap(cardBMs[karo,vier],SYSTEM.VAL(LONGINT,KaroData.karo4Dat));
  InitBitMap(cardBMs[karo,fuenf],SYSTEM.VAL(LONGINT,KaroData.karo5Dat));
  InitBitMap(cardBMs[karo,sechs],SYSTEM.VAL(LONGINT,KaroData.karo6Dat));
  InitBitMap(cardBMs[karo,sieben],SYSTEM.VAL(LONGINT,KaroData.karo7Dat));
  InitBitMap(cardBMs[karo,acht],SYSTEM.VAL(LONGINT,KaroData.karo8Dat));
  InitBitMap(cardBMs[karo,neun],SYSTEM.VAL(LONGINT,KaroData.karo9Dat));
  InitBitMap(cardBMs[karo,zehn],SYSTEM.VAL(LONGINT,KaroData.karo10Dat));
  InitBitMap(cardBMs[karo,bube],SYSTEM.VAL(LONGINT,KaroData.karobubeDat));
  InitBitMap(cardBMs[karo,dame],SYSTEM.VAL(LONGINT,KaroData.karodameDat));
  InitBitMap(cardBMs[karo,koenig],SYSTEM.VAL(LONGINT,KaroData.karokoenigDat));

  InitBitMap(cardBMs[herz,as],SYSTEM.VAL(LONGINT,HerzData.herzasDat));
  InitBitMap(cardBMs[herz,zwei],SYSTEM.VAL(LONGINT,HerzData.herz2Dat));
  InitBitMap(cardBMs[herz,drei],SYSTEM.VAL(LONGINT,HerzData.herz3Dat));
  InitBitMap(cardBMs[herz,vier],SYSTEM.VAL(LONGINT,HerzData.herz4Dat));
  InitBitMap(cardBMs[herz,fuenf],SYSTEM.VAL(LONGINT,HerzData.herz5Dat));
  InitBitMap(cardBMs[herz,sechs],SYSTEM.VAL(LONGINT,HerzData.herz6Dat));
  InitBitMap(cardBMs[herz,sieben],SYSTEM.VAL(LONGINT,HerzData.herz7Dat));
  InitBitMap(cardBMs[herz,acht],SYSTEM.VAL(LONGINT,HerzData.herz8Dat));
  InitBitMap(cardBMs[herz,neun],SYSTEM.VAL(LONGINT,HerzData.herz9Dat));
  InitBitMap(cardBMs[herz,zehn],SYSTEM.VAL(LONGINT,HerzData.herz10Dat));
  InitBitMap(cardBMs[herz,bube],SYSTEM.VAL(LONGINT,HerzData.herzbubeDat));
  InitBitMap(cardBMs[herz,dame],SYSTEM.VAL(LONGINT,HerzData.herzdameDat));
  InitBitMap(cardBMs[herz,koenig],SYSTEM.VAL(LONGINT,HerzData.herzkoenigDat));

  InitBitMap(cardBMs[pik,as],SYSTEM.VAL(LONGINT,PikData.pikasDat));
  InitBitMap(cardBMs[pik,zwei],SYSTEM.VAL(LONGINT,PikData.pik2Dat));
  InitBitMap(cardBMs[pik,drei],SYSTEM.VAL(LONGINT,PikData.pik3Dat));
  InitBitMap(cardBMs[pik,vier],SYSTEM.VAL(LONGINT,PikData.pik4Dat));
  InitBitMap(cardBMs[pik,fuenf],SYSTEM.VAL(LONGINT,PikData.pik5Dat));
  InitBitMap(cardBMs[pik,sechs],SYSTEM.VAL(LONGINT,PikData.pik6Dat));
  InitBitMap(cardBMs[pik,sieben],SYSTEM.VAL(LONGINT,PikData.pik7Dat));
  InitBitMap(cardBMs[pik,acht],SYSTEM.VAL(LONGINT,PikData.pik8Dat));
  InitBitMap(cardBMs[pik,neun],SYSTEM.VAL(LONGINT,PikData.pik9Dat));
  InitBitMap(cardBMs[pik,zehn],SYSTEM.VAL(LONGINT,PikData.pik10Dat));
  InitBitMap(cardBMs[pik,bube],SYSTEM.VAL(LONGINT,PikData.pikbubeDat));
  InitBitMap(cardBMs[pik,dame],SYSTEM.VAL(LONGINT,PikData.pikdameDat));
  InitBitMap(cardBMs[pik,koenig],SYSTEM.VAL(LONGINT,PikData.pikkoenigDat));

  InitBitMap(cardBMs[kreuz,as],SYSTEM.VAL(LONGINT,KreuzData.kreuzasDat));
  InitBitMap(cardBMs[kreuz,zwei],SYSTEM.VAL(LONGINT,KreuzData.kreuz2Dat));
  InitBitMap(cardBMs[kreuz,drei],SYSTEM.VAL(LONGINT,KreuzData.kreuz3Dat));
  InitBitMap(cardBMs[kreuz,vier],SYSTEM.VAL(LONGINT,KreuzData.kreuz4Dat));
  InitBitMap(cardBMs[kreuz,fuenf],SYSTEM.VAL(LONGINT,KreuzData.kreuz5Dat));
  InitBitMap(cardBMs[kreuz,sechs],SYSTEM.VAL(LONGINT,KreuzData.kreuz6Dat));
  InitBitMap(cardBMs[kreuz,sieben],SYSTEM.VAL(LONGINT,KreuzData.kreuz7Dat));
  InitBitMap(cardBMs[kreuz,acht],SYSTEM.VAL(LONGINT,KreuzData.kreuz8Dat));
  InitBitMap(cardBMs[kreuz,neun],SYSTEM.VAL(LONGINT,KreuzData.kreuz9Dat));
  InitBitMap(cardBMs[kreuz,zehn],SYSTEM.VAL(LONGINT,KreuzData.kreuz10Dat));
  InitBitMap(cardBMs[kreuz,bube],SYSTEM.VAL(LONGINT,KreuzData.kreuzbubeDat));
  InitBitMap(cardBMs[kreuz,dame],SYSTEM.VAL(LONGINT,KreuzData.kreuzdameDat));
  InitBitMap(cardBMs[kreuz,koenig],SYSTEM.VAL(LONGINT,KreuzData.kreuzkoenigDat));

  InitBitMap(backred,SYSTEM.VAL(LONGINT,Backs.rueckenrotDat));
  InitBitMap(backblue,SYSTEM.VAL(LONGINT,Backs.rueckenblauDat));
  InitBitMap(Leerstelle,SYSTEM.VAL(LONGINT,Backs.emptyDat));

END InitCardBMs;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawEmpty(x,y:INTEGER);

BEGIN

IF G.BltBitMap(Leerstelle,0,0,WinP.rPort.bitMap,x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;

END DrawEmpty;


(* ------------------------------------------------------------------ *)

PROCEDURE Depict(card:G.BitMapPtr;x,y:INTEGER);

BEGIN

IF G.BltBitMap(card,0,0,WinP.rPort.bitMap,x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;

END Depict;

(* ------------------------------------------------------------------ *)

PROCEDURE rechtsraus(card:Lists.NodePtr;x,y:INTEGER);

VAR j : INTEGER;

BEGIN

   x := x+kbreite+1;
   j := 0;
   IF card(CardT).blau THEN
      REPEAT
         IF G.BltBitMap(backblue,kbreite-j,0,WinP.rPort.bitMap,
                        x,y,j,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
         INC(j);
      UNTIL j = kbreite;
      G.SetAPen(WinP.rPort,0);
      G.RectFill(WinP.rPort,x,y,x+kbreite,y+khoehe);
   ELSE
      REPEAT
         IF G.BltBitMap(backred,kbreite-j,0,WinP.rPort.bitMap,
                        x,y,j,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
         INC(j);
      UNTIL j = kbreite;
      G.SetAPen(WinP.rPort,0);
      G.RectFill(WinP.rPort,x,y,x+kbreite,y+khoehe);
   END;

END rechtsraus;

(* ------------------------------------------------------------------ *)

PROCEDURE linksrein(card:Lists.NodePtr;x,y:INTEGER);

VAR j : INTEGER;

BEGIN

   x := x-kbreite;
   j := 0;
   IF card(CardT).blau THEN
      REPEAT
         IF G.BltBitMap(backblue,0,0,WinP.rPort.bitMap,
                        x+j,y,kbreite-j,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
         G.SetAPen(WinP.rPort,0);
         G.RectFill(WinP.rPort,x+j,y,x+j,y+khoehe);
         INC(j);
      UNTIL j = kbreite;
   ELSE
      REPEAT
         IF G.BltBitMap(backred,0,0,WinP.rPort.bitMap,
                        x+j,y,kbreite-j,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
         G.SetAPen(WinP.rPort,0);
         G.RectFill(WinP.rPort,x+j,y,x+j,y+khoehe);
         INC(j);
      UNTIL j = kbreite;
   END;

END linksrein;

(* ------------------------------------------------------------------ *)

PROCEDURE rechtsrein(card:Lists.NodePtr;x,y:INTEGER);

VAR j : INTEGER;

BEGIN

   x := x+kbreite+1;
   j := 0;
   IF card(CardT).blau THEN
      REPEAT
         IF G.BltBitMap(backblue,j,0,WinP.rPort.bitMap,
                        x,y,kbreite-j,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
         G.SetAPen(WinP.rPort,0);
         G.RectFill(WinP.rPort,x+kbreite-j-1,y,x+kbreite-j,y+khoehe);
         INC(j);
      UNTIL j = kbreite;
   ELSE
      REPEAT
         IF G.BltBitMap(backred,j,0,WinP.rPort.bitMap,
                        x,y,kbreite-j,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
         G.SetAPen(WinP.rPort,0);
         G.RectFill(WinP.rPort,x+kbreite-j-1,y,x+kbreite-j,y+khoehe);
         INC(j);
      UNTIL j = kbreite;
   END;

END rechtsrein;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLine(bm : G.BitMapPtr;x,y,x1,y1:INTEGER);

VAR ay,ax,dy,dx,iy,ix,hilf,of,ct,times : INTEGER;

BEGIN

ay := 0; ax := 0;

IF x1 >= x THEN dx := x1-x; ix := 1;
ELSE dx := x-x1; ix := -1; END;
IF y1 >= y THEN dy := y1-y; iy := 1;
ELSE dy := y-y1; iy := -1; END;
IF dx < dy THEN hilf := dx; dx := dy; dy := hilf;
ay := ix; ax := iy; ix := 0; iy := 0; END;
of := dx DIV 2;
ct := 1;
times := 0;
LOOP
   IF times = 0 THEN
      IF G.BltBitMap(WinP.rPort.bitMap,x,y,SaveBM,0,0,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
      IF G.BltBitMap(bm,0,0,WinP.rPort.bitMap,x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
      REPEAT UNTIL G.VBeamPos()<y+70; 
      REPEAT UNTIL G.VBeamPos()>y+70;
      IF G.BltBitMap(SaveBM,0,0,WinP.rPort.bitMap,x,y,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   END;
   IF dx < ct THEN EXIT END;
   INC(times); IF times = velo THEN times := 0 END;
   x := x + ix;
   y := y + ax;
   INC(ct);
   of := of + dy;
   IF of > dx THEN of := of-dx; x := x+ay; y := y+iy; END;
END;

END DrawLine;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLineSwitch(karte: Lists.NodePtr;x,y,x1,y1:INTEGER);

VAR dx,dy:INTEGER;

BEGIN
   dx := (x1+x) DIV 2;
   dy := (y1+y) DIV 2;
   WITH karte:CardT DO
      IF karte.blau THEN
         DrawLine(backblue,x,y,dx,dy);
      ELSE DrawLine(backred,x,y,dx,dy);
      END;
      DrawLine(cardBMs[karte.farbe,karte.typ],dx,dy,x1,y1);
   END;

END DrawLineSwitch;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLineSwitchR(karte: Lists.NodePtr;x,y,x1,y1:INTEGER);

VAR dx,dy:INTEGER;

BEGIN
   dx := (x1+x) DIV 2;
   dy := (y1+y) DIV 2;
   WITH karte:CardT DO
      DrawLine(cardBMs[karte.farbe,karte.typ],x,y,dx,dy);
      IF karte.blau THEN
         DrawLine(backblue,dx,dy,x1,y1);
      ELSE DrawLine(backred,dx,dy,x1,y1);
      END;
   END;

END DrawLineSwitchR;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLineBack(karte: Lists.NodePtr;x,y,x1,y1:INTEGER);

BEGIN

      IF karte(CardT).blau THEN
           DrawLine(backblue,x,y,x1,y1);
      ELSE DrawLine(backred,x,y,x1,y1);
      END;

END DrawLineBack;

(* ------------------------------------------------------------------ *)

PROCEDURE DrawLineCard(karte: Lists.NodePtr;x,y,x1,y1:INTEGER);

BEGIN
   WITH karte:CardT DO
   DrawLine(cardBMs[karte.farbe,karte.typ],x,y,x1,y1);
   END;

END DrawLineCard;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleAnfang;

VAR i : INTEGER;

BEGIN

i := 0;
REPEAT
   DrawEmpty(BauX[i],BauOffs[0,i]);
   DrawEmpty(FamX[i],FamY[i]);
   INC(i);
UNTIL i = 8;

DrawEmpty(hilfsx,hilfsy);DrawEmpty(junkx,junky);DrawEmpty(talonx,talony);

END MaleAnfang;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleTalon;

VAR karte:Lists.NodePtr;
BEGIN

WriteNums(FALSE,FALSE,FALSE,TRUE);
IF Talonsize > 0 THEN
   karte := Lists.Head(Talon);
   IF karte(CardT).blau THEN
      Depict(backblue,talonx,talony);
   ELSE Depict(backred,talonx,talony); END;
ELSE DrawEmpty(talonx,talony);
END;

END MaleTalon;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleHilfsstapel;

VAR karte:Lists.NodePtr;
BEGIN
WriteNums(FALSE,TRUE,FALSE,FALSE);
IF Hilfsstapelsize > 0 THEN
   karte := Lists.Head(Hilfsstapel);
   IF karte(CardT).blau THEN
      Depict(backblue,hilfsx,hilfsy);
   ELSE Depict(backred,hilfsx,hilfsy); END;
ELSE DrawEmpty(hilfsx,hilfsy);
END;

END MaleHilfsstapel;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleAblage;

VAR karte:Lists.NodePtr;

BEGIN
WriteNums(FALSE,FALSE,TRUE,FALSE);
IF Ablagesize > 0 THEN
   karte := Lists.Head(Ablage);
   WITH karte:CardT DO
      Depict(cardBMs[karte.farbe,karte.typ],junkx,junky);
   END;
ELSE DrawEmpty(junkx,junky);
END;

END MaleAblage;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleFamilie(i: INTEGER);

VAR karte:Lists.NodePtr;

BEGIN

IF NOT Lists.Empty(Familie[i]) THEN
   karte := Lists.Head(Familie[i]);
   WITH karte:CardT DO
      Depict(cardBMs[karte.farbe,karte.typ],FamX[i],FamY[i]);
   END;
ELSE DrawEmpty(FamX[i],FamY[i]);
END;

END MaleFamilie;

(* ------------------------------------------------------------------ *)

PROCEDURE MaleBaustelle(n:INTEGER);

VAR karte : Lists.NodePtr;
    i: INTEGER;

BEGIN

CASE Bausize[n] OF

0:
   DrawEmpty(BauX[n],BauOffs[0,n]);
   G.SetAPen(WinP.rPort,0);
   G.RectFill(WinP.rPort,BauX[n],BauOffs[0,n]+khoehe,BauX[n]+kbreite,BauOffs[0,n]+98);
   |

1..7:
   karte := Lists.Head(Bau[n]);
   WITH karte:CardT DO
     Depict(cardBMs[karte.farbe,karte.typ],BauX[n],BauOffs[Bausize[n]-1,n]);
   END;
   G.SetAPen(WinP.rPort,0);
   G.RectFill(WinP.rPort,BauX[n],BauOffs[Bausize[n]-1,n]+khoehe,
              BauX[n]+kbreite,BauOffs[0,n]+98);
   |
8: 
   karte := Lists.Tail(Bau[n]);
      i := 0;
      REPEAT
         WITH karte:CardT DO
            Depict(cardBMs[karte.farbe,karte.typ],BauX[n],BauOffs[i,n]);
            INC(i);
         END;
      UNTIL NOT Lists.Previous(karte);
   G.SetAPen(WinP.rPort,0);
   G.RectFill(WinP.rPort,BauX[n],BauOffs[7,n]+khoehe,
              BauX[n]+kbreite,BauOffs[0,n]+98);
   |

9:
   karte := Lists.Tail(Bau[n]);
      i := 0;
      REPEAT
         WITH karte:CardT DO
            Depict(cardBMs[karte.farbe,karte.typ],BauX[n],BauOffs1[i,n]);
            INC(i);
         END;
      UNTIL NOT Lists.Previous(karte);
   G.SetAPen(WinP.rPort,0);
   G.RectFill(WinP.rPort,BauX[n],BauOffs1[8,n]+khoehe,
              BauX[n]+kbreite,BauOffs[0,n]+98);
   |
ELSE
   karte := Lists.Head(Bau[n]);
   WITH karte:CardT DO
      Depict(cardBMs[karte.farbe,karte.typ],BauX[n],BauOffs1[Bausize[n]-1,n]);
   END;
   G.SetAPen(WinP.rPort,0);
   G.RectFill(WinP.rPort,BauX[n],BauOffs1[Bausize[n]-1,n]+khoehe,
              BauX[n]+kbreite,BauOffs[0,n]+98);
END;

END MaleBaustelle;

(* ------------------------------------------------------------------ *)

PROCEDURE PruefeAnfangsDamen;

VAR i,zufall : INTEGER;
    karte,stelle : Lists.NodePtr;
    notfound : BOOLEAN;

BEGIN

REPEAT
   notfound := TRUE;
   i := 0;
   REPEAT
      karte := Lists.Head(Bau[i]);
      IF karte(CardT).typ = dame THEN
         notfound := FALSE;
         karte := Lists.RemHead(Bau[i]);DEC(Bausize[i]);MaleBaustelle(i);
         DrawLineSwitchR(karte,BauX[i],BauOffs[0,i],talonx-kbreite,talony);
         linksrein(karte,talonx,talony);
         zufall := Random.RND(Talonsize);
         stelle := Lists.Head(Talon);
         REPEAT
            DEC(zufall);
         UNTIL (zufall < 0) OR NOT Lists.Next(stelle);
         Lists.AddBehind(Talon,karte,stelle);
         karte := Lists.RemHead(Talon);MaleTalon;
         DrawLineSwitch(karte,talonx,talony,BauX[i],BauOffs[0,i]);
         Lists.AddHead(Bau[i],karte);INC(Bausize[i]);MaleBaustelle(i);
      END;
      INC(i);
   UNTIL i = 8;
UNTIL notfound;

END PruefeAnfangsDamen;

(* ------------------------------------------------------------------ *)

PROCEDURE InitStapel;

VAR i : INTEGER;
    karte : Lists.NodePtr;

BEGIN

   Lists.Init(Talon);
   Lists.Init(Hilfsstapel);
   Lists.Init(Ablage);

   Hilfsstapelsize := 0;
   REPEAT
      karte := Lists.RemHead(Karten);
      DEC(Kartensize);
      Lists.AddHead(Hilfsstapel,karte);
      INC(Hilfsstapelsize);
   UNTIL Hilfsstapelsize = 32;
   MaleHilfsstapel;

   Talon := Karten;
   Talonsize := Kartensize;
   Ablagesize := 0;
   MaleAblage;
   Einblenden(ScP,Colors);

   i := 0;
   REPEAT
      Lists.Init(Familie[i]);
      Lists.Init(Bau[i]);
      karte := Lists.RemHead(Talon);
      DEC(Talonsize);
      MaleTalon;
      DrawLineSwitch(karte,talonx,talony,BauX[i],BauOffs[0,i]);
      Lists.AddHead(Bau[i],karte);
      Bausize[i] := 1;
      MaleBaustelle(i);
      INC(i);
   UNTIL i = 8;
   PruefeAnfangsDamen;

END InitStapel;

(* ------------------------------------------------------------------ *)

PROCEDURE DragKarte(which : Lists.NodePtr; x,y : INTEGER; VAR lx,ly : INTEGER);

VAR i,farbe,typ,newx,newy : INTEGER;

BEGIN

WITH which : CardT DO

   farbe := which.farbe;
   typ := which.typ;

END;

lx := x; ly := y;
newx := x-kdx; newy := y-kdy;
IF newx < 0 THEN newx := 0 END;
IF newy < 0 THEN newy := 0 END;
IF newx > maxx THEN newx := maxx END;
IF newy > maxy THEN newy := maxy END;

LOOP

   IF G.BltBitMap(WinP.rPort.bitMap,newx,newy,SaveBM,0,0,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   IF G.BltBitMap(cardBMs[farbe,typ],0,0,WinP.rPort.bitMap,newx,newy,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   REPEAT
      REPEAT
         IMessPtr := E.GetMsg(WinP.userPort);
          IF IMessPtr # NIL THEN
            IMess := IMessPtr^;
            E.ReplyMsg(IMessPtr);
            IF (I.mouseButtons IN IMess.class) AND (IMess.code = I.selectDown) THEN
               IF G.BltBitMap(SaveBM,0,0,WinP.rPort.bitMap,newx,newy,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
               I.ModifyIDCMP(WinP,LONGSET{});
               EXIT;
            END;
         END;
      UNTIL IMessPtr = NIL;
      lx := WinP^.mouseX; ly := WinP^.mouseY;
   UNTIL (lx#x) OR (ly#y);
   G.WaitTOF;
   x :=lx; y :=ly;
   IF G.BltBitMap(SaveBM,0,0,WinP.rPort.bitMap,newx,newy,kbreite,khoehe,0C0X,SHORTSET{0..7},0)=0 THEN END;
   newx := lx-kdx; newy := ly-kdy;
   IF newx < 0 THEN newx := 0 END;
   IF newy < 0 THEN newy := 0 END;
   IF newx > maxx THEN newx := maxx END;
   IF newy > maxy THEN newy := maxy END;

END;

END DragKarte;

(* ------------------------------------------------------------------ *)

PROCEDURE MoveKarte;

VAR
      x,y,endx,endy,backx,backy,i,j : INTEGER;
   took,totalon,toab,tono,talondame : BOOLEAN;
                        tofam,tobau : ARRAY 8 OF BOOLEAN;
                       karte,karte2 : Lists.NodePtr;

PROCEDURE pruefefam(i:INTEGER;karte: Lists.NodePtr) : BOOLEAN;

VAR top:Lists.NodePtr;

BEGIN

   top := Lists.Head(Familie[i]);
   IF top # NIL THEN
      WITH top:CardT DO
         WITH karte:CardT DO
            IF top.typ # dame THEN
               IF (karte.farbe = top.farbe) AND ((karte.typ = top.typ + 1)
                  OR ((karte.typ = as) AND (top.typ = koenig)))
               THEN RETURN TRUE;
               ELSE RETURN FALSE;
               END;
            END;
         END;
      END;
   ELSIF karte(CardT).typ = koenig THEN RETURN TRUE;
   END;
   RETURN FALSE;

END pruefefam;

PROCEDURE pruefebau(i:INTEGER;karte: Lists.NodePtr) : BOOLEAN;

VAR top:Lists.NodePtr;

BEGIN

   top := Lists.Head(Bau[i]);
   IF top # NIL THEN
      WITH top:CardT DO
         WITH karte:CardT DO
            IF top.typ # koenig THEN
               IF (karte.farbe = top.farbe) AND (karte.typ = top.typ - 1)
               THEN RETURN TRUE;
               END;
            END;
         END;
      END;
   END;
   RETURN FALSE;

END pruefebau;

PROCEDURE TesteEnde;

VAR j,k: INTEGER;
    card: Lists.NodePtr;
    test: BOOLEAN;

BEGIN
   IF Ablagesize = 0 THEN
      j := 0;
      LOOP
         IF Lists.Empty(Familie[j]) THEN EXIT; END;
         card := Lists.Head(Familie[j]);
         IF card(CardT).typ = dame THEN gewonnen := TRUE;
         ELSE gewonnen := FALSE;EXIT;
         END;
         INC(j); IF j = 8 THEN EXIT; END;
      END;
   END;

   IF NOT gewonnen THEN

      LOOP
         IF Ablagesize > 0 THEN
            card := Lists.Head(Ablage);
            k := 0;
            REPEAT
               IF pruefebau(k,card) THEN EXIT; END;
               IF pruefefam(k,card) THEN EXIT; END;
               INC(k);
            UNTIL k = 8;
         END;
         k := 0;
         REPEAT
            IF Bausize[k] > 0 THEN
               card := Lists.Head(Bau[k]);
               j := 0;
               REPEAT
                  IF (j # k) AND (Bausize[k] = 1) AND pruefebau(j,card)
                     THEN EXIT;
                  END;
                  IF pruefefam(j,card) THEN EXIT END;
                  INC(j);
               UNTIL j = 8;
            END;
            INC(k);
         UNTIL k = 8;
         k := 0;
         REPEAT
            IF Bausize[k] > 0 THEN
               card := Lists.Tail(Bau[k]);
               j := 0;
               REPEAT
                  IF j # k THEN IF pruefebau(j,card) THEN EXIT END;END;
                  INC(j);
               UNTIL j = 8;
            END;
            INC(k);
         UNTIL k = 8;
         verloren := TRUE;EXIT;
      END;
   END;

END TesteEnde;

PROCEDURE leerbau(i:INTEGER);

VAR    hkarte : Lists.NodePtr;
    hilfsdame : BOOLEAN;
            j : INTEGER;
BEGIN
   hilfsdame := FALSE;
   IF Bausize[i] = 0 THEN
      IF Hilfsstapelsize > 0 THEN
         hkarte := Lists.RemHead(Hilfsstapel);
         DEC(Hilfsstapelsize);
         MaleHilfsstapel;
         IF hkarte(CardT).typ = dame THEN hilfsdame := TRUE;END;
         DrawLineSwitch(hkarte,hilfsx,hilfsy,BauX[i],BauOffs[0,i]);
         Lists.AddHead(Bau[i],hkarte);
         INC(Bausize[i]);
         MaleBaustelle(i);
         IF hilfsdame THEN
            j := 0;
            velo := 10;
            LOOP
               IF Hilfsstapelsize = 0 THEN EXIT;END;
               hkarte := Lists.RemHead(Hilfsstapel);
               DEC(Hilfsstapelsize);
               MaleHilfsstapel;
               IF Hilfsstapelsize >= 1 THEN
                  rechtsraus(hkarte,hilfsx,hilfsy);
                     IF Talonsize > 0 THEN
                     DrawLineBack(hkarte,hilfsx+kbreite,hilfsy,talonx-kbreite,talony);
                     linksrein(hkarte,talonx,talony);
                  ELSE
                     DrawLineBack(hkarte,hilfsx+kbreite,hilfsy,talonx,talony);
                  END;
               ELSE
                  IF Talonsize > 0 THEN
                     DrawLineBack(hkarte,hilfsx,hilfsy,talonx-kbreite,talony);
                     linksrein(hkarte,talonx,talony);
                  ELSE
                     DrawLineBack(hkarte,hilfsx,hilfsy,talonx,talony);
                  END;
               END;
               Lists.AddTail(Talon,hkarte);
               INC(Talonsize);MaleTalon;
               INC(j); IF j = 5 THEN EXIT; END;
            END;
            velo := 9;
         END;
      ELSIF Ablagesize > 0 THEN
         hkarte := Lists.RemHead(Ablage);
         DEC(Ablagesize);
         MaleAblage;
         DrawLineCard(hkarte,junkx,junky,BauX[i],BauOffs[0,i]);
         Lists.AddHead(Bau[i],hkarte);
         INC(Bausize[i]);
         MaleBaustelle(i);
      ELSIF Talonsize > 0 THEN
         hkarte := Lists.RemHead(Talon);
         DEC(Talonsize);
         IF (hkarte(CardT).typ = dame)
            THEN talondame := TRUE;END;
         MaleTalon;
         DrawLineSwitch(hkarte,talonx,talony,BauX[i],BauOffs[0,i]);
         Lists.AddHead(Bau[i],hkarte);
         INC(Bausize[i]);
         MaleBaustelle(i);
      END;
   END;

END leerbau;

PROCEDURE BauzuFamilie(baunr,famnr:INTEGER);

VAR k : INTEGER;
    vergleichskarte,baukarte : Lists.NodePtr;

BEGIN

IF (baunr < 4) AND (famnr = baunr +2) OR
   (baunr >= 4)AND (famnr = baunr -2) THEN
   velo := 7;
END;
IF Bausize[baunr] > 0 THEN
   baukarte := Lists.Head(Bau[baunr]);
   LOOP
      k := 0;
      REPEAT
         IF (k # baunr) AND (Bausize[k] > 0) AND (Bausize[k] # Bausize[baunr]) THEN
            vergleichskarte := Lists.Head(Bau[k]);
            WITH baukarte:CardT DO
               WITH vergleichskarte:CardT DO
                  IF (baukarte.farbe = vergleichskarte.farbe) AND
                     (baukarte.typ = vergleichskarte.typ) THEN EXIT;END;
               END;
            END;
         END;
         INC(k);
      UNTIL k = 8;
      IF Ablagesize > 0 THEN
         vergleichskarte := Lists.Head(Ablage);
         WITH baukarte:CardT DO
            WITH vergleichskarte:CardT DO
               IF (baukarte.farbe = vergleichskarte.farbe) AND
                  (baukarte.typ = vergleichskarte.typ) THEN EXIT;END;
            END;
         END;
      END;   
      baukarte := Lists.RemHead(Bau[baunr]);
      DEC(Bausize[baunr]);MaleBaustelle(baunr);
      CASE Bausize[baunr] OF
      0:
         DrawLineCard(baukarte,BauX[baunr],BauOffs[0,baunr],FamX[famnr],FamY[famnr]);
         |
      1..7:
          DrawLineCard(baukarte,BauX[baunr],BauOffs[Bausize[baunr],baunr],FamX[famnr],FamY[famnr]);
          |
      ELSE
           DrawLineCard(baukarte,BauX[baunr],BauOffs1[Bausize[baunr],baunr],FamX[famnr],FamY[famnr]);
      END;
      Lists.AddHead(Familie[famnr],baukarte);
      MaleFamilie(famnr);
      IF Bausize[baunr] = 0 THEN EXIT; ELSE baukarte := Lists.Head(Bau[baunr]); END;
   END;
END;
velo := 9;

END BauzuFamilie;

PROCEDURE stapelumbau(i,j:INTEGER);

VAR baukarte : Lists.NodePtr;
           l : INTEGER;
           
BEGIN

IF (i < 4) AND (j = i + 4) OR (i >= 4) AND (j = i - 4) THEN
   velo := 7;
END;
IF Bausize[i] < 8 THEN
   l := 1;
   LOOP
      IF Bausize[i] = 1 THEN EXIT;END;
      baukarte := Lists.RemTail(Bau[i]);DEC(Bausize[i]);
      CASE l OF
      1..2:
         IF G.BltBitMap(Leerstelle,0,9*l,WinP.rPort.bitMap,BauX[i],BauOffs[l,i],kbreite,9,0C0X,SHORTSET{0..7},0)=0 THEN END;
         |
      3:
         IF G.BltBitMap(Leerstelle,0,9*l,WinP.rPort.bitMap,BauX[i],BauOffs[l,i],kbreite,9,0C0X,SHORTSET{0..7},0)=0 THEN END;
         G.SetAPen(WinP.rPort,0);
         G.RectFill(WinP.rPort,BauX[i],BauOffs[0,i]+khoehe,BauX[i]+kbreite,BauOffs[0,i]+khoehe);
         |
      ELSE
         G.SetAPen(WinP.rPort,0);
         G.RectFill(WinP.rPort,BauX[i],BauOffs[l,i],BauX[i]+kbreite,BauOffs[l,i]+8);
      END;
      CASE Bausize[j] OF
      1..7:
         DrawLineCard(baukarte,BauX[i],BauOffs[l,i],BauX[j],BauOffs[Bausize[j]-1,j]+9);
         |
      8:
         DrawLineCard(baukarte,BauX[i],BauOffs[l,i],BauX[j],BauOffs[7,j]);
         |
      ELSE
         DrawLineCard(baukarte,BauX[i],BauOffs[l,i],BauX[j],BauOffs1[Bausize[j]-1,j]+5);
      END;
      Lists.AddHead(Bau[j],baukarte);INC(Bausize[j]);
      MaleBaustelle(j); INC(l);
   END;
   baukarte := Lists.RemTail(Bau[i]);DEC(Bausize[i]);
   DrawEmpty(BauX[i],BauOffs[0,i]);
   G.SetAPen(WinP.rPort,0);
   G.RectFill(WinP.rPort,BauX[i],BauOffs[0,i]+khoehe,BauX[i]+kbreite,BauOffs[0,i]+98);
   CASE Bausize[j] OF
   1..7:
      DrawLineCard(baukarte,BauX[i],BauOffs[l,i],BauX[j],BauOffs[Bausize[j]-1,j]+9);
      |
   8:
      DrawLineCard(baukarte,BauX[i],BauOffs[l,i],BauX[j],BauOffs[7,j]);
      |
   ELSE
      DrawLineCard(baukarte,BauX[i],BauOffs[l,i],BauX[j],BauOffs1[Bausize[j]-1,j]+5);
   END;
   Lists.AddHead(Bau[j],baukarte);INC(Bausize[j]);
   MaleBaustelle(j);
ELSE
   l := 1;
   LOOP
      IF Bausize[i] = 1 THEN EXIT;END;
      baukarte := Lists.RemTail(Bau[i]);DEC(Bausize[i]);
      CASE l OF 
      1..5:
         IF G.BltBitMap(Leerstelle,0,9+5*(l-1),WinP.rPort.bitMap,BauX[i],BauOffs1[l,i],kbreite,5,0C0X,SHORTSET{0..7},0)=0 THEN END;
         |
      6:
         IF G.BltBitMap(Leerstelle,0,9+5*(l-1),WinP.rPort.bitMap,BauX[i],BauOffs1[l,i],kbreite,1,0C0X,SHORTSET{0..7},0)=0 THEN END;
         G.SetAPen(WinP.rPort,0);
         G.RectFill(WinP.rPort,BauX[i],BauOffs1[0,i]+khoehe,BauX[i]+kbreite,BauOffs1[0,i]+khoehe+3);
         |
      ELSE
         G.SetAPen(WinP.rPort,0);
         G.RectFill(WinP.rPort,BauX[i],BauOffs1[l,i],BauX[i]+kbreite,BauOffs1[l,i]+4);
      END;
      CASE Bausize[j] OF
      1..7:
         DrawLineCard(baukarte,BauX[i],BauOffs1[l,i],BauX[j],BauOffs[Bausize[j]-1,j]+9);
         |
      8:
         DrawLineCard(baukarte,BauX[i],BauOffs1[l,i],BauX[j],BauOffs[7,j]);
         |
      ELSE
         DrawLineCard(baukarte,BauX[i],BauOffs1[l,i],BauX[j],BauOffs1[Bausize[j]-1,j]+5);
      END;
      Lists.AddHead(Bau[j],baukarte);INC(Bausize[j]);
      MaleBaustelle(j); INC(l);
   END;
   baukarte := Lists.RemTail(Bau[i]);DEC(Bausize[i]);
   G.SetAPen(WinP.rPort,0);
   G.RectFill(WinP.rPort,BauX[i],BauOffs[0,i]+khoehe,BauX[i]+kbreite,BauOffs[0,i]+98);
   CASE Bausize[j] OF
   1..7:
      DrawLineCard(baukarte,BauX[i],BauOffs1[l,i],BauX[j],BauOffs[Bausize[j]-1,j]+9);
      |
   8:
      DrawLineCard(baukarte,BauX[i],BauOffs1[l,i],BauX[j],BauOffs[7,j]);
      |
   ELSE
      DrawLineCard(baukarte,BauX[i],BauOffs1[l,i],BauX[j],BauOffs1[Bausize[j]-1,j]+5);
   END;
   Lists.AddHead(Bau[j],baukarte);INC(Bausize[j]);
   MaleBaustelle(j);
END;
velo := 9;

END stapelumbau;

BEGIN

   x := WinP^.mouseX;
   y := WinP^.mouseY;
   took := FALSE; talontake := FALSE; hilfstake := FALSE; ablagetake := FALSE;
   totalon := FALSE;toab := FALSE;tono := TRUE;talondame := FALSE;

   i := 0;
   REPEAT
      baustapel[i] := FALSE;
      bautake[i] := FALSE;
      tofam[i] := FALSE;
      tobau[i] := FALSE;
      INC(i);
   UNTIL i = 8;
   IF (x > 620) AND (y < 12) THEN I.ScreenToBack(ScP);END;
   IF (Talonsize > 0) AND (x >= talonx) AND (x <= talonx+kbreite) AND (y >= talony)
      AND (y <= talony+khoehe)
   THEN
      karte := Lists.RemHead(Talon);
      DEC(Talonsize); talontake := TRUE; took := TRUE;MaleTalon;
   ELSIF
      (Ablagesize > 0) AND (x >= junkx) AND (x <= junkx+kbreite) AND (y >= junky)
      AND (y <= junky+khoehe)
   THEN
      karte := Lists.RemHead(Ablage);
      DEC(Ablagesize); ablagetake := TRUE; took := TRUE;MaleAblage;
   ELSE
      i := 0;
      LOOP
         IF (x >= BauX[i]) AND (x <= BauX[i]+kbreite) THEN
            IF ((Bausize[i] = 1) AND (y >= BauOffs[0,i]) AND (y <= BauOffs[0,i]+khoehe)) OR
               ((Bausize[i] >= 2) AND (Bausize[i] <= 8)
               AND (y >= BauOffs[0,i]+9*(Bausize[i]-1))
               AND (y <= BauOffs[0,i]+9*(Bausize[i]-1)+khoehe)) OR
               ((Bausize[i] > 8) AND (y >= BauOffs[0,i]+4+5*(Bausize[i]-1))
               AND (y <= BauOffs[0,i]+4+5*(Bausize[i]-1)+khoehe))
            THEN
               karte := Lists.RemHead(Bau[i]);
               DEC(Bausize[i]); bautake[i] := TRUE; took := TRUE;MaleBaustelle(i);
               EXIT;
            ELSIF ((Bausize[i] >= 2) AND (Bausize[i] <= 8)
               AND (y >= BauOffs[0,i]) AND (y < BauOffs[0,i]+9*(Bausize[i]-1)))
            OR ((Bausize[i] > 8) AND (y >= BauOffs[0,i])
               AND (y < BauOffs[0,i]+4+5*(Bausize[i]-1)))
            THEN karte := Lists.RemTail(Bau[i]);DEC(Bausize[i]);
               baustapel[i] := TRUE; took := TRUE;
               IF G.BltBitMap(Leerstelle,0,0,WinP.rPort.bitMap,BauX[i],BauOffs[0,i],kbreite,9,0C0X,SHORTSET{0..7},0)=0 THEN END;
               EXIT;
            END;
         END;
         INC(i); IF i = 8 THEN EXIT END;
      END;
   END;

   IF took THEN
      I.SetPointer(WinP,SYSTEM.VAL(LONGINT,Backs.hand2Data),16,15,7,0);
      DragKarte(karte,x,y,endx,endy);
      I.SetPointer(WinP,SYSTEM.VAL(LONGINT,Backs.hand1Data),16,16,0,0);
      I.ModifyIDCMP(WinP,LONGSET{});
      backx := endx-kdx; backy := endy-kdy;
      IF endx > maxx+kdx THEN backx := maxx; END;
      IF endx <      kdx THEN backx :=    0; END;
      IF endy > maxy+kdy THEN backy := maxy; END;
      IF endy <      kdy THEN backy :=    0; END;
      IF (endx >= junkx) AND (endx <= junkx+kbreite) AND (endy >= junky)
         AND (endy <= junky+khoehe) THEN toab := TRUE; tono := FALSE;
      ELSIF (endx >= talonx) AND (endx <= talonx+kbreite) AND (endy >= talony)
         AND (endy <= talony+khoehe) THEN totalon := TRUE; tono := FALSE;
      ELSE
         i := 0;
         LOOP
            IF (endx >= FamX[i]) AND (endx <= FamX[i]+kbreite)
               AND (endy >= FamY[i]) AND (endy <= FamY[i]+khoehe)
            THEN tofam[i] := TRUE; tono := FALSE; EXIT; END;
            IF (endx >= BauX[i]) AND (endx <= BauX[i]+kbreite)
               AND (endy >= BauOffs[0,i]) AND (endy <= BauOffs[0,i]+98)
            THEN tobau[i] := TRUE; tono := FALSE; EXIT; END;
            INC(i); IF i = 8 THEN EXIT;END;
         END;
      END;
      IF NOT tono THEN
         tono := TRUE;
         IF talontake OR ablagetake THEN
            IF talontake AND totalon THEN
               Lists.AddHead(Talon,karte);
               INC(Talonsize);tono := FALSE;
               MaleTalon;
            ELSIF toab THEN
               IF (karte(CardT).typ = dame) AND talontake THEN talondame := TRUE;END;
               Lists.AddHead(Ablage,karte);
               INC(Ablagesize);tono := FALSE;
               MaleAblage;
            ELSE
               i := 0;
               LOOP
                  IF tobau[i] THEN
                     IF pruefebau(i,karte) THEN
                        Lists.AddHead(Bau[i],karte);
                        INC(Bausize[i]);tono := FALSE;
                        MaleBaustelle(i);
                        EXIT;
                     ELSIF talontake THEN
                        DrawLineSwitchR(karte,backx,backy,talonx,talony);
                        Lists.AddHead(Talon,karte);
                        INC(Talonsize);tono := FALSE;
                        MaleTalon;
                        EXIT;
                     ELSE
                        DrawLineCard(karte,backx,backy,junkx,junky);
                        Lists.AddHead(Ablage,karte);
                        INC(Ablagesize);tono := FALSE;
                        MaleAblage;
                        EXIT;
                     END;
                  END;
                  IF tofam[i] THEN
                     IF pruefefam(i,karte) THEN
                        IF (karte(CardT).typ = dame) AND talontake
                        THEN talondame := TRUE;END;
                        Lists.AddHead(Familie[i],karte);tono := FALSE;
                        MaleFamilie(i);
                        EXIT;
                     ELSIF talontake THEN
                        DrawLineSwitchR(karte,backx,backy,talonx,talony);
                        Lists.AddHead(Talon,karte);
                        INC(Talonsize);tono := FALSE;
                        MaleTalon;
                        EXIT;
                     ELSE
                        DrawLineCard(karte,backx,backy,junkx,junky);
                        Lists.AddHead(Ablage,karte);
                        INC(Ablagesize);tono := FALSE;
                        MaleAblage;
                        EXIT;
                     END;
                  END;
                  INC(i);
                  IF i = 8 THEN EXIT;END;
               END;
            END;
         ELSE
            i := 0;
            LOOP
               IF bautake[i] THEN
                  IF tobau[i] THEN Lists.AddHead(Bau[i],karte);INC(Bausize[i]);
                     MaleBaustelle(i);tono := FALSE;EXIT;
                  ELSE
                     j := 0;
                     REPEAT
                        IF tofam[j] THEN
                           IF pruefefam(j,karte) THEN
                              Lists.AddHead(Familie[j],karte);
                              MaleFamilie(j);
                              BauzuFamilie(i,j);
                              tono := FALSE;
                              leerbau(i);
                              EXIT;
                           ELSE EXIT;
                            END;
                        ELSIF (j # i) AND tobau[j] THEN
                           IF pruefebau(j,karte) THEN
                              Lists.AddHead(Bau[j],karte);
                              INC(Bausize[j]);tono := FALSE;
                              MaleBaustelle(j);
                              leerbau(i);
                              EXIT;
                           ELSE EXIT;
                           END;
                        END;
                        INC(j);
                     UNTIL j = 8;
                  END;
               ELSIF baustapel[i] THEN
                  IF tobau[i] THEN Lists.AddTail(Bau[i],karte);INC(Bausize[i]);
                     WITH karte:CardT DO
                        IF G.BltBitMap(cardBMs[karte.farbe,karte.typ],0,0,
                           WinP.rPort.bitMap,BauX[i],BauOffs[0,i],kbreite,9,0C0X,SHORTSET{0..7},0)=0 THEN END;
                     END;
                     tono := FALSE;EXIT;
                  ELSE
                     j := 0;
                     REPEAT
                        IF j # i THEN
                           IF tobau[j] THEN
                              IF pruefebau(j,karte) THEN
                                 Lists.AddHead(Bau[j],karte);INC(Bausize[j]);
                                 MaleBaustelle(j);tono := FALSE;
                                 stapelumbau(i,j);
                                 leerbau(i);
                                 EXIT;      
                              ELSE EXIT;
                              END;
                           END;
                        END;
                        INC(j);
                     UNTIL j = 8;
                  END;
               END;
               INC(i); IF i = 8 THEN EXIT END;
            END;
         END;
      END;               (* IF NOT tono ...   *)

      IF tono THEN
         IF talontake OR ablagetake THEN
            IF (karte(CardT).typ = dame) AND talontake
               THEN talondame := TRUE;END;
            DrawLineCard(karte,backx,backy,junkx,junky);
            Lists.AddHead(Ablage,karte);INC(Ablagesize);
            MaleAblage;
         ELSE
            i := 0;
            LOOP
               IF bautake[i] THEN
                  Lists.AddHead(Bau[i],karte);INC(Bausize[i]);
                  IF Bausize[i] < 9 THEN
                      DrawLineCard(karte,backx,backy,BauX[i],BauOffs[Bausize[i]-1,i]);
                  ELSE
                       DrawLineCard(karte,backx,backy,BauX[i],BauOffs1[Bausize[i]-1,i]);
                  END;
                  MaleBaustelle(i);EXIT;
               END;
               IF baustapel[i] THEN
                  DrawLineCard(karte,backx,backy,BauX[i],BauOffs[0,i]);
                  WITH karte:CardT DO
                       IF G.BltBitMap(cardBMs[karte.farbe,karte.typ],0,0,
                     WinP.rPort.bitMap,BauX[i],BauOffs[0,i],kbreite,9,0C0X,SHORTSET{0..7},0)=0 THEN END;
                  END;
                  Lists.AddTail(Bau[i],karte);INC(Bausize[i]);
                  MaleBaustelle(i);EXIT;
               END;
               INC(i); IF i = 8 THEN EXIT END;
            END;
         END;
      END;        (* IF tono ... *)
      
      IF talondame THEN
         i := 0; velo := 7;
         LOOP
            IF Ablagesize = 0 THEN EXIT END;
            karte2 := Lists.RemTail(Ablage);
            DEC(Ablagesize);MaleAblage;
            IF Ablagesize >= 1 THEN
               rechtsraus(karte2,junkx,junky);
               IF Talonsize > 0 THEN
                  DrawLineBack(karte2,junkx+kbreite,junky,talonx+kbreite,talony);
                  rechtsrein(karte2,talonx,talony);
               ELSE
                  DrawLineBack(karte2,junkx+kbreite,junky,talonx,talony);
               END;
            ELSE
               IF Talonsize > 0 THEN
                  DrawLineSwitchR(karte2,junkx,junky,talonx+kbreite,talony);
                  rechtsrein(karte2,talonx,talony);
               ELSE
                  DrawLineSwitchR(karte2,junkx,junky,talonx,talony);
               END;
            END;
            Lists.AddTail(Talon,karte2);
            INC(Talonsize);MaleTalon;
            INC(i); IF i = 3 THEN EXIT; END;
         END;
         velo := 8;
      END;     (* IF talondame ... *)
   END;                    (* IF took ... *)
   IF Talonsize = 0 THEN TesteEnde; END;
   I.ModifyIDCMP(WinP,LONGSET{I.mouseButtons,I.rawKey,I.gadgetUp});
   
END MoveKarte;

(* ------------------------------------------------------------------ *)

PROCEDURE ReturnKarten(VAR Ks : Lists.List);

VAR karte : Lists.NodePtr;
        j : INTEGER;
BEGIN

   Ks := Ablage;
   WHILE Talonsize > 0 DO
         karte := Lists.RemHead(Talon);
         DEC(Talonsize);
         Lists.AddHead(Ks,karte);
   END;
   WHILE Hilfsstapelsize > 0 DO
         karte := Lists.RemHead(Hilfsstapel);
         DEC(Hilfsstapelsize);
         Lists.AddHead(Ks,karte);
   END;
   j := 0;
   REPEAT
      WHILE Bausize[j] > 0 DO
            karte := Lists.RemHead(Bau[j]);
            DEC(Bausize[j]);
            Lists.AddHead(Ks,karte);
            MaleBaustelle(j);
      END;
      WHILE NOT Lists.Empty(Familie[j]) DO
            karte := Lists.RemHead(Familie[j]);
            Lists.AddHead(Ks,karte);
      END;
      INC(j);
   UNTIL j = 8;

END ReturnKarten;

PROCEDURE ThreeGadReq(titel,text,links,rechts,mitte:ARRAY OF CHAR):INTEGER;

VAR int : INTEGER;
    myTextStruct : Req.TRStructurePtr;
    result : INTEGER;
BEGIN

   NEW(myTextStruct);
   IF text # "" THEN
   	myTextStruct.text := SYSTEM.ADR(text);
   ELSE myTextStruct.text := NIL;
   END;
	myTextStruct.controls := NIL;
	myTextStruct.window := NIL;
	IF mitte # "" THEN
	   myTextStruct.middleText := SYSTEM.ADR(mitte);
	ELSE myTextStruct.middleText := NIL;
	END;
	IF links # "" THEN
   	myTextStruct.positiveText := SYSTEM.ADR(links);
   ELSE myTextStruct.positiveText := NIL;
   END;
   IF rechts # "" THEN
   	myTextStruct.negativeText := SYSTEM.ADR(rechts);
   ELSE myTextStruct.negativeText := NIL;
   END;
   IF titel # "" THEN
   	myTextStruct.title := SYSTEM.ADR(titel);
   ELSE myTextStruct.title := NIL;
   END;
	myTextStruct.keyMask := {};
	myTextStruct.textcolor := 11;
	myTextStruct.detailcolor := 8;
	myTextStruct.blockcolor := 6;
	myTextStruct.versionnumber := 0;
	myTextStruct.rfu1 := 0;
	myTextStruct.rfu2 := 0;
	result := Req.TextRequest(myTextStruct);
   DISPOSE(myTextStruct);
   RETURN result;
   
END ThreeGadReq;

PROCEDURE Gewinn;

VAR  i,j,k,farbe,typ : INTEGER;
               cards : ARRAY 8 OF Lists.NodePtr;
               farben : ARRAY 8 OF INTEGER;
BEGIN

IF text THEN WriteText(FALSE);END;
IF NumsOn THEN WriteNums(TRUE,FALSE,FALSE,FALSE);NumsOn := NOT NumsOn;END;
G.SetAPen(WinP.rPort,0);
G.RectFill(WinP.rPort,hilfsx,hilfsy,hilfsx+kbreite,hilfsy+khoehe);
G.RectFill(WinP.rPort,junkx,junky,junkx+kbreite,junky+khoehe);
G.RectFill(WinP.rPort,talonx,talony,talonx+kbreite,talony+khoehe);
i := 0;
REPEAT
   G.RectFill(WinP.rPort,BauX[i],BauOffs[0,i],BauX[i]+kbreite,BauOffs[0,i]+khoehe);
   INC(i);
UNTIL i = 8;

i := 0;
REPEAT
   cards[i] := Lists.Head(Familie[i]);
   farben[i] := cards[i](CardT).farbe;
   j := 0;
   REPEAT
      typ := 10-j;k := 0;
      REPEAT
         IF typ = -1 THEN
            IF G.BltBitMap(cardBMs[farben[i],koenig],0,0,WinP.rPort.bitMap,FamX[i],FamY[i],kbreite,9,0C0X,SHORTSET{0..7},0)=0 THEN END;
            INC(typ);INC(k);
         END;
         IF G.BltBitMap(cardBMs[farben[i],typ],0,0,WinP.rPort.bitMap,FamX[i],FamY[i]+k*9,kbreite,9,0C0X,SHORTSET{0..7},0)=0 THEN END;
         INC(typ);INC(k);
      UNTIL typ = dame;
      Depict(cardBMs[farben[i],dame],FamX[i],FamY[i]+9*(j+1));
      INC(j);
   UNTIL j = koenig;
   INC(i);Dos.Delay(8);
UNTIL i = 8;

G.SetAPen(WinP.rPort,5);
G.Move(WinP.rPort,290,184);
G.Text(WinP.rPort,"BRAVO !!!",9);
G.Move(WinP.rPort,252,224);
G.Text(WinP.rPort,"Click to continue !",19);

I.ModifyIDCMP(WinP,LONGSET{I.mouseButtons,I.rawKey});
Queenshelp.WaitLeftButton(WinP);
I.ModifyIDCMP(WinP,LONGSET{I.rawKey});
G.SetAPen(WinP.rPort,0);
G.RectFill(WinP.rPort,252,170,420,234);

i := 0;
REPEAT
   INC(i,2);
   I.MoveScreen(ScP,0,2);
UNTIL i = maxy-FamY[0]-9*12;

i := 0;
REPEAT
   Depict(cardBMs[farben[0],dame],FamX[0],FamY[0]+9*12-i);
   G.RectFill(WinP.rPort,FamX[0],FamY[0]+9*12-i+khoehe,FamX[0]+kbreite,FamY[0]+9*12-i+khoehe+2);
   Depict(cardBMs[farben[7],dame],FamX[7],FamY[0]+9*12-i);
   G.RectFill(WinP.rPort,FamX[7],FamY[7]+9*12-i+khoehe,FamX[7]+kbreite,FamY[7]+9*12-i+khoehe+2);
   I.MoveScreen(ScP,0,3);
   INC(i,3);
UNTIL i = 9;
i := 0;
REPEAT
   Depict(cardBMs[farben[0],dame],FamX[0],FamY[1]+9*12-i);
   G.RectFill(WinP.rPort,FamX[0],FamY[0]+9*12-i+khoehe,FamX[0]+kbreite,FamY[0]+9*12-i+khoehe+2);
   Depict(cardBMs[farben[7],dame],FamX[7],FamY[1]+9*12-i);
   G.RectFill(WinP.rPort,FamX[7],FamY[7]+9*12-i+khoehe,FamX[7]+kbreite,FamY[7]+9*12-i+khoehe+2);
   Depict(cardBMs[farben[1],dame],FamX[1],FamY[1]+9*12-i);
   G.RectFill(WinP.rPort,FamX[1],FamY[1]+9*12-i+khoehe,FamX[1]+kbreite,FamY[1]+9*12-i+khoehe+2);
   Depict(cardBMs[farben[6],dame],FamX[6],FamY[1]+9*12-i);
   G.RectFill(WinP.rPort,FamX[6],FamY[6]+9*12-i+khoehe,FamX[6]+kbreite,FamY[6]+9*12-i+khoehe+2);
   I.MoveScreen(ScP,0,3);
   INC(i,3);
UNTIL i = 6;

i := 0;
REPEAT
   j := 0;
   REPEAT
      Depict(cardBMs[farben[j],dame],FamX[j],FamY[2]+9*12-i);
      G.RectFill(WinP.rPort,FamX[j],FamY[2]+9*12-i+khoehe,FamX[j]+kbreite,FamY[2]+9*12-i+khoehe+8);
      INC(j);
   UNTIL j = 8;
   I.MoveScreen(ScP,0,3);
   INC(i,3);
UNTIL i = 120;

j := 0;
REPEAT
   I.MoveScreen(ScP,0,2);
   INC(j);
UNTIL j = 50;

END Gewinn;

(* ------------------------------------------------------------------ *)
(* ------------------------------------------------------------------ *)

BEGIN

OpenAll();
myproc := SYSTEM.VAL(Dos.ProcessPtr,E.FindTask(NIL));
oldWinP := myproc.windowPtr;
myproc.windowPtr := WinP;
InitCardBMs;
velo := 9;
text := TRUE; NumsOn := TRUE; stop := FALSE;
InitKarten(Karten);
MaleAnfang;
REPEAT
   Kartensize := 104;
   WriteText(text);
   MischKarten(Karten);
   InitStapel;
   gewonnen := FALSE; verloren := FALSE;
   I.ModifyIDCMP(WinP,LONGSET{I.mouseButtons,I.rawKey,I.gadgetUp});
   
   LOOP
      LOOP
        IMessPtr := E.GetMsg(WinP.userPort);
        IF IMessPtr # NIL THEN EXIT END;
        E.WaitPort(WinP.userPort);
      END;
      IMess := IMessPtr^;
      E.ReplyMsg(IMessPtr);

      IF (I.mouseButtons IN IMess.class) AND (IMess.code = I.selectDown) THEN
         MoveKarte;
         IF gewonnen THEN Gewinn; EXIT; END;
         IF verloren THEN
            IF ThreeGadReq("What a pity..."," RIEN NE VA PLUS ! ",
               "New Game","Quit Out","")=0 THEN
               stop := TRUE;
            END;
            EXIT;
         END;
      END;           

      IF (I.rawKey IN IMess.class) THEN
         CASE IMess.code OF
            64: text := NOT text;
                WriteText(text);|
            70: WriteNums(TRUE,TRUE,TRUE,TRUE);|
            95: Queenshelp.Help;
                I.ActivateWindow(WinP);|
            69: IF ThreeGadReq("Start a new game ?","                    "," Oh no! "," YES ! ","")=0 THEN
                I.ModifyIDCMP(WinP,LONGSET{});EXIT;END;|
            16: IF ThreeGadReq("Really quit ?","               "," Oh no! "," Quit ! ","")=0 THEN
                stop := TRUE;I.ModifyIDCMP(WinP,LONGSET{});EXIT;END;|
         ELSE
         END;   
      END;
      
      IF (I.gadgetUp IN IMess.class) THEN
         gadgetPtr := IMess.iAddress;
         gadgetnum := gadgetPtr.gadgetID;
   
         CASE gadgetnum OF
            0: IF ThreeGadReq(" Really quit ? ","               "," Oh no! "," Quit ! ","")=0 THEN
               stop := TRUE;I.ModifyIDCMP(WinP,LONGSET{});EXIT;END;|
            1: Queenshelp.Help;
               I.ActivateWindow(WinP);|
            2: IF ThreeGadReq(" Start a new game ? ","                    "," Oh no! "," YES ! ","")=0 THEN
               I.ModifyIDCMP(WinP,LONGSET{});EXIT;END;|
            3: WriteNums(TRUE,TRUE,TRUE,TRUE);|
            4: text := NOT text;
               WriteText(text);|
         ELSE
         END;
      END;
   END;
   
   IF stop THEN
      int := 1;      
      REPEAT
         I.MoveScreen(ScP,0,3);
         INC(int);
      UNTIL int = ScP.height DIV 3 + 20;
   ELSE
      IF gewonnen THEN
         int := 1;      
         REPEAT
            I.MoveScreen(ScP,0,-3);
            INC(int);
         UNTIL int = ScP.height DIV 3 + 20;
      END;
      Ausblenden(ScP);
      G.SetAPen(SYSTEM.ADR(ScP.rastPort),0);
      G.RectFill(SYSTEM.ADR(ScP.rastPort),0,0,639,40);
      ReturnKarten(Karten);
      Ablagesize:=0;Talonsize:=0;Hilfsstapelsize:=0;
      WriteNums(FALSE,TRUE,TRUE,TRUE);
      WriteText(text); 
      MaleAnfang;
   END;
   
UNTIL stop

CLOSE

IF (myproc # NIL) AND (myproc.windowPtr # NIL) THEN myproc.windowPtr := oldWinP;END;
IF WinP # NIL THEN I.CloseWindow(WinP);END;
IF ScP # NIL THEN I.CloseScreen(ScP);END;

END Queens.
