MODULE Queenshelp;

IMPORT
      I : Intuition,
      G : Graphics,
      E : Exec,
      ol: OberonLib,
      Requests,
      Backs,
      SYSTEM;

VAR
   HlpScP     : I.ScreenPtr;
   HlpWinP    : I.WindowPtr;

(* ------------------------------------------------------------------ *)

PROCEDURE WaitLeftButton*(VAR WindowZeiger:I.WindowPtr);

VAR
   IMess      : I.IntuiMessage;
   IMessPtr   : I.IntuiMessagePtr;

BEGIN

LOOP
   LOOP
      IMessPtr := E.GetMsg(WindowZeiger.userPort);
      IF IMessPtr # NIL THEN EXIT END;
      E.WaitPort(WindowZeiger.userPort);
   END;

  IMess := IMessPtr^;
  E.ReplyMsg(IMessPtr);
  IF (I.mouseButtons IN IMess.class) AND (IMess.code = I.selectDown) THEN
  EXIT; END;
END;

END WaitLeftButton;

(* ------------------------------------------------------------------ *)

PROCEDURE Openhelp() : BOOLEAN;

VAR
   Nw   : I.NewWindow;
   NSc  : I.NewScreen;
   top8 : G.TextAttr;
   
BEGIN

   IF G.gfx.normalDisplayColumns >= 640 THEN
      NSc.leftEdge := (G.gfx.normalDisplayColumns - 640) DIV 2;
   ELSE NSc.leftEdge := 0;
   END;
   NSc.topEdge      := 0;
   NSc.width        := 640;  NSc.height       := 256;
   NSc.depth        := 1;    NSc.detailPen    := 0;
   NSc.blockPen     := 1;    NSc.viewModes    := {G.hires};
   NSc.type         := I.customScreen;
   NSc.font := NIL;
   NSc.defaultTitle := NIL;
   NSc.gadgets      := NIL;  NSc.customBitMap := NIL;
   INCL(NSc.type,I.screenQuiet);
   INCL(NSc.type,I.screenBehind);
   
   LOOP
      
      HlpScP := I.OpenScreen(NSc);
      IF HlpScP = NIL THEN
         IF NOT Requests.Request("Patience:","Couldn't open help screen !","Retry","Abort")
            THEN EXIT;
         END;
      ELSE
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),0,0,0,0);
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),1,13,13,13);
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),17,13,0,15);
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),18,14,11,11);
            G.SetRGB4(SYSTEM.ADR(HlpScP.viewPort),19,5,5,5);

            Nw.leftEdge      := 0;      Nw.topEdge       := 0;
            Nw.width         := 640;    Nw.height        := 256;
            Nw.detailPen     := 0;      Nw.blockPen      := 1;
            Nw.idcmpFlags    := LONGSET{I.mouseButtons};
            Nw.flags         := LONGSET{I.activate,I.borderless,I.rmbTrap};
            Nw.firstGadget   := NIL;    Nw.checkMark     := NIL;
            Nw.screen        := HlpScP; Nw.bitMap        := NIL;
            Nw.minWidth      := 128;    Nw.minHeight     := 24;
            Nw.maxWidth      := -1;     Nw.maxHeight     := -1;
            Nw.title         := NIL;    Nw.type          := I.customScreen;

         LOOP
            HlpWinP := I.OpenWindow(Nw);
            IF HlpWinP = NIL THEN
               IF NOT Requests.Request("Patience:","Couldn't open help window !","Retry","Abort")
                  THEN I.CloseScreen(HlpScP);EXIT;
               END;
            ELSE
               I.SetPointer(HlpWinP,SYSTEM.VAL(LONGINT,Backs.hand1Data),16,16,0,0);
               top8.name        := SYSTEM.ADR("topaz.font");
               top8.ySize       := 8;
               top8.style       := SHORTSET{};
               top8.flags       := SHORTSET{G.romFont};
               G.SetFont(HlpWinP.rPort,G.OpenFont(SYSTEM.ADR(top8)));
               RETURN TRUE;
            END;
         END;
      END;
      EXIT;
   END;
   RETURN FALSE;

END Openhelp;

(* ------------------------------------------------------------------ *)

PROCEDURE Help*();

VAR int: INTEGER;
    lib: G.BitMapPtr;

PROCEDURE Text(y: INTEGER; s: ARRAY OF CHAR);

BEGIN

  G.Move(HlpWinP.rPort,15,y);
  G.Text(HlpWinP.rPort,s,75);

END Text;

BEGIN

IF Openhelp() THEN

NEW(lib);
IF lib # NIL THEN
   G.InitBitMap(lib^,1,59,30);
   lib.planes[0] := SYSTEM.VAL(LONGINT,Backs.LibertyData);
END;

I.MoveScreen(HlpScP,0,285);
G.SetDrMd(HlpWinP.rPort,G.jam2);

Text(12,"                            CAPRICIOUS  QUEENS                             ");
Text(24,"The aim of this patience game is to complete the card families on the piles");
Text(36,"of the top line.  They start with a king and should end with a queen of the");
Text(48,"same  suit  ( for absolute  beginners - the order to accomplish should be :");
Text(60,"king, ace, two, three, ...  , ten, jack, queen).                           ");
Text(72,"   So,  whereever a king should appear, put him to the top row at once.  On");
Text(84,"the  eight cards in the middle you may build rows of cards of the same suit");
Text(96,"in  descending  order.   If  there  are  queens  among  those  cards in the");
Text(108,"beginning,  they  will be replaced by new cards and put back somewhere into");
Text(120,"the talon.  You can either take the card at the bottom of one of those rows");
Text(132,"and  put  it  on  another row or on the families; or you take the uppermost");
Text(144,"card  and by that move the whole row to another one.  If one of the rows is");
Text(156,"empty,  it  will  be filled with a card of the \"Extra\" pile, or, if that is");
Text(168,"empty,  with a card of the \"Junk\" pile.  If a card from the \"Extra\" pile is");
Text(180,"a queen, five more cards will be moved under the talon.  You should get rid");
Text(192,"of the \"Extra\" pile as fast as possible.                                   ");
Text(204,"   Once  you  can't build anymore, you take card by card from the talon and");
Text(216,"put  it on the middle rows or on the families.  If they don't fit, put them");
Text(228,"on  the  \"Junk\"  pile  (  or  let  them  \"fall\"  to  it by dragging them to");
Text(240,"                             Click for more !                              ");

I.ScreenToFront(HlpScP);
int := 1;
REPEAT
   I.MoveScreen(HlpScP,0,-4);
   INC(int);
UNTIL int = 73;

WaitLeftButton(HlpWinP);

Text(12,"\"nowhere\").  If a card from the talon is a queen, three cards will be taken");
Text(24,"from  under  the \"Junk\" pile and put under the talon.  Don't forget the top");
Text(36,"card  of  the \"Junk\" pile.  You can always take it and put it on the middle");
Text(48,"rows or on the families.                                                   ");
Text(60,"   You can start a new game by pressing the ESC key whenever you want.  But");
Text(72,"don't give up too early.  Even when there are more cards in the \"Junk\" pile");
Text(84,"than  in the talon, there is still a chance to accomplish the patience.  Or");
Text(96,"you might press Q to quit, if you think patience games are tiresome.  Sorry");
Text(108,"for  you...                                                                ");
Text(120,"As  you  might see, it depends a lot on the queens whether you will win the");
Text(132,"patience. I wish yours won't  be too moody.  If this  patience helps you to");
Text(144,"relax,  feel free to send greetings, picture postcards, donations, whatever");
Text(156,"to:                                                                        ");
Text(168,"                                                                           ");
Text(180,"Achim Siebert                                                              ");
Text(192,"Nobileweg 67                                                               ");
Text(204,"7000 Stuttgart 40 , Germany                         1990 by Achim Siebert.");
Text(216,"     No use of any part of the program without my special permission.      ");
Text(228,"        Source in Oberon (thanks to brother dear for the compiler).        ");
Text(240,"                             Click to continue !                           ");

IF (lib # NIL) AND (lib.planes[0] # NIL) THEN
   IF G.BltBitMap(lib,0,0,HlpWinP.rPort.bitMap,291,175,59,30,0C0X,SHORTSET{0..7},0)=0 THEN END;
END;
WaitLeftButton(HlpWinP);
int := 1;
REPEAT
   I.MoveScreen(HlpScP,0,4);
   INC(int);
UNTIL int = 73;

I.ScreenToBack(HlpScP);

I.CloseWindow(HlpWinP);
I.CloseScreen(HlpScP);

END; (* IF Openhelp() ... *)

END Help; 

END Queenshelp.
