(*---------------------------------------------------------------------------
    :Program.    Iconify
    :Author.     Steffen Khler
    :Address.    Grne Str. 1 D-2880 Brake
    :Version.    1.0
    :Date.       06-Nov-90
    :Copyright.  PD
    :Language.   Modula-II
    :Translator. M2Amiga 3.3d
    :Contents.   Stellt eine Iconify- Routine zur Verfgung
    :History.    V1.0 first Version
---------------------------------------------------------------------------*)
IMPLEMENTATION MODULE Iconify;

FROM Arts       IMPORT  Assert,TermProcedure;
FROM SYSTEM     IMPORT  ADR;
FROM Intuition  IMPORT  NewWindow,WindowPtr,
                        IDCMPFlags,IDCMPFlagSet,WindowFlags,WindowFlagSet,
                        OpenWindow,CloseWindow,IntuiMessage,
                        Gadget,GadgetPtr,DrawImage,
                        boolGadget,GadgetFlags,GadgetFlagSet,ActivationFlags,
                        ActivationFlagSet,
                        Image,ImagePtr,ScreenFlags,ScreenFlagSet,
                        DoubleClick;
FROM Exec       IMPORT  GetMsg,ReplyMsg,WaitPort;


VAR
   MyWindowPtr            : WindowPtr ;


PROCEDURE CloseDown;

BEGIN
   IF MyWindowPtr#NIL THEN
      CloseWindow(MyWindowPtr);
   END;
END CloseDown;


PROCEDURE Iconify(VAR x,y : INTEGER;Image:ImagePtr);

VAR
   MyWindow               : NewWindow;
   class                  : IDCMPFlagSet ;
   IntuiMsg               : POINTER TO IntuiMessage ;
   Message                : IntuiMessage;
   MyGadget               : Gadget;
   FirstClick,
   EndFlag                : BOOLEAN;
   LastSecond,
   LastMicro,
   Second,
   Micro                  : LONGINT;

BEGIN
   WITH MyGadget DO
      nextGadget   := NIL;
      leftEdge     := 0;
      topEdge      := 0;
      width        := 0;
      height       := 0;
      flags        := GadgetFlagSet{gRelWidth,gRelHeight} ;
      activation   := ActivationFlagSet{gadgImmediate} ;
      gadgetType   := 32;
      gadgetRender := NIL;
      selectRender := NIL ;
      gadgetText   := NIL;
      gadgetID     := 0;
      userData     := NIL ;
   END ;
  WITH MyWindow DO
       leftEdge      :=  x;
       topEdge       :=  y;
       width         := Image^.width;
       height        := Image^.height;
       minWidth      := Image^.width;
       minHeight     := Image^.height;
       maxWidth      := Image^.width;
       maxHeight     := Image^.height;
       detailPen     := 0;
       blockPen      := 1;
       idcmpFlags    := IDCMPFlagSet{gadgetDown};
       flags         := WindowFlagSet{noCareRefresh,borderless};
       firstGadget   := ADR(MyGadget);
       checkMark     := NIL;
       title         := NIL;
       screen        := NIL;
       bitMap        := NIL;
       type          := ScreenFlagSet{wbenchScreen};
  END;
  MyWindowPtr:=OpenWindow(MyWindow);
  Assert(MyWindowPtr#NIL,ADR("Iconify-Window konnte nicht geffnet werden!"));
  DrawImage(MyWindowPtr^.rPort,Image,0,0);
  EndFlag:=FALSE;
  FirstClick:=TRUE;
  REPEAT
      WaitPort(MyWindowPtr^.userPort);
      IntuiMsg := GetMsg(MyWindowPtr^.userPort) ;
      WHILE IntuiMsg # NIL DO
         Second:=IntuiMsg^.seconds;
         Micro :=IntuiMsg^.micros;
         ReplyMsg(IntuiMsg) ;
         IF NOT FirstClick THEN
            EndFlag:=DoubleClick(LastSecond,LastMicro,Second,Micro);
         ELSE
            FirstClick:=FALSE;
         END;
         IntuiMsg := GetMsg(MyWindowPtr^.userPort) ;
         LastSecond:=Second;
         LastMicro:=Micro;
      END;
   UNTIL EndFlag;
   x:=MyWindowPtr^.leftEdge;
   y:=MyWindowPtr^.topEdge;
   CloseWindow(MyWindowPtr);
   MyWindowPtr:=NIL;
END Iconify;


BEGIN
   TermProcedure(CloseDown);
END Iconify.

