(* ------------------------------------------------------------------------
  :Program.     PowerPacker
  :Contents.    Example for Interface to "powerpacker.library"
  :Author.      Kai Bolay [kai]
  :Address.     Hoffmannstrae 168
  :Address.     D-7250 Leonberg
  :History.     v1.0 [kai] 03-Jan-91 Now it works :-)
  :Copyright.   PD
  :Language.    Oberon
  :Translator.  AMIGA OBERON v1.17.1
------------------------------------------------------------------------ *)

(*********************************
*                                *
*   powerpacker.library  V33.1   *
*                                *
*   Release 1.0                  *
*                                *
*   (c) Jul 1990 Nico Franois   *
*                                *
*   Example.mod                  *
*                                *
*   This source is public domain *
*   in all respects.             *
*                                *
*********************************)

MODULE Example;

IMPORT
   pp: PowerPacker, e: Exec, io;
CONST
   file = "testfile";
VAR
   filestart: e.ADDRESS;
   filelen: LONGINT;
   err: LONGINT;
BEGIN
   filestart := NIL;
   io.WriteString ("Loading file...\n");

   err := pp.LoadData (file, pp.DecrPoint, LONGSET {}, filestart, filelen, NIL);
   IF err # pp.LoadOk THEN
      CASE err OF
      | pp.ReadErr: io.WriteString ("Error loading text file !\n");
      | pp.NoMemory: io.WriteString ("No memory to decrunch file !\n");
      | pp.PassErr: io.WriteString ("Incorrect password, loading aborted !\n");
      | pp.OpenErr: io.WriteString ("Can't open file !\n");
      | pp.UnknownPP: io.WriteString ("Crunched with unknown PP !\n");
      ELSE
         io.WriteString ("Unknown error !\n");
      END; (* CASE *)
   ELSE
      io.WriteString ("file in memory, using it...\n");

      (* file is loaded at 'filestart' and can now be used *)

      (* ... *)

      io.WriteString ("done, freeing file...\n");
   END; (* IF *)
CLOSE
   IF filestart # NIL THEN e.FreeMem (filestart, filelen); filestart := NIL END;

   io.WriteString ("exiting.\n");
END Example.
