(*---------------------------------------------------------------------------
    :Program.    Grabber.mod
    :Author.     Fridtjof Siebert / Volker Rudolph
    :Address.    Nobileweg 67, D-7-Stgt-40
    :Shortcut.   [fbs]
    :Version.    1.1
    :Date.       09-Sep-90
    :Copyright.  PD
    :Language.   Oberon
    :Translator. Oberon V1.16
    :Imports.    IFFLib / Christian A. Weber
    :Contents.   Demonstration for IFFLib. Saves first screen as iff-file.
    :Remark.     You must have iff.library in your LIBS: directory.
    :Remark.     Original Assembler-Version by Christian A. Weber
    :Remark.     Ported to Oberon by Volker Rudolph
    :Usage.      Grabber <Where to save Pic>
---------------------------------------------------------------------------*)

MODULE Grabber;

IMPORT io,ol:OberonLib,s:SYSTEM,a:Arguments,e:Exec,g:Graphics,i:Intuition,
  iff:IFFLib;

VAR
  name: ARRAY 80 OF CHAR;
  f: SET;
  b: BOOLEAN;
  colTab: e.ADDRESS;
  screen: i.ScreenPtr;
BEGIN
  IF ol.wbStarted THEN
    io.WriteString("filename: ");
    io.ReadString(name);
  ELSE
    IF a.NumArgs()=0 THEN
      io.WriteString("Usage: Grabber <filename>\n");
      io.WriteString("  saves first screen to filename.\n");
      HALT(0);
    END;
    a.GetArg(1,name);
  END; (* IF *)
  screen := i.int.firstScreen;
  f := {iff.cmpByteRun1};
  IF g.ham IN screen.viewPort.modes THEN INCL(f,iff.saveHAM) END;
  colTab := screen.viewPort.colorMap.colorTable;
  b := iff.SaveBitMap(name,s.ADR(screen.bitMap),colTab,f);
END Grabber.

