(*
  :Program.       RunTime
  :Author.        Volker Rudolph
  :Address.       Lettow-Vorbeck-Str. 11 / 6750 Kaiserslautern 26
  :Phone.         06301/8566
  :Version.       1.1
  :Date.          28.4.1990
  :Copyright.     Freeware
  :Language.      Oberon
  :Translator.    Amiga-Oberon V1.17.1
  :Imports.       MicroTimer, Printf
  :Contents.      RunTime ermittelt die Ausfhrungsdauer eines Programmes
  :Usage.         RunTime "<program> <arguments>"
*)

MODULE RunTime;

IMPORT ol:OberonLib,a:Arguments,io,d:Dos,s:SYSTEM,
  mi:MicroTimer,p:Printf;

VAR
  arg:ARRAY 80 OF CHAR;
  result:BOOLEAN;
  minutes:INTEGER;
  seconds:INTEGER;
  micros:LONGINT;
  ticks:LONGINT;
BEGIN
  p.writeProc := io.WriteString;
  a.GetArg(1,arg);
  IF (a.NumArgs() = 1) AND ~((arg[1] = '?') AND (arg[2] = 0X)) THEN
    mi.Start;
    result := d.Execute(arg,NIL,io.out);
    mi.Stop(ticks);
    mi.TicksToTime(minutes, seconds, micros, ticks);
    p.Printf3("\[33mRuntime: %ld min %ld sec %03ld msec\[0m\n",minutes,seconds,micros DIV 1000);
  ELSE
    a.GetArg(0,arg);
    p.Printf1('Usage:\n  %s "<program> <arguments>"\n',s.ADR(arg));
  END; (* IF *)
END RunTime.
