(*-------------------------------------------------------------------------
:Program.       FontToOberonDemo.mod
:Contents.      Demo for FontToOberon
:Author.        Christian Stiens
:Address.       Heustiege 2, W-4710 Ldinghausen
:Copyright.     PD
:Language.      Oberon
:Translator.    Amiga Oberon V1.17.1 A+L
:History.       V1.0, 26-Feb-91
:Imports.       Coop24
-------------------------------------------------------------------------*)

MODULE FontToOberonDemo;

  IMPORT
    I : Intuition,
    g : Graphics,
    e : Exec,
    s : SYSTEM,
    Coop24;

  VAR
    win : I.WindowPtr;
    nw  : I.NewWindow;
    rp  : g.RastPortPtr;
    mes : I.IntuiMessage;

  CONST
    closeWindow  = LONGSET{I.closeWindow};
    normalWindow = LONGSET{0..3,10,12};

BEGIN
  nw := I.NewWindow(0,50,640,150,-1,-1,closeWindow,normalWindow,NIL,NIL,
                    s.ADR("FontToOberonDemo"),NIL,NIL,90,40,-1,-1,{0});
  win := I.OpenWindow(nw);
  IF win # NIL THEN
    rp := win.rPort;
    g.SetFont(rp,Coop24.font);
    g.SetAPen(rp,1);
    g.Move(rp,20,30); g.Text(rp,"Dies ist ein Test",17);
    g.Move(rp,20,60); g.Text(rp,"abcdefghijklmnopqrstuvwxyz0123456789",36);
    g.Move(rp,20,90); g.Text(rp,"ABCDEFGHIJKLMNOPQRSTUVWXYZ!$%&/()=?",36);
    e.WaitPort(win.userPort);
    I.CloseWindow(win);
  END;
END FontToOberonDemo.


