 IMPLEMENTATION MODULE Color;


FROM GraphicsD IMPORT
         ViewModes, ViewModeSet, ViewPortPtr;
FROM IntuitionD IMPORT
         customScreen, NewScreen, ScreenPtr;
FROM IntuitionL IMPORT
         CloseScreen, OpenScreen;




PROCEDURE OpenGraphScreen(Modus          : GraphModus;   (*OG*)
                          BitPlanes      : PlaneNumbers;
                          TopPos         : CARDINAL;
                          PALSize        : BOOLEAN) : ScreenPtr;


VAR
      TempScreen     : NewScreen;
      MaxPlanes      : CARDINAL;

BEGIN
   MaxPlanes := 4 ; (* default HiRes, HiresLace *)

   WITH TempScreen DO
      leftEdge  := 0;
      width     := 320;
      IF PALSize THEN
         height := 256;
      ELSE
         height := 200;
      END;
      CASE Modus OF
         LoRes     : viewModes := ViewModeSet{}; INC(MaxPlanes);|
         LoResLace : INC(height,height);
                     viewModes := ViewModeSet{lace}; INC(MaxPlanes);|
         HiRes     : INC(width,width); viewModes := ViewModeSet{hires};
                     INC(height, height);|
         HiResLace : INC(width,width); INC(height,height);
                     viewModes := ViewModeSet{lace,hires};|
         LoResHAM  : viewModes := ViewModeSet{ham}; BitPlanes := 6;
                     INC(MaxPlanes,2);|
         LoResEx   : viewModes := ViewModeSet{extraHalfbrite};
                     BitPlanes := 6; INC(MaxPlanes,2);
      END;

      topEdge   := INTEGER(TopPos) MOD height; (* Darstellung sichern *)

      IF BitPlanes > MaxPlanes THEN
         depth := MaxPlanes
      ELSE
         depth := BitPlanes;
      END;

      detailPen := 0;
      blockPen  := 0;

      type      := customScreen;
      font      := NIL;
      defaultTitle := NIL;
      gadgets   := NIL;
      customBitMap := NIL;
   END;

   RETURN OpenScreen(TempScreen);

END OpenGraphScreen;



END Color.


